(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    539435,      14783]
NotebookOptionsPosition[    530803,      14541]
NotebookOutlinePosition[    531434,      14563]
CellTagsIndexPosition[    531391,      14560]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData["$HistoryLength"], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"$HistoryLength", "=", "1"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.634998029594146*^9, 3.63499803193038*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"$CalculateNew", "=", "0"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6351737999234233`*^9, 3.6351738067801085`*^9}, {
   3.6351750187508855`*^9, 3.6351750187698874`*^9}, {3.6351796824402075`*^9, 
   3.6351796824642105`*^9}, 3.635181930945036*^9, {3.6352220517828503`*^9, 
   3.6352220518388557`*^9}, 3.64783180985252*^9, {3.648466417134878*^9, 
   3.64846641715288*^9}}],

Cell[BoxData[
 RowBox[{"NotebookDirectory", "[", "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6331843319714355`*^9, 3.633184335756814*^9}}],

Cell[CellGroupData[{

Cell["Data import static exposure (scenarios E - L)", "Chapter",
 CellChangeTimes->{{3.6345317059390807`*^9, 3.6345317232918158`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
      "\"\<\\\\input/LC50 Survival - Carbendazim - Gpulex.txt\>\""}], ",", 
     "\"\<Table\>\""}], "]"}]}], ";", 
  RowBox[{"data", "//", "TableForm"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6331843103662753`*^9, 3.63318436701394*^9}, {
   3.63318448482872*^9, 3.6331844851337504`*^9}, 3.6331886244616413`*^9, 
   3.6345318030257883`*^9, {3.634531883220807*^9, 3.634531883628848*^9}, {
   3.6345319563361177`*^9, 3.6345319660230865`*^9}, {3.634541227545355*^9, 
   3.6345412497773547`*^9}, 3.635175022879298*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"expData", "=", 
    RowBox[{
     RowBox[{
      RowBox[{"Import", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
         "\"\<\\\\input/Cw - Carbendazim - \>\"", "<>", "#", "<>", 
         "\"\<.txt\>\""}], ",", "\"\<Table\>\""}], "]"}], "&"}], "/@", 
     RowBox[{"{", 
      RowBox[{
      "\"\<E\>\"", ",", "\"\<F\>\"", ",", "\"\<G\>\"", ",", "\"\<H\>\"", ",", 
       "\"\<I\>\"", ",", "\"\<J\>\"", ",", "\"\<K\>\"", ",", "\"\<L\>\""}], 
      "}"}]}]}], ";", 
   RowBox[{"expData", "//", "TableForm"}]}], "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.633184508071044*^9, 3.633184530813318*^9}, {
   3.633184601384374*^9, 3.6331846698522205`*^9}, {3.6331847147507095`*^9, 
   3.633184718238058*^9}, 3.633188638758071*^9, 3.6345318067221584`*^9, {
   3.6345318863821235`*^9, 3.6345319230357885`*^9}, {3.6345319722177057`*^9, 
   3.6345319723767223`*^9}, {3.6345412444763546`*^9, 3.634541246616355*^9}, 
   3.635175025657576*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Data preparation and parameter fit", "Chapter",
 CellChangeTimes->{{3.634531759708457*^9, 3.6345317745249386`*^9}, {
  3.634533924897973*^9, 3.634533929681452*^9}, {3.63453401937442*^9, 
  3.6345340301114936`*^9}}],

Cell[CellGroupData[{

Cell["Preparation of data set", "Subchapter",
 CellChangeTimes->{3.6345340321666994`*^9}],

Cell[TextData[{
 StyleBox["\[LineSeparator]",
  FontWeight->"Bold"],
 StyleBox["Convention: data matrix structure for optimisation\n",
  FontSize->12,
  FontWeight->"Bold"],
 StyleBox["1. absolute day numbers (Length = number of sampling days incl. \
day 0)\n2. initial abundances (Length = number of treatments incl control)\n\
3. concentrations (incl control)\n4. relative survival  control\n5. relative \
survival treatment 1\n.\n.\nk+4. relative survival treatment k\nk+5. \
Functions giving time course of water concentrations (can be constant)",
  FontSize->12]
}], "Subsubtitle",
 CellChangeTimes->{{3.587734059105467*^9, 3.587734186543501*^9}, {
   3.587735012824694*^9, 3.5877350384246225`*^9}, {3.587743287239338*^9, 
   3.587743289828971*^9}, {3.587798928784072*^9, 3.5877989298760576`*^9}, {
   3.5879651884708996`*^9, 3.587965202979086*^9}, {3.587976756094768*^9, 
   3.5879767569908576`*^9}, 3.6333476066029434`*^9, {3.6345394655349817`*^9, 
   3.634539471831611*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"tvefunc", "[", 
    RowBox[{"t_", ",", "dur_", ",", "conc_"}], "]"}], ":=", 
   RowBox[{"Piecewise", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"conc", ",", 
         RowBox[{"t", "<", "dur"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"t", "\[GreaterEqual]", "dur"}]}], "}"}]}], "}"}], ",", 
     "0"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SOT$data$days", "=", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "2", ",", "3", ",", "4"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"noTreats", "=", 
   RowBox[{
    RowBox[{"Length", "[", 
     RowBox[{"data", "[", 
      RowBox[{"[", "2", "]"}], "]"}], "]"}], "-", "1"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$data$initAbundance", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"data", "[", 
      RowBox[{"[", 
       RowBox[{"2", ",", "i"}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "2", ",", 
       RowBox[{"noTreats", "+", "1"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$conc", "=", 
   RowBox[{"Reverse", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"expData", "[", 
       RowBox[{"[", 
        RowBox[{"i", ",", "2", ",", "2"}], "]"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "noTreats"}], "}"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$treatments", "=", 
   RowBox[{"Reverse", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"N", "@", 
       RowBox[{"(", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Drop", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Transpose", "[", "data", "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"#", "+", "1"}], "]"}], "]"}], ",", "1"}], "]"}], "/", 
          RowBox[{"SOT$data$initAbundance", "[", 
           RowBox[{"[", "#", "]"}], "]"}]}], ")"}], ")"}]}], "&"}], "/@", 
     RowBox[{"Range", "[", "noTreats", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$CWs", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"tvefunc", "[", 
      RowBox[{"t", ",", "4", ",", "#"}], "]"}], "&"}], "/@", "SOT$conc"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$data$CAR", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", "SOT$data$days", "}"}], ",", 
     RowBox[{"{", "SOT$data$initAbundance", "}"}], ",", 
     RowBox[{"{", "SOT$conc", "}"}], ",", "SOT$treatments", ",", 
     RowBox[{"{", "SOT$CWs", "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{"TableForm", "[", 
  RowBox[{
   RowBox[{"SOT$data$CAR", "[", 
    RowBox[{"[", 
     RowBox[{"4", ";;", "11"}], "]"}], "]"}], ",", 
   RowBox[{"TableHeadings", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"SOT$data$CAR", "[", 
       RowBox[{"[", "3", "]"}], "]"}], ",", 
      RowBox[{"SOT$data$CAR", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}]}], "]"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.587962474616413*^9, 3.587962540355656*^9}, {
   3.5879625828662014`*^9, 3.587962588154669*^9}, {3.58796424624802*^9, 
   3.587964257885769*^9}, {3.5879649232820997`*^9, 3.587964968382278*^9}, {
   3.6331848191071444`*^9, 3.633184866388872*^9}, {3.6331849254007726`*^9, 
   3.633185021652397*^9}, 3.635175037035714*^9, {3.6356466949009643`*^9, 
   3.635646694916564*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Fit of background mortality rate constant to control survival\
\>", "Subchapter",
 CellChangeTimes->{{3.6345320852461395`*^9, 3.634532087869877*^9}, {
   3.634532155963067*^9, 3.6345321637052927`*^9}, {3.634532627463576*^9, 
   3.634532630911576*^9}, 3.634534681970673*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"$CalculateNew", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"res", "=", 
      RowBox[{"NMinimize", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"goalFunc$Control", "[", 
           RowBox[{"SOT$data$CAR", ",", "SDmodel", ",", 
            RowBox[{"tEnd", "=", "4"}], ",", "p1", ",", "1"}], "]"}], ",", 
          RowBox[{"p1", ">", "0"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"p1", ",", "0.001", ",", "0.002"}], "}"}]}], "]"}]}], ";", 
     RowBox[{"opt$Haz$BG$B", "=", 
      RowBox[{"p1", "/.", 
       RowBox[{"res", "[", 
        RowBox[{"[", "2", "]"}], "]"}]}]}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"opt$Haz$BG$B", "=", "0.056352933607966275`"}]}], 
   "\[IndentingNewLine]", "]"}], ";", "opt$Haz$BG$B"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.633185857950018*^9, 3.6331858608543086`*^9}, 
   3.6331886764478397`*^9, {3.63453207133853*^9, 3.634532076467017*^9}, {
   3.635173817428173*^9, 3.635173912051635*^9}, {3.635175229642973*^9, 
   3.6351752369617043`*^9}, 3.635646694932164*^9, {3.63565483908751*^9, 
   3.6356548419891157`*^9}, {3.635656176944061*^9, 3.635656183964073*^9}, {
   3.648198988425523*^9, 3.6481989892679443`*^9}, {3.6484664252646914`*^9, 
   3.6484664253456993`*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["SD model", "Title",
 CellChangeTimes->{{3.6345345050989876`*^9, 3.6345345062190995`*^9}}],

Cell[CellGroupData[{

Cell["Parameter optimisation for the SD model", "Subchapter",
 CellChangeTimes->{{3.6345326070325756`*^9, 3.634532613135576*^9}, {
  3.634534439743453*^9, 3.6345344450799866`*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{3.648205948808729*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"$CalculateNew", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"gmonix", "=", "1"}], ";", "\[IndentingNewLine]", 
     RowBox[{"globResMonDat", "=", 
      RowBox[{"Table", "[", 
       RowBox[{"\"\<\>\"", ",", 
        RowBox[{"{", "100000", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"startSD", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"p1", "\[Rule]", "0.5"}], ",", 
        RowBox[{"p2", "\[Rule]", "0.025"}], ",", 
        RowBox[{"p3", "\[Rule]", "200"}]}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"monArr", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"globC", "=", "0"}], ";", "\[IndentingNewLine]", 
     RowBox[{"startInt", "=", "5"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Monitor", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"resSD$B", "=", 
        RowBox[{"NMinimize", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"goalFunc$treatments", "[", " ", 
             RowBox[{
             "SOT$data$CAR", ",", "SDmodel", ",", "0", ",", "p1", ",", "p2", 
              ",", "p3", ",", "opt$Haz$BG$B", ",", 
              RowBox[{"tEnd", "=", "4"}]}], "]"}], ",", 
            RowBox[{
             RowBox[{"p1", ">", "0"}], "&&", 
             RowBox[{"p2", ">", "0"}], "&&", 
             RowBox[{"p3", ">", "0"}]}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"p1", ",", 
              RowBox[{
               RowBox[{"1", "/", "startInt"}], "*", 
               RowBox[{"(", 
                RowBox[{"p1", "/.", "startSD"}], ")"}]}], ",", 
              RowBox[{"startInt", "*", 
               RowBox[{"(", 
                RowBox[{"p1", "/.", "startSD"}], ")"}]}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"p2", ",", 
              RowBox[{
               RowBox[{"1", "/", "startInt"}], "*", 
               RowBox[{"(", 
                RowBox[{"p2", "/.", "startSD"}], ")"}]}], ",", 
              RowBox[{"startInt", "*", 
               RowBox[{"(", 
                RowBox[{"p2", "/.", "startSD"}], ")"}]}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"p3", ",", 
              RowBox[{
               RowBox[{"1", "/", "startInt"}], "*", 
               RowBox[{"(", 
                RowBox[{"p3", "/.", "startSD"}], ")"}]}], ",", 
              RowBox[{"startInt", "*", 
               RowBox[{"(", 
                RowBox[{"p3", "/.", "startSD"}], ")"}]}]}], "}"}]}], "}"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"Method", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"\"\<SimulatedAnnealing\>\"", ",", 
             RowBox[{"\"\<PerturbationScale\>\"", "\[Rule]", "3"}], ",", 
             RowBox[{"\"\<SearchPoints\>\"", "\[Rule]", "50"}]}], "}"}]}], 
          ",", 
          RowBox[{"EvaluationMonitor", "\[RuleDelayed]", " ", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"globResMonDat", "[", 
              RowBox[{"[", 
               RowBox[{"gmonix", "++"}], "]"}], "]"}], "=", "resMonDat"}], 
            "}"}]}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"MaxIterations", "\[Rule]", "15"}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", "resMon"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"startInt", "=", "3"}], ";", "\[IndentingNewLine]", 
     RowBox[{"startSD", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"p1", "\[Rule]", 
         RowBox[{"(", 
          RowBox[{"p1", "/.", 
           RowBox[{"resSD$B", "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], ")"}]}], ",", 
        RowBox[{"p2", "\[Rule]", 
         RowBox[{"(", 
          RowBox[{"p2", "/.", 
           RowBox[{"resSD$B", "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], ")"}]}], ",", 
        RowBox[{"p3", "\[Rule]", 
         RowBox[{"Max", "[", 
          RowBox[{"0.001", ",", 
           RowBox[{"(", 
            RowBox[{"p3", "/.", 
             RowBox[{"resSD$B", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}], ")"}]}], "]"}]}]}], "}"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", "resSD$B", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Monitor", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"resSD$B", "=", 
        RowBox[{"NMinimize", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"goalFunc$treatments", "[", " ", 
             RowBox[{
             "SOT$data$CAR", ",", "SDmodel", ",", "0", ",", "p1", ",", "p2", 
              ",", "p3", ",", "opt$Haz$BG$B", ",", 
              RowBox[{"tEnd", "=", "4"}]}], "]"}], ",", 
            RowBox[{
             RowBox[{"p1", ">", "0"}], "&&", 
             RowBox[{"p2", ">", "0"}], "&&", 
             RowBox[{"p3", ">", "0"}]}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"p1", ",", 
              RowBox[{
               RowBox[{"1", "/", "startInt"}], "*", 
               RowBox[{"(", 
                RowBox[{"p1", "/.", "startSD"}], ")"}]}], ",", 
              RowBox[{"startInt", "*", 
               RowBox[{"(", 
                RowBox[{"p1", "/.", "startSD"}], ")"}]}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"p2", ",", 
              RowBox[{
               RowBox[{"1", "/", "startInt"}], "*", 
               RowBox[{"(", 
                RowBox[{"p2", "/.", "startSD"}], ")"}]}], ",", 
              RowBox[{"startInt", "*", 
               RowBox[{"(", 
                RowBox[{"p2", "/.", "startSD"}], ")"}]}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"p3", ",", 
              RowBox[{
               RowBox[{"1", "/", "startInt"}], "*", 
               RowBox[{"(", 
                RowBox[{"p3", "/.", "startSD"}], ")"}]}], ",", 
              RowBox[{"startInt", "*", 
               RowBox[{"(", 
                RowBox[{"p3", "/.", "startSD"}], ")"}]}]}], "}"}]}], "}"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"Method", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"\"\<SimulatedAnnealing\>\"", ",", 
             RowBox[{"\"\<PerturbationScale\>\"", "\[Rule]", "3"}], ",", 
             RowBox[{"\"\<SearchPoints\>\"", "\[Rule]", "50"}]}], "}"}]}], 
          ",", 
          RowBox[{"EvaluationMonitor", "\[RuleDelayed]", " ", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"globResMonDat", "[", 
              RowBox[{"[", 
               RowBox[{"gmonix", "++"}], "]"}], "]"}], "=", "resMonDat"}], 
            "}"}]}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "5"}], ",", 
          RowBox[{"MaxIterations", "\[Rule]", "15"}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", "resMon"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"startInt", "=", "2"}], ";", "\[IndentingNewLine]", 
     RowBox[{"startSD", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"p1", "\[Rule]", 
         RowBox[{"(", 
          RowBox[{"p1", "/.", 
           RowBox[{"resSD$B", "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], ")"}]}], ",", 
        RowBox[{"p2", "\[Rule]", 
         RowBox[{"(", 
          RowBox[{"p2", "/.", 
           RowBox[{"resSD$B", "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], ")"}]}], ",", 
        RowBox[{"p3", "\[Rule]", 
         RowBox[{"Max", "[", 
          RowBox[{"0.001", ",", 
           RowBox[{"(", 
            RowBox[{"p3", "/.", 
             RowBox[{"resSD$B", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}], ")"}]}], "]"}]}]}], "}"}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", "resSD$B", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Monitor", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"resSD$B", "=", 
        RowBox[{"NMinimize", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"goalFunc$treatments", "[", " ", 
             RowBox[{
             "SOT$data$CAR", ",", "SDmodel", ",", "0", ",", "p1", ",", "p2", 
              ",", "p3", ",", "opt$Haz$BG$B", ",", 
              RowBox[{"tEnd", "=", "4"}]}], "]"}], ",", 
            RowBox[{
             RowBox[{"p1", ">", "0"}], "&&", 
             RowBox[{"p2", ">", "0"}], "&&", 
             RowBox[{"p3", ">", "0"}]}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"p1", ",", 
              RowBox[{
               RowBox[{"1", "/", "startInt"}], "*", 
               RowBox[{"(", 
                RowBox[{"p1", "/.", "startSD"}], ")"}]}], ",", 
              RowBox[{"startInt", "*", 
               RowBox[{"(", 
                RowBox[{"p1", "/.", "startSD"}], ")"}]}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"p2", ",", 
              RowBox[{
               RowBox[{"1", "/", "startInt"}], "*", 
               RowBox[{"(", 
                RowBox[{"p2", "/.", "startSD"}], ")"}]}], ",", 
              RowBox[{"startInt", "*", 
               RowBox[{"(", 
                RowBox[{"p2", "/.", "startSD"}], ")"}]}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"p3", ",", 
              RowBox[{
               RowBox[{"1", "/", "startInt"}], "*", 
               RowBox[{"(", 
                RowBox[{"p3", "/.", "startSD"}], ")"}]}], ",", 
              RowBox[{"startInt", "*", 
               RowBox[{"(", 
                RowBox[{"p3", "/.", "startSD"}], ")"}]}]}], "}"}]}], "}"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"Method", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"\"\<SimulatedAnnealing\>\"", ",", 
             RowBox[{"\"\<PerturbationScale\>\"", "\[Rule]", "3"}], ",", 
             RowBox[{"\"\<SearchPoints\>\"", "\[Rule]", "50"}]}], "}"}]}], 
          ",", 
          RowBox[{"EvaluationMonitor", "\[RuleDelayed]", " ", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"globResMonDat", "[", 
              RowBox[{"[", 
               RowBox[{"gmonix", "++"}], "]"}], "]"}], "=", "resMonDat"}], 
            "}"}]}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "6"}], ",", 
          RowBox[{"MaxIterations", "\[Rule]", "15"}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", "resMon"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", "resSD$B", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"SRTSD", "=", 
      RowBox[{"Sort", "[", 
       RowBox[{
        RowBox[{"globResMonDat", "[", 
         RowBox[{"[", 
          RowBox[{"1", ";;", 
           RowBox[{"gmonix", "-", "1"}]}], "]"}], "]"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"#1", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "<", 
          RowBox[{"#2", "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], "&"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Export", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
        "\"\</runSD-Trace-new.xlsx\>\""}], ",", "SRTSD"}], "]"}]}], ",", 
    "\[IndentingNewLine]", "0"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.6331862371279325`*^9, 3.6331862382570453`*^9}, {
   3.6331862688351026`*^9, 3.6331862794821672`*^9}, {3.633186312381457*^9, 
   3.633186333188537*^9}, {3.633186400529271*^9, 3.633186463889606*^9}, {
   3.6331865029575124`*^9, 3.6331865046956863`*^9}, {3.6331888251157055`*^9, 
   3.633188875209714*^9}, {3.6331889094871416`*^9, 3.6331889330514975`*^9}, {
   3.6331892065568457`*^9, 3.633189231627352*^9}, {3.634532981096603*^9, 
   3.6345330004155345`*^9}, 3.634533662392726*^9, {3.6345340508195643`*^9, 
   3.634534051149597*^9}, {3.6349992660547795`*^9, 3.634999278712045*^9}, {
   3.635173924313861*^9, 3.635173958976327*^9}, {3.635175360900097*^9, 
   3.635175361060113*^9}, {3.635646694932164*^9, 3.6356466949477644`*^9}, {
   3.6478322694868097`*^9, 3.6478322873658323`*^9}, 3.647913925034986*^9, {
   3.6481996345107527`*^9, 3.6481996720044374`*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\</runSD-Trace-new.csv\>\""}], ",", "SRTSD"}], "]"}]], "Input",
 CellChangeTimes->{{3.64820126925838*^9, 3.64820126951438*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SRTSD", "=", 
   RowBox[{
    RowBox[{"Import", "[", 
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
      "\"\</runSD-Trace-new.xlsx\>\""}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{
  3.6345337066841545`*^9, {3.64783227946038*^9, 3.64783228033643*^9}, {
   3.6482012762263803`*^9, 3.64820128603338*^9}, {3.64820133555938*^9, 
   3.6482013380383797`*^9}}],

Cell[BoxData[
 RowBox[{"SRTSD", "[", 
  RowBox[{"[", "1", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.64820096606538*^9, 3.64820096832338*^9}}],

Cell[BoxData[
 RowBox[{"NumberForm", "[", 
  RowBox[{
   RowBox[{"SRTSD", "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "50"}], "]"}]], "Input",
 CellChangeTimes->{{3.64820134176138*^9, 3.64820141197738*^9}}],

Cell[BoxData[{
 RowBox[{"optParSD$CAR$AF", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"SRTSD", "[", 
     RowBox[{"[", 
      RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"p1", "\[Rule]", 
       RowBox[{"SRTSD", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "2"}], "]"}], "]"}]}], ",", 
      RowBox[{"p2", "\[Rule]", 
       RowBox[{"SRTSD", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "3"}], "]"}], "]"}]}], ",", 
      RowBox[{"p3", "\[Rule]", 
       RowBox[{"SRTSD", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "4"}], "]"}], "]"}]}]}], "}"}]}], 
   "}"}]}], "\[IndentingNewLine]", 
 RowBox[{"optErrSD", "=", 
  RowBox[{"SRTSD", "[", 
   RowBox[{"[", 
    RowBox[{"1", ",", "1"}], "]"}], "]"}]}]}], "Input",
 CellChangeTimes->{
  3.634533279043394*^9, {3.634533707981284*^9, 3.634533717315217*^9}, 
   3.6356546017050934`*^9, {3.6356546779064274`*^9, 3.635654723599908*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Calibration figures output", "Subchapter",
 CellChangeTimes->{{3.648783827681327*^9, 3.6487838324861884`*^9}}],

Cell[BoxData[{
 RowBox[{"fig", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"ShowResultScenarios", "[", 
     RowBox[{
     "SOT$data$CAR", ",", "SDmodel", ",", "opt$Haz$BG$B", ",", 
      "optParSD$CAR$AF", ",", 
      RowBox[{"tEnd", "=", "4"}], ",", "1", ",", "\"\<N\>\"", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"MarkersScaledCol2", "[", 
         RowBox[{"Red", ",", 
          RowBox[{"lighter", "=", "0"}], ",", 
          RowBox[{"thick", "=", "0.045"}], ",", 
          RowBox[{"filled", "=", "1"}], ",", 
          RowBox[{"size", "=", "0.035"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"Black", ",", 
          RowBox[{"Thickness", "[", "0.005", "]"}]}], "}"}], ",", 
        "\"\<Acute toxicity test\>\""}], "}"}]}], "]"}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"FontSize", "\[Rule]", "63"}], "}"}]}], ",", 
    RowBox[{"GridLines", "\[Rule]", "Automatic"}], ",", 
    RowBox[{"GridLinesStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Directive", "[", 
        RowBox[{"Black", ",", 
         RowBox[{"Thickness", "[", "0.001", "]"}], ",", "Dotted"}], "]"}], 
       ",", 
       RowBox[{"Directive", "[", 
        RowBox[{"Black", ",", "Dashed", ",", 
         RowBox[{"Thickness", "[", "0.001", "]"}]}], "]"}]}], "}"}]}], ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"Directive", "[", "Black", "]"}]}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{"Black", ",", 
       RowBox[{"Thickness", "[", "0.002", "]"}]}], "]"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "1800"}]}], "]"}]}], "\n", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\</CBZ-SD-acuteTox(calibration)-figA.gif\>\""}], ",", "fig"}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.6424180755492077`*^9, 3.642418081166529*^9}, {
  3.648374744054177*^9, 3.648374752557027*^9}, {3.6483749731070795`*^9, 
  3.6483749876025295`*^9}, {3.6483750999057584`*^9, 3.6483751422699947`*^9}, {
  3.6483758109508557`*^9, 3.6483758144442053`*^9}, {3.648376134963254*^9, 
  3.6483761391036677`*^9}, {3.6484664568618507`*^9, 3.648466498877052*^9}}],

Cell[BoxData[
 RowBox[{"fig", "=", 
  RowBox[{"TableForm", "[", 
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{"ShowResultScenarios", "[", 
      RowBox[{
      "SOT$data$CAR", ",", "SDmodel", ",", "opt$Haz$BG$B", ",", 
       "optParSD$CAR$AF", ",", 
       RowBox[{"tEnd", "=", "4"}], ",", "1", ",", "\"\<N\>\"", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"MarkersScaledCol2", "[", 
          RowBox[{"Red", ",", 
           RowBox[{"lighter", "=", "0"}], ",", 
           RowBox[{"thick", "=", "0.045"}], ",", 
           RowBox[{"filled", "=", "1"}], ",", 
           RowBox[{"size", "=", "0.035"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"Black", ",", 
           RowBox[{"Thickness", "[", "0.005", "]"}]}], "}"}], ",", 
         "\"\<\>\""}], "}"}], ",", "40"}], "]"}], ",", "4"}], "]"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{
  3.6356466949477644`*^9, 3.6356546951288576`*^9, {3.638971900935335*^9, 
   3.638971901898432*^9}, {3.642418183214366*^9, 3.6424181868435736`*^9}, {
   3.6483751546382313`*^9, 3.6483752405908256`*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\</CBZ-SD-acuteTox(calibration)-figB.gif\>\""}], ",", "fig"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.63896179058996*^9, 3.638961795806482*^9}, {
  3.6389618476816688`*^9, 3.638961848023703*^9}, {3.638961999300829*^9, 
  3.638962000267926*^9}, {3.6389719654357843`*^9, 3.638971967683009*^9}, {
  3.638972154870726*^9, 3.6389721553327723`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"expData", "=", 
   RowBox[{"createModelTimeSeries1M", "[", 
    RowBox[{"SDmodel", " ", ",", "SOT$data$CAR", ",", "opt$Haz$BG$B", ",", 
     RowBox[{"{", 
      RowBox[{"optParSD$CAR$AF", "[", 
       RowBox[{"[", "2", "]"}], "]"}], "}"}], ",", "tEnd", ",", "1", ",", 
     "0.1"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6389615929151945`*^9, 3.638961604491352*^9}, {
  3.6389616479086933`*^9, 3.63896168718062*^9}, {3.638961907289629*^9, 
  3.638961912889189*^9}, {3.6389621547733746`*^9, 3.638962155669464*^9}, {
  3.6389719737176127`*^9, 3.6389719940186424`*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\</CBZ-SD-acuteTox(calibration).xlsx\>\""}], ",", "expData"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.638961690568959*^9, 3.638961782839185*^9}, {
   3.6389621606569633`*^9, 3.6389621615670543`*^9}, {3.6389720002422647`*^9, 
   3.6389720039396343`*^9}, 3.648783843936735*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Profiling parameter confidence", "Subchapter",
 CellChangeTimes->{{3.634532442481576*^9, 3.634532445929576*^9}, {
  3.647831785519128*^9, 3.6478317906964245`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"$CalculateNew", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"prof", "=", 
      RowBox[{"SOT$LRParamConfidence", "[", 
       RowBox[{
       "optParSD$CAR$AF", ",", "SDmodel", ",", "opt$Haz$BG$B", ",", 
        "SOT$data$CAR", ",", 
        RowBox[{"tEnd", "=", "4"}], ",", "0.05", ",", 
        RowBox[{"confLim", "=", 
         RowBox[{
          RowBox[{"InvChiSquare", "[", 
           RowBox[{"1", ",", "0.95"}], "]"}], "/", "2"}]}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Export", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
        "\"\</runSD-LL-prof-new.xlsx\>\""}], ",", "prof"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Export", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
        "\"\</runSD-LL-prof-allTraces-new.csv\>\""}], ",", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"totalProfile", "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", 
         RowBox[{"totalProfile", "[", 
          RowBox[{"[", "2", "]"}], "]"}], ",", 
         RowBox[{"totalProfile", "[", 
          RowBox[{"[", "3", "]"}], "]"}]}], "]"}]}], "]"}]}], ",", 
    "\[IndentingNewLine]", "0"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.6476958827098446`*^9, 3.647695912293537*^9}, {
   3.6476979575780196`*^9, 3.6476979606200247`*^9}, 3.6476983540985174`*^9, {
   3.647704880728368*^9, 3.6477048811833935`*^9}, {3.6477050072879534`*^9, 
   3.6477050073503537`*^9}, {3.647828542473553*^9, 3.6478285433939548`*^9}, 
   3.6478311725727806`*^9, {3.6478318002379704`*^9, 3.647831802435096*^9}, {
   3.6478324127320027`*^9, 3.647832427949873*^9}, {3.647882903184417*^9, 
   3.6478829033024287`*^9}, {3.648205707821633*^9, 3.6482057090267534`*^9}, 
   3.64820582390624*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"$CalculateNew", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"prof", "=", 
      RowBox[{"SOT$LRParamConfidence", "[", 
       RowBox[{
       "optParSD$CAR$AF", ",", "SDmodel", ",", "opt$Haz$BG$B", ",", 
        "SOT$data$CAR", ",", 
        RowBox[{"tEnd", "=", "4"}], ",", "0.25", ",", 
        RowBox[{"confLim", "=", 
         RowBox[{
          RowBox[{"InvChiSquare", "[", 
           RowBox[{"3", ",", "0.95"}], "]"}], "/", "2"}]}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Export", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
        "\"\</runSD-LL-prof-new-2.xlsx\>\""}], ",", "prof"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Export", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
        "\"\</runSD-LL-prof-allTraces-new-2.csv\>\""}], ",", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"totalProfile", "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", 
         RowBox[{"totalProfile", "[", 
          RowBox[{"[", "2", "]"}], "]"}], ",", 
         RowBox[{"totalProfile", "[", 
          RowBox[{"[", "3", "]"}], "]"}]}], "]"}]}], "]"}]}], ",", 
    "\[IndentingNewLine]", "0"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.6476958827098446`*^9, 3.647695912293537*^9}, {
   3.6476979575780196`*^9, 3.6476979606200247`*^9}, 3.6476983540985174`*^9, {
   3.647704880728368*^9, 3.6477048811833935`*^9}, {3.6477050072879534`*^9, 
   3.6477050073503537`*^9}, {3.6477377121451235`*^9, 3.647737728681153*^9}, {
   3.647828555532776*^9, 3.647828556063177*^9}, 3.6478311741795835`*^9, 
   3.6478317988568907`*^9, {3.647832409457815*^9, 3.6478324294639597`*^9}, {
   3.647882905998698*^9, 3.647882906086707*^9}, {3.648202641531025*^9, 
   3.648202641643036*^9}, {3.648205836954545*^9, 3.648205840041854*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Import of profiling data", "Subchapter",
 CellChangeTimes->{{3.634532442481576*^9, 3.634532445929576*^9}}],

Cell[BoxData[
 RowBox[{"confLim", "=", 
  RowBox[{
   RowBox[{"InvChiSquare", "[", 
    RowBox[{"3", ",", "0.95"}], "]"}], "/", "2"}]}]], "Input",
 CellChangeTimes->{{3.6333331996682525`*^9, 3.633333210476333*^9}, {
   3.633333416312915*^9, 3.6333334167989635`*^9}, {3.63453407757924*^9, 
   3.634534077772259*^9}, 3.634559825858969*^9, {3.6345638444815645`*^9, 
   3.6345638452125645`*^9}, {3.635174366239049*^9, 3.6351743936937943`*^9}, {
   3.63522404977763*^9, 3.635224050906742*^9}, {3.647829601274823*^9, 
   3.647829611555241*^9}, {3.647829736268861*^9, 3.647829741947271*^9}, {
   3.647829875147305*^9, 3.647829908205763*^9}, 3.6482073267225113`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SRT", "=", 
   RowBox[{
    RowBox[{"Import", "[", 
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
      "\"\</runSD-Trace-new.xlsx\>\""}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SRTSD", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"Transpose", "[", "SRT", "]"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}], ",", 
      RowBox[{
       RowBox[{"Transpose", "[", "SRT", "]"}], "[", 
       RowBox[{"[", "2", "]"}], "]"}], ",", 
      RowBox[{
       RowBox[{"Transpose", "[", "SRT", "]"}], "[", 
       RowBox[{"[", "3", "]"}], "]"}], ",", 
      RowBox[{
       RowBox[{"Transpose", "[", "SRT", "]"}], "[", 
       RowBox[{"[", "4", "]"}], "]"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Transpose", "[", "SRT", "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}], "-", "optErrSD"}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"optParSD$CAR$AF", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"SRTSD", "[", 
     RowBox[{"[", 
      RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"p1", "\[Rule]", 
       RowBox[{"SRTSD", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "2"}], "]"}], "]"}]}], ",", 
      RowBox[{"p2", "\[Rule]", 
       RowBox[{"SRTSD", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "3"}], "]"}], "]"}]}], ",", 
      RowBox[{"p3", "\[Rule]", 
       RowBox[{"SRTSD", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "4"}], "]"}], "]"}]}]}], "}"}]}], 
   "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"optErrSD", "=", 
   RowBox[{"SRTSD", "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "1"}], "]"}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SRTextSig", "=", 
   RowBox[{"Select", "[", 
    RowBox[{"SRTSD", ",", 
     RowBox[{
      RowBox[{
       RowBox[{"#", "[", 
        RowBox[{"[", "5", "]"}], "]"}], "<=", "confLim"}], "&"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SRTextNS", "=", 
    RowBox[{"Select", "[", 
     RowBox[{"SRTSD", ",", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "5", "]"}], "]"}], ">", "confLim"}], "&"}]}], "]"}]}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LRAdatatmp", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
     "\"\</runSD-LL-prof-allTraces-new-2.csv\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LRAdata", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"Transpose", "[", "LRAdatatmp", "]"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}], ",", 
      RowBox[{
       RowBox[{"Transpose", "[", "LRAdatatmp", "]"}], "[", 
       RowBox[{"[", "2", "]"}], "]"}], ",", 
      RowBox[{
       RowBox[{"Transpose", "[", "LRAdatatmp", "]"}], "[", 
       RowBox[{"[", "3", "]"}], "]"}], ",", 
      RowBox[{
       RowBox[{"Transpose", "[", "LRAdatatmp", "]"}], "[", 
       RowBox[{"[", "4", "]"}], "]"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Transpose", "[", "LRAdatatmp", "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}], "-", "optErrSD"}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LRATextSig", "=", 
   RowBox[{"Select", "[", 
    RowBox[{"LRAdata", ",", 
     RowBox[{
      RowBox[{
       RowBox[{"#", "[", 
        RowBox[{"[", "5", "]"}], "]"}], "<=", "confLim"}], "&"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LRATextNS", "=", 
    RowBox[{"Select", "[", 
     RowBox[{"LRAdata", ",", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "5", "]"}], "]"}], ">", "confLim"}], "&"}]}], "]"}]}], 
   ";"}], "\n"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"lprofData", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
     "\"\</runSD-LL-prof-new-2.xlsx\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LRdata", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"lprofData", "[", 
      RowBox[{"[", "1", "]"}], "]"}], ",", 
     RowBox[{"lprofData", "[", 
      RowBox[{"[", "2", "]"}], "]"}], ",", 
     RowBox[{"lprofData", "[", 
      RowBox[{"[", "3", "]"}], "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LRTextSig", "=", 
   RowBox[{"Select", "[", 
    RowBox[{"LRdata", ",", 
     RowBox[{
      RowBox[{
       RowBox[{"#", "[", 
        RowBox[{"[", "5", "]"}], "]"}], "<=", "confLim"}], "&"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LRTextNS", "=", 
    RowBox[{"Select", "[", 
     RowBox[{"LRdata", ",", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "5", "]"}], "]"}], ">", "confLim"}], "&"}]}], "]"}]}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Selected \>\"", "<>", 
    RowBox[{"ToString", "@", 
     RowBox[{"Length", "[", "SRTextSig", "]"}]}], "<>", 
    "\"\< parameter sets out of \>\"", "<>", 
    RowBox[{"ToString", "@", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Length", "[", "SRTextNS", "]"}], "+", 
       RowBox[{"Length", "[", "SRTextSig", "]"}]}], ")"}]}], "<>", 
    "\"\< from the parameter optimisation routine\>\""}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Selected \>\"", "<>", 
    RowBox[{"ToString", "@", 
     RowBox[{"Length", "[", "LRTextSig", "]"}]}], "<>", 
    "\"\< parameter sets out of \>\"", "<>", 
    RowBox[{"ToString", "@", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Length", "[", "LRTextSig", "]"}], "+", 
       RowBox[{"Length", "[", "LRTextNS", "]"}]}], ")"}]}], "<>", 
    "\"\< from the likelihood profiling directly\>\""}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Selected \>\"", "<>", 
    RowBox[{"ToString", "@", 
     RowBox[{"Length", "[", "LRATextSig", "]"}]}], "<>", 
    "\"\< parameter sets out of \>\"", "<>", 
    RowBox[{"ToString", "@", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Length", "[", "LRATextSig", "]"}], "+", 
       RowBox[{"Length", "[", "LRATextNS", "]"}]}], ")"}]}], "<>", 
    "\"\< from the likelihood profiling.\>\""}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"paramSamplesSD", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"SRTextSig", ",", 
     RowBox[{"LRTextSig", "[", 
      RowBox[{"[", 
       RowBox[{"1", ";;", "5"}], "]"}], "]"}], ",", "LRATextSig"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<In total \>\"", "<>", 
    RowBox[{"ToString", "[", 
     RowBox[{"Length", "[", "paramSamplesSD", "]"}], "]"}], "<>", 
    "\"\<  parameter sets within confidence limit.\>\""}], "]"}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.633759486456072*^9, 3.6337595071351395`*^9}, {
   3.633948985945913*^9, 3.6339490062349415`*^9}, {3.6339492371800337`*^9, 
   3.633949238724188*^9}, {3.634534081730655*^9, 3.634534081899672*^9}, 
   3.6345341531827993`*^9, {3.6345341836478457`*^9, 3.6345341880472856`*^9}, 
   3.6345342534288235`*^9, {3.6345342917726574`*^9, 3.634534292332713*^9}, {
   3.634557556218028*^9, 3.63455755754016*^9}, {3.634557594875893*^9, 
   3.6345576068010855`*^9}, {3.6345576751559205`*^9, 
   3.6345576753049355`*^9}, {3.635174045704999*^9, 3.6351741402044477`*^9}, 
   3.635222258951565*^9, {3.635223865485202*^9, 3.6352238666983232`*^9}, {
   3.6362216451809683`*^9, 3.6362216453993692`*^9}, {3.647737407584789*^9, 
   3.647737447536459*^9}, {3.6477734333680487`*^9, 3.647773437122264*^9}, {
   3.6478291918865023`*^9, 3.6478292423761916`*^9}, {3.647832201226905*^9, 
   3.6478322152887096`*^9}, {3.6482071828081217`*^9, 3.648207197783619*^9}, {
   3.6482073393547745`*^9, 3.6482073433631754`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"optErrSD", ",", "optParSD", ",", "paramSamplesSD"}], "}"}], "=", 
   RowBox[{"loadParameterProfiles", "[", 
    RowBox[{"\"\<G.pulex - SD - CBZ\>\"", ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
      "\"\</runSD-Trace-new.xlsx\>\""}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
      "\"\</runSD-LL-prof-new-2.xlsx\>\""}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
      "\"\</runSD-LL-prof-allTraces-new.csv\>\""}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
      "\"\</runSD-LL-prof-new.xlsx\>\""}], ",", "\[IndentingNewLine]", 
     RowBox[{"confLimSingleCI", "=", "1.920729"}], ",", "\[IndentingNewLine]", 
     RowBox[{"confLimJointCI", "=", "3.9074"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.648782715387405*^9, 3.6487827156744337`*^9}, {
  3.648782830594925*^9, 3.6487828371655817`*^9}, {3.6487832636111774`*^9, 
  3.6487832864964657`*^9}, {3.648783317379554*^9, 3.6487833309369097`*^9}, {
  3.648784212179456*^9, 3.64878421250706*^9}, {3.6487842437230606`*^9, 
  3.6487842700717983`*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["IT model", "Title"]], "Title",
 CellChangeTimes->{
  3.6345348313016047`*^9, 3.634539374530882*^9, {3.6389720215283933`*^9, 
   3.6389720246817083`*^9}, {3.638972166019841*^9, 3.6389721679800367`*^9}, {
   3.6424182023424597`*^9, 3.642418203280514*^9}}],

Cell[CellGroupData[{

Cell["Parameter estimation for the acute experiments", "Subchapter",
 CellChangeTimes->{{3.6345335490253897`*^9, 3.634533557690256*^9}, {
  3.6347220388446712`*^9, 3.634722041096896*^9}, {3.6392194539499288`*^9, 
  3.639219455232057*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"$CalculateNew", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"gmonix", "=", "1"}], ";", "\[IndentingNewLine]", 
     RowBox[{"globResMonDat", "=", 
      RowBox[{"Table", "[", 
       RowBox[{"\"\<\>\"", ",", 
        RowBox[{"{", "100000", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"startIT", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"p1", "\[Rule]", "0.1"}], ",", 
        RowBox[{"p2", "\[Rule]", "150"}], ",", 
        RowBox[{"p3", "\[Rule]", "2"}]}], "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"monArr", "=", 
      RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"globC", "=", "0"}], ";", "\[IndentingNewLine]", 
     RowBox[{"startInt", "=", "5"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Monitor", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"resIT$B", "=", 
        RowBox[{"NMinimize", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"goalFunc$treatments", "[", " ", 
             RowBox[{
             "SOT$data$CAR", ",", "ITmodel", ",", "0", ",", "p1", ",", "p2", 
              ",", "p3", ",", "opt$Haz$BG$B", ",", 
              RowBox[{"tEnd", "=", "4"}]}], "]"}], ",", 
            RowBox[{
             RowBox[{"p1", ">", "0"}], "&&", 
             RowBox[{"p2", ">", "0"}], "&&", 
             RowBox[{"p3", ">", "0"}]}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"p1", ",", 
              RowBox[{
               RowBox[{"1", "/", "startInt"}], "*", 
               RowBox[{"(", 
                RowBox[{"p1", "/.", "startIT"}], ")"}]}], ",", 
              RowBox[{"startInt", "*", 
               RowBox[{"(", 
                RowBox[{"p1", "/.", "startIT"}], ")"}]}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"p2", ",", 
              RowBox[{
               RowBox[{"1", "/", "startInt"}], "*", 
               RowBox[{"(", 
                RowBox[{"p2", "/.", "startIT"}], ")"}]}], ",", 
              RowBox[{"startInt", "*", 
               RowBox[{"(", 
                RowBox[{"p2", "/.", "startIT"}], ")"}]}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"p3", ",", 
              RowBox[{
               RowBox[{"1", "/", "startInt"}], "*", 
               RowBox[{"(", 
                RowBox[{"p3", "/.", "startIT"}], ")"}]}], ",", 
              RowBox[{"startInt", "*", 
               RowBox[{"(", 
                RowBox[{"p3", "/.", "startIT"}], ")"}]}]}], "}"}]}], "}"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"Method", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"\"\<SimulatedAnnealing\>\"", ",", 
             RowBox[{"\"\<PerturbationScale\>\"", "\[Rule]", "3"}], ",", 
             RowBox[{"\"\<SearchPoints\>\"", "\[Rule]", "50"}]}], "}"}]}], 
          ",", 
          RowBox[{"EvaluationMonitor", "\[RuleDelayed]", " ", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"globResMonDat", "[", 
              RowBox[{"[", 
               RowBox[{"gmonix", "++"}], "]"}], "]"}], "=", "resMonDat"}], 
            "}"}]}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "4"}], ",", 
          RowBox[{"MaxIterations", "\[Rule]", "15"}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", "resMon"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"startInt", "=", "3"}], ";", "\[IndentingNewLine]", 
     RowBox[{"startIT", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"p1", "\[Rule]", 
         RowBox[{"(", 
          RowBox[{"p1", "/.", 
           RowBox[{"resIT$B", "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], ")"}]}], ",", 
        RowBox[{"p2", "\[Rule]", 
         RowBox[{"(", 
          RowBox[{"p2", "/.", 
           RowBox[{"resIT$B", "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], ")"}]}], ",", 
        RowBox[{"p3", "\[Rule]", 
         RowBox[{"(", 
          RowBox[{"p3", "/.", 
           RowBox[{"resIT$B", "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], ")"}]}]}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Print", "[", "resIT$B", "]"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"Monitor", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"resIT$B", "=", 
        RowBox[{"NMinimize", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"goalFunc$treatments", "[", " ", 
             RowBox[{
             "SOT$data$CAR", ",", "ITmodel", ",", "0", ",", "p1", ",", "p2", 
              ",", "p3", ",", "opt$Haz$BG$B", ",", 
              RowBox[{"tEnd", "=", "4"}]}], "]"}], ",", 
            RowBox[{
             RowBox[{"p1", ">", "0"}], "&&", 
             RowBox[{"p2", ">", "0"}], "&&", 
             RowBox[{"p3", ">", "0"}]}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"p1", ",", 
              RowBox[{
               RowBox[{"1", "/", "startInt"}], "*", 
               RowBox[{"(", 
                RowBox[{"p1", "/.", "startIT"}], ")"}]}], ",", 
              RowBox[{"startInt", "*", 
               RowBox[{"(", 
                RowBox[{"p1", "/.", "startIT"}], ")"}]}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"p2", ",", 
              RowBox[{
               RowBox[{"1", "/", "startInt"}], "*", 
               RowBox[{"(", 
                RowBox[{"p2", "/.", "startIT"}], ")"}]}], ",", 
              RowBox[{"startInt", "*", 
               RowBox[{"(", 
                RowBox[{"p2", "/.", "startIT"}], ")"}]}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"p3", ",", 
              RowBox[{
               RowBox[{"1", "/", "startInt"}], "*", 
               RowBox[{"(", 
                RowBox[{"p3", "/.", "startIT"}], ")"}]}], ",", 
              RowBox[{"startInt", "*", 
               RowBox[{"(", 
                RowBox[{"p3", "/.", "startIT"}], ")"}]}]}], "}"}]}], "}"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"Method", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"\"\<SimulatedAnnealing\>\"", ",", 
             RowBox[{"\"\<PerturbationScale\>\"", "\[Rule]", "2.5"}], ",", 
             RowBox[{"\"\<SearchPoints\>\"", "\[Rule]", "50"}]}], "}"}]}], 
          ",", 
          RowBox[{"EvaluationMonitor", "\[RuleDelayed]", " ", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"globResMonDat", "[", 
              RowBox[{"[", 
               RowBox[{"gmonix", "++"}], "]"}], "]"}], "=", "resMonDat"}], 
            "}"}]}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "5"}], ",", 
          RowBox[{"MaxIterations", "\[Rule]", "15"}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", "resMon"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"startInt", "=", "2"}], ";", "\[IndentingNewLine]", 
     RowBox[{"startIT", "=", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"p1", "\[Rule]", 
         RowBox[{"(", 
          RowBox[{"p1", "/.", 
           RowBox[{"resIT$B", "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], ")"}]}], ",", 
        RowBox[{"p2", "\[Rule]", 
         RowBox[{"(", 
          RowBox[{"p2", "/.", 
           RowBox[{"resIT$B", "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], ")"}]}], ",", 
        RowBox[{"p3", "\[Rule]", 
         RowBox[{"(", 
          RowBox[{"p3", "/.", 
           RowBox[{"resIT$B", "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], ")"}]}]}], "}"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Print", "[", "resIT$B", "]"}], ";", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"Monitor", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"resIT$B", "=", 
        RowBox[{"NMinimize", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"goalFunc$treatments", "[", " ", 
             RowBox[{
             "SOT$data$CAR", ",", "ITmodel", ",", "0", ",", "p1", ",", "p2", 
              ",", "p3", ",", "opt$Haz$BG$B", ",", 
              RowBox[{"tEnd", "=", "4"}]}], "]"}], ",", 
            RowBox[{
             RowBox[{"p1", ">", "0"}], "&&", 
             RowBox[{"p2", ">", "0"}], "&&", 
             RowBox[{"p3", ">", "0"}]}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"p1", ",", 
              RowBox[{
               RowBox[{"1", "/", "startInt"}], "*", 
               RowBox[{"(", 
                RowBox[{"p1", "/.", "startIT"}], ")"}]}], ",", 
              RowBox[{"startInt", "*", 
               RowBox[{"(", 
                RowBox[{"p1", "/.", "startIT"}], ")"}]}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"p2", ",", 
              RowBox[{
               RowBox[{"1", "/", "startInt"}], "*", 
               RowBox[{"(", 
                RowBox[{"p2", "/.", "startIT"}], ")"}]}], ",", 
              RowBox[{"startInt", "*", 
               RowBox[{"(", 
                RowBox[{"p2", "/.", "startIT"}], ")"}]}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"p3", ",", 
              RowBox[{
               RowBox[{"1", "/", "startInt"}], "*", 
               RowBox[{"(", 
                RowBox[{"p3", "/.", "startIT"}], ")"}]}], ",", 
              RowBox[{"startInt", "*", 
               RowBox[{"(", 
                RowBox[{"p3", "/.", "startIT"}], ")"}]}]}], "}"}]}], "}"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"Method", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"\"\<SimulatedAnnealing\>\"", ",", 
             RowBox[{"\"\<PerturbationScale\>\"", "\[Rule]", "2"}], ",", 
             RowBox[{"\"\<SearchPoints\>\"", "\[Rule]", "50"}]}], "}"}]}], 
          ",", 
          RowBox[{"EvaluationMonitor", "\[RuleDelayed]", " ", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"globResMonDat", "[", 
              RowBox[{"[", 
               RowBox[{"gmonix", "++"}], "]"}], "]"}], "=", "resMonDat"}], 
            "}"}]}], ",", 
          RowBox[{"PrecisionGoal", "\[Rule]", "6"}], ",", 
          RowBox[{"MaxIterations", "\[Rule]", "15"}]}], "]"}]}], ",", 
       "\[IndentingNewLine]", "resMon"}], "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Print", "[", "resIT$B", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"SRTIT", "=", 
      RowBox[{"Sort", "[", 
       RowBox[{
        RowBox[{"globResMonDat", "[", 
         RowBox[{"[", 
          RowBox[{"1", ";;", 
           RowBox[{"gmonix", "-", "1"}]}], "]"}], "]"}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{"#1", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "<", 
          RowBox[{"#2", "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], "&"}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Export", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
        "\"\</runIT-Trace-new.xlsx\>\""}], ",", "SRTIT"}], "]"}]}], ",", 
    "\[IndentingNewLine]", "0"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.6331862371279325`*^9, 3.6331862382570453`*^9}, {
   3.6331862688351026`*^9, 3.6331862794821672`*^9}, {3.633186312381457*^9, 
   3.633186333188537*^9}, {3.633186400529271*^9, 3.633186463889606*^9}, {
   3.6331865029575124`*^9, 3.6331865046956863`*^9}, {3.6331867906992836`*^9, 
   3.63318681936115*^9}, {3.633187249699179*^9, 3.633187313135522*^9}, {
   3.63318797727793*^9, 3.6331880517123723`*^9}, 3.6331881130385046`*^9, 
   3.6331883774829464`*^9, {3.6331888828654795`*^9, 3.633188892352428*^9}, {
   3.6331893078279715`*^9, 3.6331893432805166`*^9}, {3.634533492445732*^9, 
   3.6345335111186*^9}, {3.63499922565374*^9, 3.634999251615336*^9}, {
   3.6351741932257495`*^9, 3.6351742319936256`*^9}, {3.635175416328639*^9, 
   3.6351754164706535`*^9}, {3.6356466951193647`*^9, 
   3.6356466951193647`*^9}, {3.6356567852929306`*^9, 3.635656785604932*^9}, {
   3.635657009746125*^9, 3.635657018684941*^9}, {3.6383350998848934`*^9, 
   3.638335100124889*^9}, {3.6482107127060757`*^9, 3.6482107135611615`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SRTIT", "=", 
   RowBox[{
    RowBox[{"Import", "[", 
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
      "\"\</runIT-Trace.xlsx\>\""}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{
  3.6345337066841545`*^9, {3.6345338086153464`*^9, 3.6345338119596806`*^9}}],

Cell[BoxData[{
 RowBox[{"optParIT$CAR$AF", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"SRTIT", "[", 
     RowBox[{"[", 
      RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"p1", "\[Rule]", 
       RowBox[{"SRTIT", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "2"}], "]"}], "]"}]}], ",", 
      RowBox[{"p2", "\[Rule]", 
       RowBox[{"SRTIT", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "3"}], "]"}], "]"}]}], ",", 
      RowBox[{"p3", "\[Rule]", 
       RowBox[{"SRTIT", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "4"}], "]"}], "]"}]}]}], "}"}]}], 
   "}"}]}], "\[IndentingNewLine]", 
 RowBox[{"optErrIT", "=", 
  RowBox[{"SRTIT", "[", 
   RowBox[{"[", 
    RowBox[{"1", ",", "1"}], "]"}], "]"}]}]}], "Input",
 CellChangeTimes->{
  3.634533279043394*^9, {3.634533707981284*^9, 3.634533717315217*^9}, {
   3.634533815313016*^9, 3.634533822079693*^9}, {3.6356551007477703`*^9, 
   3.635655129714221*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Calibration figures output", "Subchapter",
 CellChangeTimes->{{3.648783871455488*^9, 3.648783877289963*^9}}],

Cell[BoxData[{
 RowBox[{"fig", "=", 
  RowBox[{"Show", "[", 
   RowBox[{
    RowBox[{"ShowResultScenarios", "[", 
     RowBox[{
     "SOT$data$CAR", ",", "ITmodel", ",", "opt$Haz$BG$B", ",", 
      "optParIT$CAR$AF", ",", 
      RowBox[{"tEnd", "=", "4"}], ",", "1", ",", "\"\<N\>\"", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"MarkersScaledCol2", "[", 
         RowBox[{"Red", ",", 
          RowBox[{"lighter", "=", "0"}], ",", 
          RowBox[{"thick", "=", "0.045"}], ",", 
          RowBox[{"filled", "=", "1"}], ",", 
          RowBox[{"size", "=", "0.035"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"Black", ",", 
          RowBox[{"Thickness", "[", "0.005", "]"}]}], "}"}], ",", 
        "\"\<Acute toxicity test\>\""}], "}"}]}], "]"}], ",", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"FontSize", "\[Rule]", "63"}], "}"}]}], ",", 
    RowBox[{"GridLines", "\[Rule]", "Automatic"}], ",", 
    RowBox[{"GridLinesStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Directive", "[", 
        RowBox[{"Black", ",", 
         RowBox[{"Thickness", "[", "0.001", "]"}], ",", "Dotted"}], "]"}], 
       ",", 
       RowBox[{"Directive", "[", 
        RowBox[{"Black", ",", "Dashed", ",", 
         RowBox[{"Thickness", "[", "0.001", "]"}]}], "]"}]}], "}"}]}], ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"Directive", "[", "Black", "]"}]}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{"Black", ",", 
       RowBox[{"Thickness", "[", "0.002", "]"}]}], "]"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "1800"}]}], "]"}]}], "\n", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\</CBZ-IT-acuteTox(calibration)-figA.gif\>\""}], ",", "fig"}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.6356551680122886`*^9, 3.6356551794783087`*^9}, {
  3.647832337255686*^9, 3.6478323378437195`*^9}, {3.648467236370794*^9, 
  3.6484672520923657`*^9}}],

Cell[BoxData[
 RowBox[{"fig", "=", 
  RowBox[{"TableForm", "[", 
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{"ShowResultScenarios", "[", 
      RowBox[{
      "SOT$data$CAR", ",", "ITmodel", ",", "opt$Haz$BG$B", ",", 
       "optParIT$CAR$AF", ",", 
       RowBox[{"tEnd", "=", "4"}], ",", "1", ",", "\"\<N\>\"", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"MarkersScaledCol2", "[", 
          RowBox[{"Red", ",", 
           RowBox[{"lighter", "=", "0"}], ",", 
           RowBox[{"thick", "=", "0.045"}], ",", 
           RowBox[{"filled", "=", "1"}], ",", 
           RowBox[{"size", "=", "0.035"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"Black", ",", 
           RowBox[{"Thickness", "[", "0.005", "]"}]}], "}"}], ",", 
         "\"\<\>\""}], "}"}], ",", "40"}], "]"}], ",", "4"}], "]"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.6331879140706096`*^9, 3.6331879147176743`*^9}, {
   3.6331883216403627`*^9, 3.633188331936392*^9}, {3.6331893923894267`*^9, 
   3.633189403405528*^9}, {3.6339445602673893`*^9, 3.6339445626676292`*^9}, {
   3.6345338346489496`*^9, 3.634533835985083*^9}, {3.6351664854759245`*^9, 
   3.6351664859959764`*^9}, 3.6356466951193647`*^9, 3.6356551229906096`*^9, {
   3.638972090909331*^9, 3.6389720990771475`*^9}, {3.642418264045989*^9, 
   3.642418266966156*^9}, {3.6483758856433244`*^9, 3.648375886259386*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\</CBZ-IT-acuteTox(calibration)-figB.gif\>\""}], ",", "fig"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.63896179058996*^9, 3.638961795806482*^9}, {
  3.6389618476816688`*^9, 3.638961848023703*^9}, {3.638961999300829*^9, 
  3.638962000267926*^9}, {3.6389719654357843`*^9, 3.638971967683009*^9}, {
  3.638972104134653*^9, 3.638972105045744*^9}, {3.6389721486541047`*^9, 
  3.6389721490771465`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"expData", "=", 
   RowBox[{"createModelTimeSeries1M", "[", 
    RowBox[{"ITmodel", " ", ",", "SOT$data$CAR", ",", "opt$Haz$BG$B", ",", 
     RowBox[{"{", 
      RowBox[{"optParIT$CAR$AF", "[", 
       RowBox[{"[", "2", "]"}], "]"}], "}"}], ",", "tEnd", ",", "1", ",", 
     "0.1"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6389615929151945`*^9, 3.638961604491352*^9}, {
  3.6389616479086933`*^9, 3.63896168718062*^9}, {3.638961907289629*^9, 
  3.638961912889189*^9}, {3.6389621547733746`*^9, 3.638962155669464*^9}, {
  3.6389719737176127`*^9, 3.6389719940186424`*^9}, {3.6389721091891584`*^9, 
  3.6389721153407736`*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\</CBZ-IT-acuteTox(calibration).xlsx\>\""}], ",", "expData"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.638961690568959*^9, 3.638961782839185*^9}, {
  3.6389621606569633`*^9, 3.6389621615670543`*^9}, {3.6389720002422647`*^9, 
  3.6389720039396343`*^9}, {3.638972121958435*^9, 3.63897212470971*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Profiling parameter confidence", "Subchapter",
 CellChangeTimes->{{3.634532442481576*^9, 3.634532445929576*^9}, {
  3.647831785519128*^9, 3.6478317906964245`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"$CalculateNew", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"prof", "=", 
      RowBox[{"SOT$LRParamConfidence", "[", 
       RowBox[{
       "optParIT$CAR$AF", ",", "ITmodel", ",", "opt$Haz$BG$B", ",", 
        "SOT$data$CAR", ",", 
        RowBox[{"tEnd", "=", "4"}], ",", "0.05", ",", 
        RowBox[{"confLim", "=", 
         RowBox[{
          RowBox[{"InvChiSquare", "[", 
           RowBox[{"1", ",", "0.95"}], "]"}], "/", "2"}]}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Export", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
        "\"\</runIT-LL-prof-new.xlsx\>\""}], ",", "prof"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Export", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
        "\"\</runIT-LL-prof-allTraces-new.csv\>\""}], ",", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"totalProfile", "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", 
         RowBox[{"totalProfile", "[", 
          RowBox[{"[", "2", "]"}], "]"}], ",", 
         RowBox[{"totalProfile", "[", 
          RowBox[{"[", "3", "]"}], "]"}]}], "]"}]}], "]"}]}], ",", 
    "\[IndentingNewLine]", "0"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.6476958827098446`*^9, 3.647695912293537*^9}, {
   3.6476979575780196`*^9, 3.6476979606200247`*^9}, 3.6476983540985174`*^9, {
   3.647704880728368*^9, 3.6477048811833935`*^9}, {3.6477050072879534`*^9, 
   3.6477050073503537`*^9}, {3.647828542473553*^9, 3.6478285433939548`*^9}, 
   3.6478311725727806`*^9, {3.6478318002379704`*^9, 3.647831802435096*^9}, {
   3.6478324127320027`*^9, 3.647832427949873*^9}, {3.64783249502871*^9, 
   3.647832496178776*^9}, {3.647832631683526*^9, 3.6478326430581765`*^9}, {
   3.6482069344547567`*^9, 3.648206956141757*^9}, {3.6482074190947475`*^9, 
   3.648207419398778*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"$CalculateNew", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"prof", "=", 
      RowBox[{"SOT$LRParamConfidence", "[", 
       RowBox[{
       "optParIT$CAR$AF", ",", "ITmodel", ",", "opt$Haz$BG$B", ",", 
        "SOT$data$CAR", ",", 
        RowBox[{"tEnd", "=", "4"}], ",", "0.25", ",", 
        RowBox[{"confLim", "=", 
         RowBox[{
          RowBox[{"InvChiSquare", "[", 
           RowBox[{"3", ",", "0.95"}], "]"}], "/", "2"}]}]}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Export", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
        "\"\</runIT-LL-prof-new-2.xlsx\>\""}], ",", "prof"}], "]"}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"Export", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
        "\"\</runIT-LL-prof-allTraces-new-2.csv\>\""}], ",", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"totalProfile", "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", 
         RowBox[{"totalProfile", "[", 
          RowBox[{"[", "2", "]"}], "]"}], ",", 
         RowBox[{"totalProfile", "[", 
          RowBox[{"[", "3", "]"}], "]"}]}], "]"}]}], "]"}]}], ",", 
    "\[IndentingNewLine]", "0"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.6476958827098446`*^9, 3.647695912293537*^9}, {
   3.6476979575780196`*^9, 3.6476979606200247`*^9}, 3.6476983540985174`*^9, {
   3.647704880728368*^9, 3.6477048811833935`*^9}, {3.6477050072879534`*^9, 
   3.6477050073503537`*^9}, {3.6477377121451235`*^9, 3.647737728681153*^9}, {
   3.647828555532776*^9, 3.647828556063177*^9}, 3.6478311741795835`*^9, 
   3.6478317988568907`*^9, {3.647832409457815*^9, 3.6478324294639597`*^9}, {
   3.6478324997089777`*^9, 3.647832500401017*^9}, {3.6478326368668222`*^9, 
   3.6478326516626687`*^9}, {3.648206948662757*^9, 3.648206966021757*^9}, {
   3.6482074229101295`*^9, 3.648207423238162*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Import of profiling data", "Subchapter",
 CellChangeTimes->{{3.634532442481576*^9, 3.634532445929576*^9}}],

Cell[BoxData[
 RowBox[{"confLim", "=", 
  RowBox[{"InvChiSquare", "[", 
   RowBox[{"1", ",", "0.95"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.648776377681731*^9, 3.6487763776973314`*^9}, {
  3.648776492171599*^9, 3.6487764922808003`*^9}}],

Cell[BoxData[
 RowBox[{"confLim", "=", 
  RowBox[{
   RowBox[{"InvChiSquare", "[", 
    RowBox[{"3", ",", "0.95"}], "]"}], "/", "2"}]}]], "Input",
 CellChangeTimes->{{3.6333331996682525`*^9, 3.633333210476333*^9}, {
   3.633333416312915*^9, 3.6333334167989635`*^9}, {3.63453407757924*^9, 
   3.634534077772259*^9}, 3.634559825858969*^9, {3.6345638444815645`*^9, 
   3.6345638452125645`*^9}, {3.635174366239049*^9, 3.6351743936937943`*^9}, {
   3.63522404977763*^9, 3.635224050906742*^9}, {3.647829601274823*^9, 
   3.647829611555241*^9}, {3.647829736268861*^9, 3.647829741947271*^9}, {
   3.647829875147305*^9, 3.647829908205763*^9}, 3.6487763710828466`*^9, {
   3.6487764193498654`*^9, 3.6487764277739735`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SRT", "=", 
   RowBox[{
    RowBox[{"Import", "[", 
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
      "\"\</runIT-Trace-new.xlsx\>\""}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SRTSD", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"Transpose", "[", "SRT", "]"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}], ",", 
      RowBox[{
       RowBox[{"Transpose", "[", "SRT", "]"}], "[", 
       RowBox[{"[", "2", "]"}], "]"}], ",", 
      RowBox[{
       RowBox[{"Transpose", "[", "SRT", "]"}], "[", 
       RowBox[{"[", "3", "]"}], "]"}], ",", 
      RowBox[{
       RowBox[{"Transpose", "[", "SRT", "]"}], "[", 
       RowBox[{"[", "4", "]"}], "]"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Transpose", "[", "SRT", "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}], "-", "optErrIT"}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"optParIT$CAR$AF", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"SRTSD", "[", 
     RowBox[{"[", 
      RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"p1", "\[Rule]", 
       RowBox[{"SRTSD", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "2"}], "]"}], "]"}]}], ",", 
      RowBox[{"p2", "\[Rule]", 
       RowBox[{"SRTSD", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "3"}], "]"}], "]"}]}], ",", 
      RowBox[{"p3", "\[Rule]", 
       RowBox[{"SRTSD", "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "4"}], "]"}], "]"}]}]}], "}"}]}], 
   "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"optErrIT", "=", 
   RowBox[{"SRTSD", "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "1"}], "]"}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SRTextSig", "=", 
   RowBox[{"Select", "[", 
    RowBox[{"SRTSD", ",", 
     RowBox[{
      RowBox[{
       RowBox[{"#", "[", 
        RowBox[{"[", "5", "]"}], "]"}], "<=", "confLim"}], "&"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SRTextNS", "=", 
    RowBox[{"Select", "[", 
     RowBox[{"SRTSD", ",", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "5", "]"}], "]"}], ">", "confLim"}], "&"}]}], "]"}]}], 
   ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LRAdatatmp", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
     "\"\</runIT-LL-prof-allTraces-new.csv\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LRAdata", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"Transpose", "[", "LRAdatatmp", "]"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}], ",", 
      RowBox[{
       RowBox[{"Transpose", "[", "LRAdatatmp", "]"}], "[", 
       RowBox[{"[", "2", "]"}], "]"}], ",", 
      RowBox[{
       RowBox[{"Transpose", "[", "LRAdatatmp", "]"}], "[", 
       RowBox[{"[", "3", "]"}], "]"}], ",", 
      RowBox[{
       RowBox[{"Transpose", "[", "LRAdatatmp", "]"}], "[", 
       RowBox[{"[", "4", "]"}], "]"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Transpose", "[", "LRAdatatmp", "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}], "-", "optErrIT"}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LRATextSig", "=", 
   RowBox[{"Select", "[", 
    RowBox[{"LRAdata", ",", 
     RowBox[{
      RowBox[{
       RowBox[{"#", "[", 
        RowBox[{"[", "5", "]"}], "]"}], "<=", "confLim"}], "&"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LRATextNS", "=", 
    RowBox[{"Select", "[", 
     RowBox[{"LRAdata", ",", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "5", "]"}], "]"}], ">", "confLim"}], "&"}]}], "]"}]}], 
   ";"}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{"lprofData", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
     "\"\</runIT-LL-prof-new.xlsx\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LRdata", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"lprofData", "[", 
      RowBox[{"[", "1", "]"}], "]"}], ",", 
     RowBox[{"lprofData", "[", 
      RowBox[{"[", "2", "]"}], "]"}], ",", 
     RowBox[{"lprofData", "[", 
      RowBox[{"[", "3", "]"}], "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"LRTextSig", "=", 
   RowBox[{"Select", "[", 
    RowBox[{"LRdata", ",", 
     RowBox[{
      RowBox[{
       RowBox[{"#", "[", 
        RowBox[{"[", "5", "]"}], "]"}], "<=", "confLim"}], "&"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LRTextNS", "=", 
    RowBox[{"Select", "[", 
     RowBox[{"LRdata", ",", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "5", "]"}], "]"}], ">", "confLim"}], "&"}]}], "]"}]}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Selected \>\"", "<>", 
    RowBox[{"ToString", "@", 
     RowBox[{"Length", "[", "SRTextSig", "]"}]}], "<>", 
    "\"\< parameter sets out of \>\"", "<>", 
    RowBox[{"ToString", "@", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Length", "[", "SRTextNS", "]"}], "+", 
       RowBox[{"Length", "[", "SRTextSig", "]"}]}], ")"}]}], "<>", 
    "\"\< from the parameter optimisation routine\>\""}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Selected \>\"", "<>", 
    RowBox[{"ToString", "@", 
     RowBox[{"Length", "[", "LRTextSig", "]"}]}], "<>", 
    "\"\< parameter sets out of \>\"", "<>", 
    RowBox[{"ToString", "@", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Length", "[", "LRTextSig", "]"}], "+", 
       RowBox[{"Length", "[", "LRTextNS", "]"}]}], ")"}]}], "<>", 
    "\"\< from the likelihood profiling directly\>\""}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<Selected \>\"", "<>", 
    RowBox[{"ToString", "@", 
     RowBox[{"Length", "[", "LRATextSig", "]"}]}], "<>", 
    "\"\< parameter sets out of \>\"", "<>", 
    RowBox[{"ToString", "@", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Length", "[", "LRATextSig", "]"}], "+", 
       RowBox[{"Length", "[", "LRATextNS", "]"}]}], ")"}]}], "<>", 
    "\"\< from the likelihood profiling.\>\""}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"paramSamplesIT", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"SRTextSig", ",", 
     RowBox[{"LRTextSig", "[", 
      RowBox[{"[", 
       RowBox[{"1", ";;", "5"}], "]"}], "]"}], ",", "LRATextSig"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Print", "[", 
   RowBox[{"\"\<In total \>\"", "<>", 
    RowBox[{"ToString", "[", 
     RowBox[{"Length", "[", "paramSamplesIT", "]"}], "]"}], "<>", 
    "\"\<  parameter sets within confidence limit.\>\""}], "]"}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.633759486456072*^9, 3.6337595071351395`*^9}, {
   3.633948985945913*^9, 3.6339490062349415`*^9}, {3.6339492371800337`*^9, 
   3.633949238724188*^9}, {3.634534081730655*^9, 3.634534081899672*^9}, 
   3.6345341531827993`*^9, {3.6345341836478457`*^9, 3.6345341880472856`*^9}, 
   3.6345342534288235`*^9, {3.6345342917726574`*^9, 3.634534292332713*^9}, {
   3.634557556218028*^9, 3.63455755754016*^9}, {3.634557594875893*^9, 
   3.6345576068010855`*^9}, {3.6345576751559205`*^9, 
   3.6345576753049355`*^9}, {3.635174045704999*^9, 3.6351741402044477`*^9}, 
   3.635222258951565*^9, {3.635223865485202*^9, 3.6352238666983232`*^9}, {
   3.6362216451809683`*^9, 3.6362216453993692`*^9}, {3.647737407584789*^9, 
   3.647737447536459*^9}, {3.6477734333680487`*^9, 3.647773437122264*^9}, {
   3.6478291918865023`*^9, 3.6478292423761916`*^9}, {3.647832201226905*^9, 
   3.6478322152887096`*^9}, {3.647832658644068*^9, 3.6478326747589893`*^9}, {
   3.64820743001784*^9, 3.648207444595298*^9}, {3.6482074755963974`*^9, 
   3.648207498494687*^9}, {3.648258507101235*^9, 3.648258511459671*^9}, {
   3.648258634847008*^9, 3.6482586360461283`*^9}, {3.6482597730638185`*^9, 
   3.648259774118924*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"optErrIT", ",", "optParIT", ",", "paramSamplesIT"}], "}"}], "=", 
   RowBox[{"loadParameterProfiles", "[", 
    RowBox[{"\"\<G.pulex - IT - CYP\>\"", ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
      "\"\</runIT-Trace-new.xlsx\>\""}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
      "\"\</runIT-LL-prof-new.xlsx\>\""}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
      "\"\</runIT-LL-prof-allTraces-new.csv\>\""}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
      "\"\</runIT-LL-prof-new.xlsx\>\""}], ",", "\[IndentingNewLine]", 
     RowBox[{"confLimSingleCI", "=", "1.920729"}], ",", "\[IndentingNewLine]", 
     RowBox[{"confLimJointCI", "=", "3.9074"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6487830358465924`*^9, 3.6487830443331013`*^9}, 
   3.648783737309368*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Prediction of survival under pulsed expsoure  ", "Title",
 CellChangeTimes->{{3.6345394204164705`*^9, 3.634539442653694*^9}}],

Cell[CellGroupData[{

Cell[TextData[StyleBox["Data import pulsed exposure (scenarios A - D)", \
"Subchapter"]], "Chapter",
 CellChangeTimes->{{3.6345317356440516`*^9, 3.6345317502285094`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"expDataPulse", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Import", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
        "\"\<\\\\input/Cw - Carbendazim - \>\"", "<>", "#", "<>", 
        "\"\<.txt\>\""}], ",", "\"\<Table\>\""}], "]"}], "&"}], "/@", 
    RowBox[{"{", 
     RowBox[{
     "\"\<A\>\"", ",", "\"\<B\>\"", ",", "\"\<C\>\"", ",", "\"\<D\>\""}], 
     "}"}]}]}], ";", 
  RowBox[{"expDataPulse", "//", "TableForm"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ltab", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<A\>\"", ",", "\"\<B\>\"", ",", "\"\<C\>\"", ",", "\"\<D\>\""}], 
    "}"}]}], ";", 
  RowBox[{"fig", "=", 
   RowBox[{"TableForm", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Text", "[", 
         RowBox[{"Style", "[", 
          RowBox[{
           RowBox[{"ltab", "[", 
            RowBox[{"[", "i", "]"}], "]"}], ",", "Bold", ",", "63"}], "]"}], 
         "]"}], ",", 
        RowBox[{"ListPlot", "[", 
         RowBox[{
          RowBox[{"Drop", "[", 
           RowBox[{
            RowBox[{"expDataPulse", "[", 
             RowBox[{"[", "i", "]"}], "]"}], ",", "1"}], "]"}], ",", 
          RowBox[{"Frame", "\[Rule]", "True"}], ",", 
          RowBox[{"LabelStyle", "\[Rule]", 
           RowBox[{"Directive", "[", "Black", "]"}]}], ",", 
          RowBox[{"FrameStyle", "\[Rule]", 
           RowBox[{"Directive", "[", 
            RowBox[{"Black", ",", 
             RowBox[{"Thickness", "[", "0.002", "]"}]}], "]"}]}], ",", 
          RowBox[{"FrameLabel", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
            "\"\<Time [d]\>\"", ",", 
             "\"\<Concentration [nmol \!\(\*SuperscriptBox[\(L\), \
\(-1\)]\)]\>\""}], " ", "}"}]}], ",", 
          RowBox[{"PlotStyle", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"Directive", "[", 
             RowBox[{
              RowBox[{"Thickness", "[", "0.004", "]"}], ",", "Blue"}], "]"}], 
            "}"}]}], ",", 
          RowBox[{"ImageSize", "\[Rule]", "1800"}], ",", 
          RowBox[{"BaseStyle", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"FontSize", "\[Rule]", "63"}], "}"}]}], ",", 
          RowBox[{"Joined", "\[Rule]", "True"}], ",", 
          RowBox[{"LabelStyle", "\[Rule]", 
           RowBox[{"{", "Black", "}"}]}]}], "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "4"}], "}"}]}], "]"}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.633961725762901*^9, 3.633961737883837*^9}, 
   3.634531816122098*^9, {3.634531929111396*^9, 3.634531983208805*^9}, {
   3.6345665912033997`*^9, 3.6345665963349133`*^9}, {3.635174559708394*^9, 
   3.6351745598454075`*^9}, {3.6383347155288806`*^9, 
   3.6383347510628805`*^9}, {3.6392817686463957`*^9, 3.639281778756407*^9}, 
   3.642418296854866*^9, {3.648375270914858*^9, 3.6483752974265084`*^9}, {
   3.648467665386691*^9, 3.6484676790080533`*^9}}],

Cell[BoxData[{
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\</CBZ-Pulsed-Exposure-Concentrations.gif\>\""}], ",", "fig"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\</CBZ-Pulsed-Exposure-Concentrations-pulseA.gif\>\""}], ",", 
   RowBox[{"fig", "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "1", ",", "2"}], "]"}], "]"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\</CBZ-Pulsed-Exposure-Concentrations-pulseB.gif\>\""}], ",", 
   RowBox[{"fig", "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "2", ",", "2"}], "]"}], "]"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.648467684286581*^9, 3.6484676892630787`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"survivalDataPulsed", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
      "\"\<\\\\input/Pulse Tox Survival - Carbendazim - Gpulex.txt\>\""}], 
     ",", "\"\<Table\>\""}], "]"}]}], ";", 
  RowBox[{"survivalDataPulsed", "//", "TableForm"}]}]], "Input",
 CellChangeTimes->{{3.6345318288093667`*^9, 3.634531833809867*^9}, {
  3.6345318658280683`*^9, 3.634531875196005*^9}, {3.63453199465795*^9, 
  3.6345319950259867`*^9}, {3.6345666070509844`*^9, 3.6345666102913084`*^9}, {
  3.638334762964881*^9, 3.638334766525881*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"NInitPulse", "=", "80"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"NInitAcute", "=", "20"}], ";"}]}], "Input",
 CellChangeTimes->{{3.6392826417508144`*^9, 3.6392826659157257`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tEndExp", "=", "10"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$data$days", "=", 
   RowBox[{"Drop", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Transpose", "[", "survivalDataPulsed", "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}], ",", "1"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$data$initAbundance", "=", 
   RowBox[{"{", 
    RowBox[{
    "NInitPulse", ",", "NInitPulse", ",", "NInitPulse", ",", "NInitPulse"}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$conc", "=", 
   RowBox[{"Reverse", "@", 
    RowBox[{"{", 
     RowBox[{
     "\"\<A\>\"", ",", "\"\<B\>\"", ",", "\"\<C\>\"", ",", "\"\<D\>\""}], 
     "}"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$treatments", "=", 
   RowBox[{"Reverse", "@", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Drop", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Transpose", "[", "survivalDataPulsed", "]"}], "[", 
            RowBox[{"[", "#", "]"}], "]"}], ",", "1"}], "]"}], "/", 
         "NInitPulse"}], ")"}], "&"}], "/@", 
      RowBox[{"{", 
       RowBox[{"2", ",", "3", ",", "4", ",", "5"}], "}"}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$CWs", "=", 
   RowBox[{"Reverse", "@", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Interpolation", "[", 
        RowBox[{
         RowBox[{"Drop", "[", 
          RowBox[{
           RowBox[{"expDataPulse", "[", 
            RowBox[{"[", "#", "]"}], "]"}], ",", "1"}], "]"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}], "&"}], "/@", 
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}]}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$dataPulsed$CBZ", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", "SOT$data$days", "}"}], ",", 
     RowBox[{"{", "SOT$data$initAbundance", "}"}], ",", 
     RowBox[{"{", "SOT$conc", "}"}], ",", "SOT$treatments", ",", 
     RowBox[{"{", "SOT$CWs", "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5877315556360598`*^9, 3.5877315556360598`*^9}, {
   3.5877316123115864`*^9, 3.5877317040251617`*^9}, {3.587731835534848*^9, 
   3.5877318928499827`*^9}, {3.5877321040454903`*^9, 
   3.5877321272595882`*^9}, {3.5877322798131495`*^9, 
   3.5877322938689294`*^9}, {3.587732390558969*^9, 3.587732414895281*^9}, {
   3.587733912706698*^9, 3.587734041633243*^9}, {3.5877343702514563`*^9, 
   3.5877343702670565`*^9}, {3.587734997084092*^9, 3.5877350050401945`*^9}, {
   3.587735043962693*^9, 3.5877351074711075`*^9}, {3.5877351394359174`*^9, 
   3.5877351412299404`*^9}, {3.587736724232035*^9, 3.5877367268216686`*^9}, 
   3.5877411156263742`*^9, 3.5877422438781524`*^9, {3.5877433008583126`*^9, 
   3.587743301201517*^9}, {3.587964502466705*^9, 3.5879645070687637`*^9}, {
   3.5879646774697485`*^9, 3.5879647116185865`*^9}, {3.5879647431621904`*^9, 
   3.5879647455022206`*^9}, {3.587964797778491*^9, 3.587964831474923*^9}, {
   3.587965008709795*^9, 3.587965014185465*^9}, {3.587965125555293*^9, 
   3.58796517212189*^9}, 3.587970373420555*^9, {3.5879706197011805`*^9, 
   3.58797062429764*^9}, {3.5883142730922647`*^9, 3.5883143228117676`*^9}, 
   3.588314582696744*^9, {3.58832968086419*^9, 3.588329730236127*^9}, 
   3.588329782143317*^9, {3.5883298157896814`*^9, 3.588329966430744*^9}, {
   3.5883302701331115`*^9, 3.5883303003331313`*^9}, {3.588330369749072*^9, 
   3.588330411813278*^9}, {3.588330528915987*^9, 3.588330539539049*^9}, 
   3.588332701753249*^9, 3.5883459682837696`*^9, {3.5955994468621893`*^9, 
   3.5955995244429655`*^9}, {3.5955996574552956`*^9, 
   3.5955996590453115`*^9}, {3.5956022129313116`*^9, 
   3.5956022190513725`*^9}, {3.595656689348352*^9, 3.5956567890693493`*^9}, {
   3.5956568281097393`*^9, 3.59565690213048*^9}, {3.5956584136975956`*^9, 
   3.5956584321977806`*^9}, {3.595928401009839*^9, 3.5959284012018585`*^9}, {
   3.6248894951475677`*^9, 3.6248895625814676`*^9}, {3.6248910990956573`*^9, 
   3.6248911095479927`*^9}, {3.624892258118964*^9, 3.6248923619587145`*^9}, {
   3.624893233913911*^9, 3.6248932477669773`*^9}, 3.62783666103316*^9, {
   3.634541715558962*^9, 3.634541721677573*^9}, {3.634541990099413*^9, 
   3.634542000890492*^9}, {3.6345421479431953`*^9, 3.6345421612645273`*^9}, {
   3.6345422510925093`*^9, 3.634542267308131*^9}, {3.6345437478051662`*^9, 
   3.6345437718455696`*^9}, {3.6345438819115753`*^9, 3.634543888951279*^9}, {
   3.6345439461229954`*^9, 3.634544055100892*^9}, 3.63454409108149*^9, {
   3.634544351477527*^9, 3.6345443521715965`*^9}, 3.6351745835337763`*^9, {
   3.6356580941488824`*^9, 3.635658095568485*^9}, {3.6383297988414807`*^9, 
   3.638329823736979*^9}, {3.638329977320244*^9, 3.6383299851213217`*^9}, {
   3.638334772445881*^9, 3.6383347731258807`*^9}, {3.639282676123619*^9, 
   3.639282682292533*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"$CalculateNew", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"res", "=", 
      RowBox[{"NMinimize", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"goalFunc$Control", "[", 
           RowBox[{"SOT$dataPulsed$CBZ", ",", "SDmodel", ",", 
            RowBox[{"tEnd", "=", "10"}], ",", "p1", ",", "1"}], "]"}], ",", 
          RowBox[{"p1", ">", "0"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"p1", ",", "0.001", ",", "0.002"}], "}"}]}], "]"}]}], ";", 
     RowBox[{"opt$Haz$BG$Pulse", "=", 
      RowBox[{"p1", "/.", 
       RowBox[{"res", "[", 
        RowBox[{"[", "2", "]"}], "]"}]}]}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"opt$Haz$BG$Pulse", "=", "0.024308185413343526`"}]}], 
   "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.638329887113247*^9, 3.6383299160906305`*^9}, {
   3.638329949075961*^9, 3.638329950715977*^9}, {3.6383347790168805`*^9, 
   3.638334784636881*^9}, {3.6383348996588807`*^9, 3.6383349013198805`*^9}, {
   3.638592080870191*^9, 3.6385920858536897`*^9}, {3.6385921246395674`*^9, 
   3.638592143503454*^9}, {3.6483729537941685`*^9, 3.648372953826172*^9}, 
   3.648377535527296*^9}],

Cell[BoxData["opt$Haz$BG$Pulse"], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tEndExp", "=", "10"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$data$days", "=", 
   RowBox[{"Drop", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Transpose", "[", "survivalDataPulsed", "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}], ",", "1"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$data$initAbundance", "=", 
   RowBox[{"{", 
    RowBox[{"80", ",", "80", ",", "80", ",", "80"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$conc", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<A\>\"", ",", "\"\<B\>\"", ",", "\"\<C\>\"", ",", "\"\<D\>\""}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$treatments", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Drop", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Transpose", "[", "survivalDataPulsed", "]"}], "[", 
          RowBox[{"[", "#", "]"}], "]"}], ",", "1"}], "]"}], "/", "80."}], 
      ")"}], "&"}], "/@", 
    RowBox[{"{", 
     RowBox[{"2", ",", "3", ",", "4", ",", "5"}], "}"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$CWs", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Interpolation", "[", 
      RowBox[{
       RowBox[{"Drop", "[", 
        RowBox[{
         RowBox[{"expDataPulse", "[", 
          RowBox[{"[", "#", "]"}], "]"}], ",", "1"}], "]"}], ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}], "&"}], "/@", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$dataPulsed$CBZ", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", "SOT$data$days", "}"}], ",", 
     RowBox[{"{", "SOT$data$initAbundance", "}"}], ",", 
     RowBox[{"{", "SOT$conc", "}"}], ",", "SOT$treatments", ",", 
     RowBox[{"{", "SOT$CWs", "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.638330000742478*^9, 3.6383300090735617`*^9}, 
   3.6383347903298807`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"optParSD$CAR$AF", "=", "optParSD"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"optParIT$CAR$AF", "=", "optParIT"}], 
  ";"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.653799338610482*^9, 3.6537993552991505`*^9}}],

Cell[BoxData[
 RowBox[{"TableForm", "[", 
  RowBox[{"Partition", "[", 
   RowBox[{
    RowBox[{"ShowResultScenariosx2M", "[", 
     RowBox[{"SOT$dataPulsed$CBZ", ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"SDmodel", ",", "\"\<Gammarus - CYP - SD-SIC\>\""}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"ITmodel", ",", "\"\<Gammarus - CYP - IT-SIC\>\""}], "}"}], 
      ",", "opt$Haz$BG$Pulse", ",", "opt$Haz$BG$Pulse", ",", 
      "\[IndentingNewLine]", "optParSD$CAR$AF", ",", "optParIT$CAR$AF", ",", 
      "\[IndentingNewLine]", 
      RowBox[{"tend", "=", "tEndExp"}], ",", "1"}], "]"}], ",", "2"}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.634544153238705*^9, 3.6345442114245234`*^9}, {
   3.634544243088689*^9, 3.634544273190699*^9}, {3.6345443108514647`*^9, 
   3.6345443113935194`*^9}, {3.635168768030157*^9, 3.6351687964469986`*^9}, 
   3.6356549022208214`*^9, 3.6356552472604275`*^9, 3.635658166111809*^9, {
   3.6362621965582175`*^9, 3.636262196982242*^9}, 3.638073792625766*^9, {
   3.638329935602826*^9, 3.6383299377128468`*^9}, 3.6383347917748804`*^9, {
   3.6383350567467546`*^9, 3.6383350609066715`*^9}, {3.6483729809828873`*^9, 
   3.648372982261015*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tEnd", "=", "10"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ninit", "=", "80"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"NinitPulse", "=", "80"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NinitAcute", "=", "20"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nRnd", "=", "100"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nrTr", "=", "4"}], ";"}]}], "Input",
 CellChangeTimes->{{3.636221781224609*^9, 3.6362218058454523`*^9}, {
   3.6362229798713274`*^9, 3.6362229870629396`*^9}, 3.6362232972504883`*^9, 
   3.6362234712381973`*^9, 3.6362235586571517`*^9, {3.636223628583475*^9, 
   3.6362236697755475`*^9}, {3.636223759414706*^9, 3.6362237609123087`*^9}, 
   3.6362238163492064`*^9, {3.636261628645735*^9, 3.636261631684909*^9}, 
   3.6362618903017006`*^9, {3.6362619617337866`*^9, 3.6362619647889614`*^9}, {
   3.636262019686101*^9, 3.636262027637556*^9}, {3.6362620633736*^9, 
   3.636262063581612*^9}, 3.636268073427039*^9, 3.642341920043704*^9, {
   3.642418574814764*^9, 3.642418592542778*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DATAvalsAbs", "=", 
   RowBox[{"extractSOTdataseries", "[", 
    RowBox[{"SOT$dataPulsed$CBZ", ",", 
     RowBox[{"tEnd", "=", "10"}], ",", "1", ",", 
     RowBox[{"nrTr", "=", "4"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6362650789367437`*^9, 3.636265093210764*^9}, {
   3.6362680805180492`*^9, 3.6362680842300544`*^9}, 3.6362707315414124`*^9, 
   3.6383347934448805`*^9, {3.6392896889312577`*^9, 3.6392896892272873`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DATAvalsRel", "=", 
   RowBox[{"extractSOTdataseriesRel", "[", 
    RowBox[{"SOT$dataPulsed$CBZ", ",", 
     RowBox[{"tEnd", "=", "10"}], ",", 
     RowBox[{"nrTr", "=", "4"}], ",", 
     RowBox[{"NinitX", "=", 
      RowBox[{"80", "/", "100"}]}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6382620822034197`*^9, 3.6382621100174193`*^9}, 
   3.6384464518618417`*^9, {3.6392896543908043`*^9, 3.6392896665530205`*^9}, {
   3.64241863558724*^9, 3.642418640413516*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"<<", "JLink`"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"InstallJava", "[", "]"}], ";"}], "\n", 
 RowBox[{"ReinstallJava", "[", 
  RowBox[{"JVMArguments", "\[Rule]", "\"\<-Xmx8192m\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.638280390925027*^9, 3.6382803909260273`*^9}, {
  3.6382804252014546`*^9, 3.638280431169051*^9}, {3.638288982718065*^9, 
  3.638288986122259*^9}, {3.638289052267043*^9, 3.6382890569383097`*^9}, {
  3.6384464732699823`*^9, 3.63844647514917*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"LoadJavaClass", "[", "\"\<java.lang.Runtime\>\"", "]"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.6382890378762197`*^9, 3.6382890378772197`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"java`lang`Runtime`getRuntime", "[", "]"}], "@", 
  RowBox[{"maxMemory", "[", "]"}]}]], "Input",
 CellChangeTimes->{{3.6382890446916094`*^9, 3.6382890446926093`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"deltaT", "=", "0.25"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"maxIX", "=", "1000"}], ";"}]}], "Input",
 CellChangeTimes->{{3.6383301627601013`*^9, 3.6383301686711607`*^9}, {
  3.638446582078862*^9, 3.638446583470001*^9}, {3.648210534362243*^9, 
  3.6482105439151983`*^9}, {3.6482610031948195`*^9, 3.6482610040259027`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"$CalculateNew", "=", "0"}], ";"}]], "Input",
 CellChangeTimes->{{3.648377554677211*^9, 3.648377556788422*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"$CalculateNew", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"ITpred$Total$10", "=", 
       RowBox[{"SOT$prediction$Uncertainty$Total", "[", 
        RowBox[{"SOT$dataPulsed$CBZ", ",", "ITmodel", ",", 
         RowBox[{"parSetList", "=", "paramSamplesIT"}], ",", 
         RowBox[{"optParSet", "=", "optParIT$CAR$AF"}], ",", 
         RowBox[{"BG$mort", "=", "opt$Haz$BG$Pulse"}], ",", 
         RowBox[{"repl", "=", "1"}], ",", 
         RowBox[{"tEnd", "=", "10"}], ",", 
         RowBox[{"Ninit", "=", "80"}], ",", 
         RowBox[{"nRand", "=", "10"}], ",", 
         RowBox[{"nrTr", "=", "4"}], ",", 
         RowBox[{"lcl", "=", "0.1"}], ",", 
         RowBox[{"ucl", "=", "0.9"}], ",", "deltaT", ",", "maxIX"}], "]"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"Export", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
         "\"\</CBZ-ITpred$Total$10-rawData.xlsx\>\""}], ",", 
        RowBox[{"Transpose", "[", "allNLO", "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"dataSet", "=", "ITpred$Total$10"}], ";", 
      RowBox[{"expDat", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"dataSet", "[", 
               RowBox[{"[", 
                RowBox[{"1", 
                 RowBox[{"(*", "median", "*)"}], ",", "trix"}], "]"}], "]"}], 
              "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"dataSet", "[", 
               RowBox[{"[", 
                RowBox[{"1", 
                 RowBox[{"(*", "median", "*)"}], ",", "trix"}], "]"}], "]"}], 
              "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}], ",", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"dataSet", "[", 
               RowBox[{"[", 
                RowBox[{"2", 
                 RowBox[{"(*", "lcl", "*)"}], ",", "trix"}], "]"}], "]"}], 
              "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}], ",", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"dataSet", "[", 
               RowBox[{"[", 
                RowBox[{"3", 
                 RowBox[{"(*", "ucl", "*)"}], ",", "trix"}], "]"}], "]"}], 
              "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}], ",", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"dataSet", "[", 
               RowBox[{"[", 
                RowBox[{"4", 
                 RowBox[{"(*", "det", "*)"}], ",", "trix"}], "]"}], "]"}], 
              "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], "}"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"trix", ",", "1", ",", "4"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Export", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
         "\"\</CBZ-ITpred$Total$10-summary.xlsx\>\""}], ",", "expDat"}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"SDpred$Total$10", "=", 
       RowBox[{"SOT$prediction$Uncertainty$Total", "[", 
        RowBox[{"SOT$dataPulsed$CBZ", ",", "SDmodel", ",", 
         RowBox[{"parSetList", "=", "paramSamplesSD"}], ",", 
         RowBox[{"optParSet", "=", "optParSD$CAR$AF"}], ",", 
         RowBox[{"BG$mort", "=", "opt$Haz$BG$Pulse"}], ",", 
         RowBox[{"repl", "=", "1"}], ",", 
         RowBox[{"tEnd", "=", "10"}], ",", 
         RowBox[{"Ninit", "=", "80"}], ",", 
         RowBox[{"nRand", "=", "10"}], ",", 
         RowBox[{"nrTr", "=", "4"}], ",", "0.1", ",", "0.9", ",", "deltaT", 
         ",", "maxIX"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"dataSet", "=", "SDpred$Total$10"}], ";", 
      RowBox[{"expDat", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"dataSet", "[", 
               RowBox[{"[", 
                RowBox[{"1", 
                 RowBox[{"(*", "median", "*)"}], ",", "trix"}], "]"}], "]"}], 
              "]"}], "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"dataSet", "[", 
               RowBox[{"[", 
                RowBox[{"1", 
                 RowBox[{"(*", "median", "*)"}], ",", "trix"}], "]"}], "]"}], 
              "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}], ",", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"dataSet", "[", 
               RowBox[{"[", 
                RowBox[{"2", 
                 RowBox[{"(*", "lcl", "*)"}], ",", "trix"}], "]"}], "]"}], 
              "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}], ",", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"dataSet", "[", 
               RowBox[{"[", 
                RowBox[{"3", 
                 RowBox[{"(*", "ucl", "*)"}], ",", "trix"}], "]"}], "]"}], 
              "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}], ",", 
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"dataSet", "[", 
               RowBox[{"[", 
                RowBox[{"4", 
                 RowBox[{"(*", "det", "*)"}], ",", "trix"}], "]"}], "]"}], 
              "]"}], "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], "}"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"trix", ",", "1", ",", "4"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Export", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
         "\"\</CBZ-SDpred$Total$10-summary.xlsx\>\""}], ",", "expDat"}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Export", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
         "\"\</CBZ-SDpred$Total$10-rawData.xlsx\>\""}], ",", 
        RowBox[{"Transpose", "[", "allNLO", "]"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"TableForm", "[", 
       RowBox[{"Transpose", "@", 
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"Show", "[", 
             RowBox[{
              RowBox[{"ListPlot", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"ITpred$Total$10", "[", 
                   RowBox[{"[", 
                    RowBox[{"1", ",", "trix"}], "]"}], "]"}], ",", 
                  RowBox[{"ITpred$Total$10", "[", 
                   RowBox[{"[", 
                    RowBox[{"2", ",", "trix"}], "]"}], "]"}], ",", 
                  RowBox[{"ITpred$Total$10", "[", 
                   RowBox[{"[", 
                    RowBox[{"3", ",", "trix"}], "]"}], "]"}]}], "}"}], ",", 
                RowBox[{"Joined", "\[Rule]", "True"}], ",", 
                RowBox[{"AxesOrigin", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"0", ",", "0"}], "}"}]}], ",", 
                RowBox[{"PlotRange", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"0", ",", "tEnd"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0", ",", "Ninit"}], "}"}]}], "}"}]}], ",", 
                RowBox[{"GridLines", "\[Rule]", "Automatic"}], ",", 
                RowBox[{"Frame", "\[Rule]", "True"}], ",", 
                RowBox[{"FrameLabel", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{
                  "\"\<days\>\"", ",", "\"\<Survival over time\>\"", ",", 
                   RowBox[{"\"\<IT model, T\>\"", "<>", 
                    RowBox[{"ToString", "[", "trix", "]"}]}], ",", 
                   "\"\<\>\""}], "}"}]}], ",", " ", 
                RowBox[{"GridLinesStyle", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"Directive", "[", 
                    RowBox[{"Black", ",", 
                    RowBox[{"Thickness", "[", "0.001", "]"}], ",", "Dashed"}],
                     "]"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{"Black", ",", 
                    RowBox[{"Thickness", "[", "0.001", "]"}]}], "]"}]}], 
                  "}"}]}], ",", 
                RowBox[{"BaseStyle", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"FontFamily", "->", "\"\<Arial\>\""}], ",", "30"}],
                   "}"}]}], ",", 
                RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
                RowBox[{"PlotStyle", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    RowBox[{"Thickness", "[", "0.005", "]"}], ",", "Green"}], 
                    "]"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
                    RowBox[{"Dashing", "[", 
                    RowBox[{"{", 
                    RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", 
                    "Red"}], "]"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
                    RowBox[{"Dashing", "[", 
                    RowBox[{"{", 
                    RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", 
                    "Red"}], "]"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    RowBox[{"Thickness", "[", "0.0035", "]"}], ",", 
                    RowBox[{"Dashing", "[", 
                    RowBox[{"{", 
                    RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", 
                    "Black"}], "]"}]}], "}"}]}], ",", 
                RowBox[{"Filling", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"1", "\[Rule]", 
                    RowBox[{"{", "2", "}"}]}], ",", 
                   RowBox[{"1", "\[Rule]", 
                    RowBox[{"{", "3", "}"}]}]}], "}"}]}], ",", 
                RowBox[{"FillingStyle", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"Directive", "[", 
                    RowBox[{"Red", ",", 
                    RowBox[{"Opacity", "[", "0.2", "]"}]}], "]"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{"Red", ",", 
                    RowBox[{"Opacity", "[", "0.2", "]"}]}], "]"}]}], 
                  "}"}]}]}], "]"}], ",", 
              RowBox[{"ListPlot", "[", 
               RowBox[{"DATAvalsAbs", "[", 
                RowBox[{"[", "trix", "]"}], "]"}], "]"}]}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"trix", ",", "1", ",", "3"}], "}"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"Show", "[", 
             RowBox[{
              RowBox[{"ListPlot", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"SDpred$Total$10", "[", 
                   RowBox[{"[", 
                    RowBox[{"1", ",", "trix"}], "]"}], "]"}], ",", 
                  RowBox[{"SDpred$Total$10", "[", 
                   RowBox[{"[", 
                    RowBox[{"2", ",", "trix"}], "]"}], "]"}], ",", 
                  RowBox[{"SDpred$Total$10", "[", 
                   RowBox[{"[", 
                    RowBox[{"3", ",", "trix"}], "]"}], "]"}]}], "}"}], ",", 
                RowBox[{"Joined", "\[Rule]", "True"}], ",", 
                RowBox[{"AxesOrigin", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"0", ",", "0"}], "}"}]}], ",", 
                RowBox[{"PlotRange", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"0", ",", "tEnd"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0", ",", "Ninit"}], "}"}]}], "}"}]}], ",", 
                RowBox[{"GridLines", "\[Rule]", "Automatic"}], ",", 
                RowBox[{"Frame", "\[Rule]", "True"}], ",", 
                RowBox[{"FrameLabel", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{
                  "\"\<days\>\"", ",", "\"\<Survival over time\>\"", ",", 
                   RowBox[{"\"\<SD model, T\>\"", "<>", 
                    RowBox[{"ToString", "[", "trix", "]"}]}], ",", 
                   "\"\<\>\""}], "}"}]}], ",", " ", 
                RowBox[{"GridLinesStyle", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"Directive", "[", 
                    RowBox[{"Black", ",", 
                    RowBox[{"Thickness", "[", "0.001", "]"}], ",", "Dashed"}],
                     "]"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{"Black", ",", 
                    RowBox[{"Thickness", "[", "0.001", "]"}]}], "]"}]}], 
                  "}"}]}], ",", 
                RowBox[{"BaseStyle", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"FontFamily", "->", "\"\<Arial\>\""}], ",", "30"}],
                   "}"}]}], ",", 
                RowBox[{"ImageSize", "\[Rule]", "600"}], ",", 
                RowBox[{"PlotStyle", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    RowBox[{"Thickness", "[", "0.005", "]"}], ",", "Green"}], 
                    "]"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
                    RowBox[{"Dashing", "[", 
                    RowBox[{"{", 
                    RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", 
                    "Red"}], "]"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
                    RowBox[{"Dashing", "[", 
                    RowBox[{"{", 
                    RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", 
                    "Red"}], "]"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{
                    RowBox[{"Thickness", "[", "0.0035", "]"}], ",", 
                    RowBox[{"Dashing", "[", 
                    RowBox[{"{", 
                    RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", 
                    "Black"}], "]"}]}], "}"}]}], ",", 
                RowBox[{"Filling", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"1", "\[Rule]", 
                    RowBox[{"{", "2", "}"}]}], ",", 
                   RowBox[{"1", "\[Rule]", 
                    RowBox[{"{", "3", "}"}]}]}], "}"}]}], ",", 
                RowBox[{"FillingStyle", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"Directive", "[", 
                    RowBox[{"Red", ",", 
                    RowBox[{"Opacity", "[", "0.2", "]"}]}], "]"}], ",", 
                   RowBox[{"Directive", "[", 
                    RowBox[{"Red", ",", 
                    RowBox[{"Opacity", "[", "0.2", "]"}]}], "]"}]}], 
                  "}"}]}]}], "]"}], ",", 
              RowBox[{"ListPlot", "[", 
               RowBox[{"DATAvalsAbs", "[", 
                RowBox[{"[", "trix", "]"}], "]"}], "]"}]}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"trix", ",", "1", ",", "3"}], "}"}]}], "]"}]}], "}"}]}], 
       "]"}]}]}], "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.638077500966319*^9, 3.6380775219583488`*^9}, {
   3.6380776373305225`*^9, 3.6380776589915533`*^9}, {3.638077842246813*^9, 
   3.638077844336816*^9}, {3.638081114890442*^9, 3.638081122790453*^9}, {
   3.6380818763595123`*^9, 3.6380818772795134`*^9}, 3.6380820443757486`*^9, 
   3.6382622518574195`*^9, {3.6382634846236067`*^9, 3.6382634855917034`*^9}, {
   3.638263602556399*^9, 3.6382636251336565`*^9}, {3.6382636852316656`*^9, 
   3.638263723524494*^9}, {3.6382637551626577`*^9, 3.638263799870128*^9}, 
   3.6382709521342382`*^9, {3.6382726335344086`*^9, 3.6382726459561195`*^9}, {
   3.6382727083016853`*^9, 3.63827272674974*^9}, {3.6382731222293606`*^9, 
   3.6382731226373835`*^9}, {3.638280292558098*^9, 3.6382802962130976`*^9}, {
   3.638329388262512*^9, 3.638329495924185*^9}, {3.638329590289985*^9, 
   3.6383297043475485`*^9}, {3.638330108982563*^9, 3.6383301182636557`*^9}, {
   3.6383301560500345`*^9, 3.638330196673441*^9}, {3.638334806775881*^9, 
   3.6383348120558805`*^9}, {3.6383348743058805`*^9, 
   3.6383348760068808`*^9}, {3.6383352032548265`*^9, 
   3.6383352038648143`*^9}, {3.6384464905527105`*^9, 3.638446500858741*^9}, {
   3.63844658835949*^9, 3.6384465973073845`*^9}, {3.6385895341911707`*^9, 
   3.638589575695321*^9}, {3.638589606456397*^9, 3.638589609022653*^9}, {
   3.639219509807514*^9, 3.639219510229556*^9}, {3.6392827070021725`*^9, 
   3.6392827070941267`*^9}, {3.648210552972104*^9, 3.648210557443551*^9}, {
   3.6482595939069047`*^9, 3.6482596035448685`*^9}, {3.6482825788212647`*^9, 
   3.6482825834197245`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ITpred$Total$10", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
     "\"\</CBZ-ITpred$Total$10-summary.xlsx\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SDpred$Total$10", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
     "\"\</CBZ-SDpred$Total$10-summary.xlsx\>\""}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.6385843906588764`*^9, 3.638584432156026*^9}, {
  3.638584600964905*^9, 3.6385846101648245`*^9}, {3.6385853199867997`*^9, 
  3.638585324395241*^9}}],

Cell[BoxData[
 RowBox[{"fig", "=", 
  RowBox[{"TableForm", "[", 
   RowBox[{"Transpose", "@", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Show", "[", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Transpose", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Transpose", "[", 
                   RowBox[{"ITpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"Transpose", "[", 
                   RowBox[{"ITpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "}"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Transpose", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Transpose", "[", 
                   RowBox[{"ITpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"Transpose", "[", 
                   RowBox[{"ITpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                  RowBox[{"[", "3", "]"}], "]"}]}], "}"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Transpose", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Transpose", "[", 
                   RowBox[{"ITpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"Transpose", "[", 
                   RowBox[{"ITpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                  RowBox[{"[", "4", "]"}], "]"}]}], "}"}], "]"}], ",", 
              RowBox[{"Transpose", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Transpose", "[", 
                   RowBox[{"ITpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"Transpose", "[", 
                   RowBox[{"ITpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                  RowBox[{"[", "5", "]"}], "]"}]}], "}"}], "]"}]}], "}"}], 
            ",", 
            RowBox[{"Joined", "\[Rule]", "True"}], ",", 
            RowBox[{"AxesOrigin", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0"}], "}"}]}], ",", 
            RowBox[{"PlotRange", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"0", ",", "tEnd"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", "Ninit"}], "}"}]}], "}"}]}], ",", 
            RowBox[{"GridLines", "\[Rule]", "Automatic"}], ",", 
            RowBox[{"Frame", "\[Rule]", "True"}], ",", 
            RowBox[{"FrameLabel", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"\"\<days\>\"", ",", "\"\<Survival over time\>\"", ",", 
               RowBox[{"\"\<IT model, T\>\"", "<>", 
                RowBox[{"ToString", "[", "trix", "]"}]}], ",", "\"\<\>\""}], 
              "}"}]}], ",", " ", 
            RowBox[{"GridLinesStyle", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Directive", "[", 
                RowBox[{"Black", ",", 
                 RowBox[{"Thickness", "[", "0.001", "]"}], ",", "Dashed"}], 
                "]"}], ",", 
               RowBox[{"Directive", "[", 
                RowBox[{"Black", ",", 
                 RowBox[{"Thickness", "[", "0.001", "]"}]}], "]"}]}], "}"}]}],
             ",", 
            RowBox[{"BaseStyle", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"FontFamily", "->", "\"\<Arial\>\""}], ",", "42"}], 
              "}"}]}], ",", 
            RowBox[{"ImageSize", "\[Rule]", "1200"}], ",", 
            RowBox[{"PlotStyle", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Directive", "[", 
                RowBox[{
                 RowBox[{"Thickness", "[", "0.005", "]"}], ",", "Green"}], 
                "]"}], ",", 
               RowBox[{"Directive", "[", 
                RowBox[{
                 RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
                 RowBox[{"Dashing", "[", 
                  RowBox[{"{", 
                   RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Red"}],
                 "]"}], ",", 
               RowBox[{"Directive", "[", 
                RowBox[{
                 RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
                 RowBox[{"Dashing", "[", 
                  RowBox[{"{", 
                   RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Red"}],
                 "]"}], ",", 
               RowBox[{"Directive", "[", 
                RowBox[{
                 RowBox[{"Thickness", "[", "0.0035", "]"}], ",", 
                 RowBox[{"Dashing", "[", 
                  RowBox[{"{", 
                   RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", 
                 "Black"}], "]"}]}], "}"}]}], ",", 
            RowBox[{"Filling", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"1", "\[Rule]", 
                RowBox[{"{", "2", "}"}]}], ",", 
               RowBox[{"1", "\[Rule]", 
                RowBox[{"{", "3", "}"}]}]}], "}"}]}], ",", 
            RowBox[{"FillingStyle", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Directive", "[", 
                RowBox[{"Red", ",", 
                 RowBox[{"Opacity", "[", "0.2", "]"}]}], "]"}], ",", 
               RowBox[{"Directive", "[", 
                RowBox[{"Red", ",", 
                 RowBox[{"Opacity", "[", "0.2", "]"}]}], "]"}]}], "}"}]}]}], 
           "]"}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"DATAvalsAbs", "[", 
            RowBox[{"[", "trix", "]"}], "]"}], "]"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"trix", ",", "1", ",", "4"}], "}"}]}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"Show", "[", 
         RowBox[{
          RowBox[{"ListPlot", "[", 
           RowBox[{
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Transpose", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Transpose", "[", 
                   RowBox[{"SDpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"Transpose", "[", 
                   RowBox[{"SDpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], "}"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Transpose", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Transpose", "[", 
                   RowBox[{"SDpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"Transpose", "[", 
                   RowBox[{"SDpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                  RowBox[{"[", "3", "]"}], "]"}]}], "}"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Transpose", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Transpose", "[", 
                   RowBox[{"SDpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"Transpose", "[", 
                   RowBox[{"SDpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                  RowBox[{"[", "4", "]"}], "]"}]}], "}"}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Transpose", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Transpose", "[", 
                   RowBox[{"SDpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}], ",", 
                 RowBox[{
                  RowBox[{"Transpose", "[", 
                   RowBox[{"SDpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                  RowBox[{"[", "5", "]"}], "]"}]}], "}"}], "]"}]}], "}"}], 
            ",", 
            RowBox[{"Joined", "\[Rule]", "True"}], ",", 
            RowBox[{"AxesOrigin", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0"}], "}"}]}], ",", 
            RowBox[{"PlotRange", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"0", ",", "tEnd"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"0", ",", "Ninit"}], "}"}]}], "}"}]}], ",", 
            RowBox[{"GridLines", "\[Rule]", "Automatic"}], ",", 
            RowBox[{"Frame", "\[Rule]", "True"}], ",", 
            RowBox[{"FrameLabel", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{"\"\<days\>\"", ",", "\"\<Survival over time\>\"", ",", 
               RowBox[{"\"\<SD model, T\>\"", "<>", 
                RowBox[{"ToString", "[", "trix", "]"}]}], ",", "\"\<\>\""}], 
              "}"}]}], ",", " ", 
            RowBox[{"GridLinesStyle", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Directive", "[", 
                RowBox[{"Black", ",", 
                 RowBox[{"Thickness", "[", "0.001", "]"}], ",", "Dashed"}], 
                "]"}], ",", 
               RowBox[{"Directive", "[", 
                RowBox[{"Black", ",", 
                 RowBox[{"Thickness", "[", "0.001", "]"}]}], "]"}]}], "}"}]}],
             ",", 
            RowBox[{"BaseStyle", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"FontFamily", "->", "\"\<Arial\>\""}], ",", "42"}], 
              "}"}]}], ",", 
            RowBox[{"ImageSize", "\[Rule]", "1200"}], ",", 
            RowBox[{"PlotStyle", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Directive", "[", 
                RowBox[{
                 RowBox[{"Thickness", "[", "0.005", "]"}], ",", "Green"}], 
                "]"}], ",", 
               RowBox[{"Directive", "[", 
                RowBox[{
                 RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
                 RowBox[{"Dashing", "[", 
                  RowBox[{"{", 
                   RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Red"}],
                 "]"}], ",", 
               RowBox[{"Directive", "[", 
                RowBox[{
                 RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
                 RowBox[{"Dashing", "[", 
                  RowBox[{"{", 
                   RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Red"}],
                 "]"}], ",", 
               RowBox[{"Directive", "[", 
                RowBox[{
                 RowBox[{"Thickness", "[", "0.0035", "]"}], ",", 
                 RowBox[{"Dashing", "[", 
                  RowBox[{"{", 
                   RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", 
                 "Black"}], "]"}]}], "}"}]}], ",", 
            RowBox[{"Filling", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"1", "\[Rule]", 
                RowBox[{"{", "2", "}"}]}], ",", 
               RowBox[{"1", "\[Rule]", 
                RowBox[{"{", "3", "}"}]}]}], "}"}]}], ",", 
            RowBox[{"FillingStyle", "\[Rule]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Directive", "[", 
                RowBox[{"Red", ",", 
                 RowBox[{"Opacity", "[", "0.2", "]"}]}], "]"}], ",", 
               RowBox[{"Directive", "[", 
                RowBox[{"Red", ",", 
                 RowBox[{"Opacity", "[", "0.2", "]"}]}], "]"}]}], "}"}]}]}], 
           "]"}], ",", 
          RowBox[{"ListPlot", "[", 
           RowBox[{"DATAvalsAbs", "[", 
            RowBox[{"[", "trix", "]"}], "]"}], "]"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"trix", ",", "1", ",", "4"}], "}"}]}], "]"}]}], "}"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.6385845142542343`*^9, 3.638584524351244*^9}, {
  3.638584574544263*^9, 3.638584632061014*^9}, {3.6385849742292275`*^9, 
  3.6385849846362677`*^9}, {3.638585221858988*^9, 3.6385852236791697`*^9}, {
  3.6423407849732037`*^9, 3.6423407865982037`*^9}, {3.6424185252519293`*^9, 
  3.642418525870965*^9}, {3.648352133132245*^9, 3.6483521339603276`*^9}, {
  3.648375356658431*^9, 3.6483753675055156`*^9}, {3.6483767551182632`*^9, 
  3.648376759837735*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\</CBZ-SOT-validation-absolute.gif\>\""}], ",", "fig"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.6483521414150734`*^9, 3.648352141416073*^9}, {
  3.6483521748064117`*^9, 3.6483521789498262`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"expDat", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
     "\"\</CBZ-ITpred$Total$10-summary.xlsx\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"expDatRel", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"Prepend", "[", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"expDat", "[", 
               RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"serix", "+", "1"}], "]"}], "]"}], "/", "NinitPulse"}], 
           "*", "100"}], ",", 
          RowBox[{"{", 
           RowBox[{"serix", ",", "1", ",", "4"}], "}"}]}], "]"}], ",", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"expDat", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"trix", ",", "1", ",", "nrTr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
     "\"\</CBZ-ITpred$Total$10-summary-rel.xlsx\>\""}], ",", "expDatRel"}], 
   "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"expDat", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
     "\"\</CBZ-SDpred$Total$10-summary.xlsx\>\""}], "]"}]}], ";", 
  RowBox[{"expDatRel", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"Prepend", "[", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"Transpose", "[", 
              RowBox[{"expDat", "[", 
               RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{"serix", "+", "1"}], "]"}], "]"}], "/", "NinitPulse"}], 
           "*", "100"}], ",", 
          RowBox[{"{", 
           RowBox[{"serix", ",", "1", ",", "4"}], "}"}]}], "]"}], ",", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"expDat", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"trix", ",", "1", ",", "nrTr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
     "\"\</CBZ-SDpred$Total$10-summary-rel.xlsx\>\""}], ",", "expDatRel"}], 
   "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.642387608230204*^9, 3.642387643377204*^9}, {
  3.642387699042204*^9, 3.6423877355952044`*^9}, {3.6424096446642036`*^9, 
  3.642409650884204*^9}, {3.64241854886528*^9, 3.642418555350651*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ITpred$Total$10", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
     "\"\</CBZ-ITpred$Total$10-summary-rel.xlsx\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SDpred$Total$10", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
     "\"\</CBZ-SDpred$Total$10-summary-rel.xlsx\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ITpred$Total$10$RAW", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
     "\"\</CBZ-ITpred$Total$10-rawData.xlsx\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SDpred$Total$10$RAW", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
     "\"\</CBZ-SDpred$Total$10-rawData.xlsx\>\""}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.6385843906588764`*^9, 3.638584432156026*^9}, {
  3.638584600964905*^9, 3.6385846101648245`*^9}, {3.6385855158113804`*^9, 
  3.63858551950775*^9}, {3.64230088054714*^9, 3.64230088569514*^9}, {
  3.642387392882204*^9, 3.642387397376204*^9}, {3.64846254816502*^9, 
  3.6484625484100447`*^9}, {3.6484677417693286`*^9, 3.648467753304482*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DATAvalsAbs", "=", 
   RowBox[{"extractSOTdataseries", "[", 
    RowBox[{"SOT$dataPulsed$CBZ", ",", 
     RowBox[{"tEnd", "=", "10"}], ",", "1", ",", 
     RowBox[{"nrTr", "=", "4"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6362650789367437`*^9, 3.636265093210764*^9}, {
   3.6362680805180492`*^9, 3.6362680842300544`*^9}, 3.6362707315414124`*^9, 
   3.6383347934448805`*^9, {3.6392896889312577`*^9, 3.6392896892272873`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DATAvalsRel", "=", 
   RowBox[{"extractSOTdataseriesRel", "[", 
    RowBox[{"SOT$dataPulsed$CBZ", ",", 
     RowBox[{"tEnd", "=", "10"}], ",", 
     RowBox[{"nrTr", "=", "4"}], ",", 
     RowBox[{"NinitX", "=", 
      RowBox[{"80", "/", "100"}]}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6382620822034197`*^9, 3.6382621100174193`*^9}, 
   3.6384464518618417`*^9, {3.6392896543908043`*^9, 3.6392896665530205`*^9}, {
   3.64241863558724*^9, 3.642418640413516*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"deltaT", "=", "0.25"}], ";", 
  RowBox[{"tEnd", "=", "10"}], ";", 
  RowBox[{"fig", "=", 
   RowBox[{"TableForm", "[", 
    RowBox[{"Transpose", "@", 
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Show", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"Transpose", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Range", "[", 
                   RowBox[{"0", ",", "tEnd", ",", "deltaT"}], "]"}], ",", 
                  "#"}], "}"}], "]"}], "&"}], "/@", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"ITpred$Total$10$RAW", "[", 
                  RowBox[{"[", "trix", "]"}], "]"}], "/", "NinitPulse"}], "*",
                 "100"}], ")"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"PlotStyle", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"Directive", "[", 
                RowBox[{
                 RowBox[{"Thickness", "[", "0.0075", "]"}], ",", 
                 RowBox[{"Lighter", "[", 
                  RowBox[{"Red", ",", "0.4"}], "]"}], ",", 
                 RowBox[{"Opacity", "[", "0.05", "]"}]}], "]"}], "}"}]}], ",",
              "\[IndentingNewLine]", 
             RowBox[{"LabelStyle", "\[Rule]", 
              RowBox[{"Directive", "[", "Black", "]"}]}], ",", 
             RowBox[{"FrameStyle", "\[Rule]", 
              RowBox[{"Directive", "[", 
               RowBox[{"Black", ",", 
                RowBox[{"Thickness", "[", "0.002", "]"}]}], "]"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"AxesOrigin", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"0", ",", "0"}], "}"}]}], ",", 
             RowBox[{"PlotRange", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", 
                  RowBox[{"tEnd", "+", "0.25"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "100"}], "}"}]}], "}"}]}], ",", 
             RowBox[{"GridLines", "\[Rule]", "Automatic"}], ",", 
             RowBox[{"Frame", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
               "\"\<time(days)\>\"", ",", "\"\<Survivors(%)\>\"", ",", 
                "\"\<Survival in pulsed exposure\>\"", ",", "\"\<\>\""}], 
               "}"}]}], ",", " ", 
             RowBox[{"GridLinesStyle", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Directive", "[", 
                 RowBox[{"Black", ",", 
                  RowBox[{"Thickness", "[", "0.001", "]"}], ",", "Dashed"}], 
                 "]"}], ",", 
                RowBox[{"Directive", "[", 
                 RowBox[{"Black", ",", 
                  RowBox[{"Thickness", "[", "0.001", "]"}]}], "]"}]}], 
               "}"}]}], ",", 
             RowBox[{"BaseStyle", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"FontFamily", "->", "\"\<Arial\>\""}], ",", "42"}], 
               "}"}]}], ",", 
             RowBox[{"ImageSize", "\[Rule]", "1200"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Transpose", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Transpose", "[", 
                    RowBox[{"ITpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"Transpose", "[", 
                    RowBox[{"ITpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}]}], "}"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Transpose", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Transpose", "[", 
                    RowBox[{"ITpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"Transpose", "[", 
                    RowBox[{"ITpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                   RowBox[{"[", "3", "]"}], "]"}]}], "}"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Transpose", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Transpose", "[", 
                    RowBox[{"ITpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"Transpose", "[", 
                    RowBox[{"ITpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                   RowBox[{"[", "4", "]"}], "]"}]}], "}"}], "]"}], ",", 
               RowBox[{"Transpose", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Transpose", "[", 
                    RowBox[{"ITpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"Transpose", "[", 
                    RowBox[{"ITpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                   RowBox[{"[", "5", "]"}], "]"}]}], "}"}], "]"}]}], "}"}], 
             ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"AxesOrigin", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"0", ",", "0"}], "}"}]}], ",", 
             RowBox[{"PlotRange", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", 
                  RowBox[{"tEnd", "+", "0.25"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "100"}], "}"}]}], "}"}]}], ",", 
             RowBox[{"GridLines", "\[Rule]", "Automatic"}], ",", 
             RowBox[{"Frame", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
               "\"\<time(days)\>\"", ",", "\"\<Survivors(%)\>\"", ",", 
                "\"\<Survival in pulsed exposure\>\"", ",", "\"\<\>\""}], 
               "}"}]}], ",", " ", "\[IndentingNewLine]", 
             RowBox[{"LabelStyle", "\[Rule]", 
              RowBox[{"Directive", "[", "Black", "]"}]}], ",", 
             RowBox[{"GridLinesStyle", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Directive", "[", 
                 RowBox[{"Black", ",", 
                  RowBox[{"Thickness", "[", "0.001", "]"}], ",", "Dashed"}], 
                 "]"}], ",", 
                RowBox[{"Directive", "[", 
                 RowBox[{"Black", ",", 
                  RowBox[{"Thickness", "[", "0.001", "]"}]}], "]"}]}], 
               "}"}]}], ",", 
             RowBox[{"BaseStyle", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"FontFamily", "->", "\"\<Arial\>\""}], ",", "Bold", 
                ",", "42"}], "}"}]}], ",", 
             RowBox[{"ImageSize", "\[Rule]", "1200"}], ",", 
             RowBox[{"PlotStyle", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Directive", "[", 
                 RowBox[{
                  RowBox[{"Thickness", "[", "0.005", "]"}], ",", "Green"}], 
                 "]"}], ",", 
                RowBox[{"Directive", "[", 
                 RowBox[{
                  RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
                  RowBox[{"Dashing", "[", 
                   RowBox[{"{", 
                    RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", 
                  "Red"}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                 RowBox[{
                  RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
                  RowBox[{"Dashing", "[", 
                   RowBox[{"{", 
                    RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", 
                  "Red"}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                 RowBox[{
                  RowBox[{"Thickness", "[", "0.0035", "]"}], ",", 
                  RowBox[{"Dashing", "[", 
                   RowBox[{"{", 
                    RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", 
                  "Black"}], "]"}]}], "}"}]}], ",", 
             RowBox[{"Filling", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"1", "\[Rule]", 
                 RowBox[{"{", "2", "}"}]}], ",", 
                RowBox[{"1", "\[Rule]", 
                 RowBox[{"{", "3", "}"}]}]}], "}"}]}], ",", 
             RowBox[{"FillingStyle", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Directive", "[", 
                 RowBox[{"Red", ",", 
                  RowBox[{"Opacity", "[", "0.2", "]"}]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                 RowBox[{"Red", ",", 
                  RowBox[{"Opacity", "[", "0.2", "]"}]}], "]"}]}], "}"}]}]}], 
            "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"DATAvalsRel", "[", 
              RowBox[{"[", "trix", "]"}], "]"}], ",", 
             RowBox[{"PlotMarkers", "->", 
              RowBox[{
               RowBox[{"MarkersScaledCol2", "[", 
                RowBox[{"Black", ",", 
                 RowBox[{"lighter", "=", "0"}], ",", 
                 RowBox[{"thick", "=", "0.045"}], ",", 
                 RowBox[{"filled", "=", "1"}], ",", 
                 RowBox[{"size", "=", "0.035"}]}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}]}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"DATAvalsRel", "[", 
               RowBox[{"[", 
                RowBox[{"trix", ",", 
                 RowBox[{"-", "1"}]}], "]"}], "]"}], "}"}], ",", 
             RowBox[{"PlotMarkers", "->", 
              RowBox[{
               RowBox[{"MarkersScaledCol2", "[", 
                RowBox[{"Blue", ",", 
                 RowBox[{"lighter", "=", "0"}], ",", 
                 RowBox[{"thick", "=", "0.16"}], ",", 
                 RowBox[{"filled", "=", "0"}], ",", 
                 RowBox[{"size", "=", "0.05"}]}], "]"}], "[", 
               RowBox[{"[", "3", "]"}], "]"}]}]}], "]"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"trix", ",", "1", ",", "4"}], "}"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Show", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"Transpose", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Range", "[", 
                   RowBox[{"0", ",", "tEnd", ",", "deltaT"}], "]"}], ",", 
                  "#"}], "}"}], "]"}], "&"}], "/@", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"SDpred$Total$10$RAW", "[", 
                  RowBox[{"[", "trix", "]"}], "]"}], "/", "NinitPulse"}], "*",
                 "100"}], ")"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"PlotStyle", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"Directive", "[", 
                RowBox[{
                 RowBox[{"Thickness", "[", "0.0075", "]"}], ",", 
                 RowBox[{"Lighter", "[", 
                  RowBox[{"Red", ",", "0.4"}], "]"}], ",", 
                 RowBox[{"Opacity", "[", "0.05", "]"}]}], "]"}], "}"}]}], ",",
              "\[IndentingNewLine]", 
             RowBox[{"LabelStyle", "\[Rule]", 
              RowBox[{"Directive", "[", "Black", "]"}]}], ",", 
             RowBox[{"FrameStyle", "\[Rule]", 
              RowBox[{"Directive", "[", 
               RowBox[{"Black", ",", 
                RowBox[{"Thickness", "[", "0.002", "]"}]}], "]"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"AxesOrigin", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"0", ",", "0"}], "}"}]}], ",", 
             RowBox[{"PlotRange", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", 
                  RowBox[{"tEnd", "+", "0.25"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "100"}], "}"}]}], "}"}]}], ",", 
             RowBox[{"GridLines", "\[Rule]", "Automatic"}], ",", 
             RowBox[{"Frame", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
               "\"\<time(days)\>\"", ",", "\"\<Survivors(%)\>\"", ",", 
                "\"\<Survival in pulsed exposure\>\"", ",", "\"\<\>\""}], 
               "}"}]}], ",", " ", 
             RowBox[{"GridLinesStyle", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Directive", "[", 
                 RowBox[{"Black", ",", 
                  RowBox[{"Thickness", "[", "0.001", "]"}], ",", "Dashed"}], 
                 "]"}], ",", 
                RowBox[{"Directive", "[", 
                 RowBox[{"Black", ",", 
                  RowBox[{"Thickness", "[", "0.001", "]"}]}], "]"}]}], 
               "}"}]}], ",", 
             RowBox[{"BaseStyle", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"FontFamily", "->", "\"\<Arial\>\""}], ",", "42"}], 
               "}"}]}], ",", 
             RowBox[{"ImageSize", "\[Rule]", "1200"}]}], "]"}], ",", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Transpose", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Transpose", "[", 
                    RowBox[{"SDpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"Transpose", "[", 
                    RowBox[{"SDpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                   RowBox[{"[", "2", "]"}], "]"}]}], "}"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Transpose", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Transpose", "[", 
                    RowBox[{"SDpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"Transpose", "[", 
                    RowBox[{"SDpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                   RowBox[{"[", "3", "]"}], "]"}]}], "}"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Transpose", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Transpose", "[", 
                    RowBox[{"SDpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"Transpose", "[", 
                    RowBox[{"SDpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                   RowBox[{"[", "4", "]"}], "]"}]}], "}"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"Transpose", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Transpose", "[", 
                    RowBox[{"SDpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"Transpose", "[", 
                    RowBox[{"SDpred$Total$10", "[", 
                    RowBox[{"[", "trix", "]"}], "]"}], "]"}], "[", 
                   RowBox[{"[", "5", "]"}], "]"}]}], "}"}], "]"}]}], "}"}], 
             ",", 
             RowBox[{"Joined", "\[Rule]", "True"}], ",", 
             RowBox[{"AxesOrigin", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"0", ",", "0"}], "}"}]}], ",", 
             RowBox[{"PlotRange", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", 
                  RowBox[{"tEnd", "+", "0.25"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", "100"}], "}"}]}], "}"}]}], ",", 
             RowBox[{"GridLines", "\[Rule]", "Automatic"}], ",", 
             RowBox[{"Frame", "\[Rule]", "True"}], ",", 
             RowBox[{"FrameLabel", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
               "\"\<time(days)\>\"", ",", "\"\<Survivors(%)\>\"", ",", 
                "\"\<Survival in pulsed exposure\>\"", ",", "\"\<\>\""}], 
               "}"}]}], ",", " ", 
             RowBox[{"LabelStyle", "\[Rule]", 
              RowBox[{"Directive", "[", "Black", "]"}]}], ",", 
             RowBox[{"GridLinesStyle", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Directive", "[", 
                 RowBox[{"Black", ",", 
                  RowBox[{"Thickness", "[", "0.001", "]"}], ",", "Dashed"}], 
                 "]"}], ",", 
                RowBox[{"Directive", "[", 
                 RowBox[{"Black", ",", 
                  RowBox[{"Thickness", "[", "0.001", "]"}]}], "]"}]}], 
               "}"}]}], ",", 
             RowBox[{"BaseStyle", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"FontFamily", "->", "\"\<Arial\>\""}], ",", "Bold", 
                ",", "42"}], "}"}]}], ",", 
             RowBox[{"ImageSize", "\[Rule]", "1200"}], ",", 
             RowBox[{"PlotStyle", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Directive", "[", 
                 RowBox[{
                  RowBox[{"Thickness", "[", "0.005", "]"}], ",", "Green"}], 
                 "]"}], ",", 
                RowBox[{"Directive", "[", 
                 RowBox[{
                  RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
                  RowBox[{"Dashing", "[", 
                   RowBox[{"{", 
                    RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", 
                  "Red"}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                 RowBox[{
                  RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
                  RowBox[{"Dashing", "[", 
                   RowBox[{"{", 
                    RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", 
                  "Red"}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                 RowBox[{
                  RowBox[{"Thickness", "[", "0.0035", "]"}], ",", 
                  RowBox[{"Dashing", "[", 
                   RowBox[{"{", 
                    RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", 
                  "Black"}], "]"}]}], "}"}]}], ",", 
             RowBox[{"Filling", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"1", "\[Rule]", 
                 RowBox[{"{", "2", "}"}]}], ",", 
                RowBox[{"1", "\[Rule]", 
                 RowBox[{"{", "3", "}"}]}]}], "}"}]}], ",", 
             RowBox[{"FillingStyle", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Directive", "[", 
                 RowBox[{"Red", ",", 
                  RowBox[{"Opacity", "[", "0.2", "]"}]}], "]"}], ",", 
                RowBox[{"Directive", "[", 
                 RowBox[{"Red", ",", 
                  RowBox[{"Opacity", "[", "0.2", "]"}]}], "]"}]}], "}"}]}]}], 
            "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"DATAvalsRel", "[", 
              RowBox[{"[", "trix", "]"}], "]"}], ",", 
             RowBox[{"PlotMarkers", "->", 
              RowBox[{
               RowBox[{"MarkersScaledCol2", "[", 
                RowBox[{"Black", ",", 
                 RowBox[{"lighter", "=", "0"}], ",", 
                 RowBox[{"thick", "=", "0.045"}], ",", 
                 RowBox[{"filled", "=", "1"}], ",", 
                 RowBox[{"size", "=", "0.035"}]}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}]}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"ListPlot", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"DATAvalsRel", "[", 
               RowBox[{"[", 
                RowBox[{"trix", ",", 
                 RowBox[{"-", "1"}]}], "]"}], "]"}], "}"}], ",", 
             RowBox[{"PlotMarkers", "->", 
              RowBox[{
               RowBox[{"MarkersScaledCol2", "[", 
                RowBox[{"Blue", ",", 
                 RowBox[{"lighter", "=", "0"}], ",", 
                 RowBox[{"thick", "=", "0.16"}], ",", 
                 RowBox[{"filled", "=", "0"}], ",", 
                 RowBox[{"size", "=", "0.05"}]}], "]"}], "[", 
               RowBox[{"[", "3", "]"}], "]"}]}]}], "]"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"trix", ",", "1", ",", "4"}], "}"}]}], "]"}]}], "}"}]}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6385845142542343`*^9, 3.638584524351244*^9}, {
   3.638584574544263*^9, 3.638584632061014*^9}, {3.6385849742292275`*^9, 
   3.6385849846362677`*^9}, {3.638585221858988*^9, 3.6385852236791697`*^9}, {
   3.6390571869847956`*^9, 3.639057187892886*^9}, {3.64230112365594*^9, 
   3.6423011737285395`*^9}, {3.64230164021474*^9, 3.6423016428823395`*^9}, {
   3.642309335020149*^9, 3.6423093357074237`*^9}, 3.642309436620455*^9, 
   3.6423094676206536`*^9, {3.642323768377136*^9, 3.6423237690271363`*^9}, {
   3.642330592187204*^9, 3.642330641562204*^9}, 3.642330681358204*^9, {
   3.642393886947204*^9, 3.642393891842204*^9}, {3.642393930320204*^9, 
   3.6423939415362043`*^9}, {3.6423940290512037`*^9, 3.642394032002204*^9}, {
   3.642394103896204*^9, 3.642394106263204*^9}, {3.6423941508782043`*^9, 
   3.6423942086422043`*^9}, {3.6423946404182043`*^9, 3.642394705949204*^9}, {
   3.642394751820204*^9, 3.642394751947204*^9}, {3.648443161575433*^9, 
   3.648443170906366*^9}, {3.648450062485577*^9, 3.648450067406069*^9}, {
   3.6484502442817545`*^9, 3.6484503008364096`*^9}, 3.6484512842587423`*^9, {
   3.6484513515084667`*^9, 3.648451357760092*^9}, {3.648451584135727*^9, 
   3.6484515881451273`*^9}, {3.6484529467369733`*^9, 3.648452951853485*^9}, {
   3.6484545086701508`*^9, 3.6484545687621593`*^9}, {3.64845465647593*^9, 
   3.648454660508333*^9}, {3.648462659095112*^9, 3.6484626621024127`*^9}, {
   3.648462759050106*^9, 3.648462769747176*^9}, {3.6484628006332645`*^9, 
   3.6484628030665073`*^9}, {3.6537994223408537`*^9, 
   3.6537994291245327`*^9}, {3.65380057732926*^9, 3.653800583525879*^9}, 
   3.653803567747743*^9, {3.6538051358655396`*^9, 3.653805157550708*^9}, {
   3.653805234310383*^9, 3.6538052430182533`*^9}, {3.6538065824202023`*^9, 
   3.6538066173900814`*^9}}],

Cell[BoxData[{
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\</CBZ-SOT-validation-relative-SD-T1.gif\>\""}], ",", 
   RowBox[{"fig", "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "1", ",", "2"}], "]"}], "]"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\</CBZ-SOT-validation-relative-IT-T1.gif\>\""}], ",", 
   RowBox[{"fig", "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "1", ",", "1"}], "]"}], "]"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\</CBZ-SOT-validation-relative-SD-T2.gif\>\""}], ",", 
   RowBox[{"fig", "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "2", ",", "2"}], "]"}], "]"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\</CBZ-SOT-validation-relative-IT-T2.gif\>\""}], ",", 
   RowBox[{"fig", "[", 
    RowBox[{"[", 
     RowBox[{"1", ",", "2", ",", "1"}], "]"}], "]"}]}], 
  "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.648351579345872*^9, 3.64835158672961*^9}, {
   3.648451294279744*^9, 3.648451308231139*^9}, {3.648467768994051*^9, 
   3.6484677715533066`*^9}, 3.6538052584507966`*^9, 3.653805744264228*^9}],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"survivalDataPulsed", "=", 
     RowBox[{"Import", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
        "\"\<\\\\input/Pulse Tox Survival - Carbendazim - Gpulex.txt\>\""}], 
       ",", "\"\<Table\>\""}], "]"}]}], ";", 
    RowBox[{"ITpred$Total$10", "=", 
     RowBox[{"Import", "[", 
      RowBox[{
       RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
       "\"\</CBZ-ITpred$Total$10-summary.xlsx\>\""}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"SDpred$Total$10", "=", 
     RowBox[{"Import", "[", 
      RowBox[{
       RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
       "\"\</CBZ-SDpred$Total$10-summary.xlsx\>\""}], "]"}]}], 
    ";"}]}]}]], "Input",
 CellChangeTimes->{{3.6385843906588764`*^9, 3.638584432156026*^9}, {
  3.638584600964905*^9, 3.6385846101648245`*^9}, {3.6385853199867997`*^9, 
  3.638585324395241*^9}, {3.6484736861517076`*^9, 3.6484736868217745`*^9}}],

Cell[BoxData[
 RowBox[{"res", "=", 
  RowBox[{"GOFPredictions", "[", 
   RowBox[{"survivalDataPulsed", ",", "ITpred$Total$10"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.643687796618752*^9, 3.6436877968995523`*^9}, {
  3.643689771526911*^9, 3.643689787505825*^9}, {3.6436898445260863`*^9, 
  3.6436898446090913`*^9}, {3.6436899001102657`*^9, 3.6436899004182835`*^9}, {
  3.6436923747627215`*^9, 3.643692375052722*^9}, {3.643692889764558*^9, 
  3.6436928899845705`*^9}}],

Cell[BoxData[
 RowBox[{"res", "=", 
  RowBox[{"GOFPredictions", "[", 
   RowBox[{"survivalDataPulsed", ",", "SDpred$Total$10"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.643690584195393*^9, 3.643690584774426*^9}, {
  3.6436923811957884`*^9, 3.6436923815287895`*^9}, {3.6436929112567873`*^9, 
  3.643692911443798*^9}}],

Cell[BoxData[
 RowBox[{"InvChiSquare", "[", 
  RowBox[{
   RowBox[{"9", "-", "3"}], ",", 
   RowBox[{"\[Alpha]", "=", "0.95"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.648470399002025*^9, 3.6484704069708223`*^9}, {
   3.6484705140625305`*^9, 3.6484705148546095`*^9}, 3.6484767699630575`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Creating  a dose-response relationship incl uncertainty", "Title",
 CellChangeTimes->{{3.638338774347769*^9, 3.638338797269998*^9}, {
  3.6482226114138794`*^9, 3.648222613069045*^9}, {3.648272460831785*^9, 
  3.6482724630635624`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
      "\"\<\\\\input/LC50 Survival - Carbendazim - Gpulex.txt\>\""}], ",", 
     "\"\<Table\>\""}], "]"}]}], ";", 
  RowBox[{"data", "//", "TableForm"}]}]], "Input",
 CellChangeTimes->{{3.6331843103662753`*^9, 3.63318436701394*^9}, {
   3.63318448482872*^9, 3.6331844851337504`*^9}, 3.6331886244616413`*^9, 
   3.6345318030257883`*^9, {3.634531883220807*^9, 3.634531883628848*^9}, {
   3.6345319563361177`*^9, 3.6345319660230865`*^9}, {3.634541227545355*^9, 
   3.6345412497773547`*^9}, {3.6385891813769*^9, 3.6385891890806704`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"expData", "=", 
    RowBox[{
     RowBox[{
      RowBox[{"Import", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
         "\"\<\\\\input/Cw - Carbendazim - \>\"", "<>", "#", "<>", 
         "\"\<.txt\>\""}], ",", "\"\<Table\>\""}], "]"}], "&"}], "/@", 
     RowBox[{"{", 
      RowBox[{
      "\"\<E\>\"", ",", "\"\<F\>\"", ",", "\"\<G\>\"", ",", "\"\<H\>\"", ",", 
       "\"\<I\>\"", ",", "\"\<J\>\"", ",", "\"\<K\>\"", ",", "\"\<L\>\""}], 
      "}"}]}]}], ";", 
   RowBox[{"expData", "//", "TableForm"}]}], "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.633184508071044*^9, 3.633184530813318*^9}, {
   3.633184601384374*^9, 3.6331846698522205`*^9}, {3.6331847147507095`*^9, 
   3.633184718238058*^9}, 3.633188638758071*^9, 3.6345318067221584`*^9, {
   3.6345318863821235`*^9, 3.6345319230357885`*^9}, {3.6345319722177057`*^9, 
   3.6345319723767223`*^9}, {3.6345412444763546`*^9, 3.634541246616355*^9}, 
   3.638589488439596*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"opt$Haz$BG$B", "=", "0.024308185413343526"}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.638340242047469*^9, 3.638340243248481*^9}, 
   3.6384449848792114`*^9, {3.638589642045955*^9, 3.6385896453412848`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"tvefunc", "[", 
    RowBox[{"t_", ",", "dur_", ",", "conc_"}], "]"}], ":=", 
   RowBox[{"Piecewise", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"conc", ",", 
         RowBox[{"t", "<", "dur"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"t", "\[GreaterEqual]", "dur"}]}], "}"}]}], "}"}], ",", 
     "0"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SOT$data$days", "=", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "2", ",", "3", ",", "4"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"noTreats", "=", 
   RowBox[{
    RowBox[{"Length", "[", 
     RowBox[{"data", "[", 
      RowBox[{"[", "2", "]"}], "]"}], "]"}], "-", "1"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$data$initAbundance", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"data", "[", 
      RowBox[{"[", 
       RowBox[{"2", ",", "i"}], "]"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "2", ",", 
       RowBox[{"noTreats", "+", "1"}]}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$concOrig", "=", 
   RowBox[{"Reverse", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"expData", "[", 
       RowBox[{"[", 
        RowBox[{"i", ",", "2", ",", "2"}], "]"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "noTreats"}], "}"}]}], "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"SOT$treatmentsOrig", "=", 
  RowBox[{"Reverse", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"N", "@", 
      RowBox[{"(", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Drop", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Transpose", "[", "data", "]"}], "[", 
            RowBox[{"[", 
             RowBox[{"#", "+", "1"}], "]"}], "]"}], ",", "1"}], "]"}], "/", 
         RowBox[{"SOT$data$initAbundance", "[", 
          RowBox[{"[", "#", "]"}], "]"}]}], ")"}], ")"}]}], "&"}], "/@", 
    RowBox[{"Range", "[", "noTreats", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$CWs", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"tvefunc", "[", 
      RowBox[{"t", ",", "4", ",", "#"}], "]"}], "&"}], "/@", "SOT$conc"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$data$CBZ", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", "SOT$data$days", "}"}], ",", 
     RowBox[{"{", "SOT$data$initAbundance", "}"}], ",", 
     RowBox[{"{", "SOT$concOrig", "}"}], ",", "SOT$treatmentsOrig", ",", 
     RowBox[{"{", "SOT$CWs", "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{"TableForm", "[", 
  RowBox[{
   RowBox[{"SOT$data$CBZ", "[", 
    RowBox[{"[", 
     RowBox[{"4", ";;", "11"}], "]"}], "]"}], ",", 
   RowBox[{"TableHeadings", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"SOT$data$CBZ", "[", 
       RowBox[{"[", "3", "]"}], "]"}], ",", 
      RowBox[{"SOT$data$CBZ", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}]}], "]"}]}], "Input",
 CellChangeTimes->{
  3.6383404853769464`*^9, {3.638445215569211*^9, 3.6384452224802113`*^9}, {
   3.638587584421221*^9, 3.6385875900447826`*^9}, {3.6385896704637966`*^9, 
   3.6385896805608063`*^9}}],

Cell[CellGroupData[{

Cell["Exposure levels in the experiments exponentially increasing", "Chapter",
 CellChangeTimes->{{3.6384416248161483`*^9, 3.638441643330595*^9}, {
  3.648222616013339*^9, 3.6482226171654544`*^9}, {3.6483768443331833`*^9, 
  3.6483768453402843`*^9}}],

Cell[BoxData[
 RowBox[{"SOT$data$CBZ", "[", 
  RowBox[{"[", "3", "]"}], "]"}]], "Input",
 CellChangeTimes->{3.6385896839681473`*^9}],

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{"Log", "@", 
   RowBox[{"SOT$data$CBZ", "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.638338262814845*^9, 3.6383382661048126`*^9}, {
   3.6383383177022963`*^9, 3.6383383460170135`*^9}, {3.6383584639492435`*^9, 
   3.6383584795401525`*^9}, 3.638589687775528*^9}],

Cell[BoxData[
 RowBox[{"Log", "[", 
  RowBox[{"SOT$data$CBZ", "[", 
   RowBox[{"[", "3", "]"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.6383383853307486`*^9, 3.638338388610749*^9}, 
   3.6385909150276184`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Make up an exposure series also exponentially increasing", "Chapter",
 CellChangeTimes->{{3.638441650628619*^9, 3.6384416628416386`*^9}, {
  3.638441716438771*^9, 3.638441717051525*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"DR$exp$data", "=", 
   RowBox[{"Prepend", "[", 
    RowBox[{
     RowBox[{"Exp", "[", 
      RowBox[{"Range", "[", 
       RowBox[{"0.9", ",", "10.9", ",", "0.25"}], "]"}], "]"}], ",", "0"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"nrExp", "=", 
  RowBox[{"Length", "[", "DR$exp$data", "]"}]}]}], "Input",
 CellChangeTimes->{{3.638338561378749*^9, 3.638338577720749*^9}, {
   3.63834074636456*^9, 3.638340752274619*^9}, {3.6383459516183043`*^9, 
   3.638345967910327*^9}, 3.63859098064618*^9, {3.638592430453146*^9, 
   3.638592430480149*^9}, {3.638593243048397*^9, 3.6385932430774*^9}, {
   3.6386859324983315`*^9, 3.638685932741356*^9}, {3.6386859717922606`*^9, 
   3.638685972040285*^9}, 3.6386864891385603`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Create a corresponding dataset, survival data is not used hence dummy values\
\>", "Chapter",
 CellChangeTimes->{{3.638441671948923*^9, 3.638441713990773*^9}, {
  3.638587602835062*^9, 3.638587604283207*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"tvefunc", "[", 
    RowBox[{"t_", ",", "dur_", ",", "conc_"}], "]"}], ":=", 
   RowBox[{"Piecewise", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"conc", ",", 
         RowBox[{"t", "<", "dur"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"t", "\[GreaterEqual]", "dur"}]}], "}"}]}], "}"}], ",", 
     "0"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SOT$data$days", "=", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "2", ",", "3", ",", "4"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"noTreats", "=", "nrExp"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$data$initAbundance", "=", 
   RowBox[{"Table", "[", 
    RowBox[{"20", ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "noTreats"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$conc", "=", "DR$exp$data"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$treatments", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0.9", ",", "0.8", ",", "0.7", ",", "0.6"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "noTreats"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$CWs", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"tvefunc", "[", 
      RowBox[{"t", ",", "4", ",", "#"}], "]"}], "&"}], "/@", "SOT$conc"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$data$CBZ$DR", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", "SOT$data$days", "}"}], ",", 
     RowBox[{"{", "SOT$data$initAbundance", "}"}], ",", 
     RowBox[{"{", "SOT$conc", "}"}], ",", "SOT$treatments", ",", 
     RowBox[{"{", "SOT$CWs", "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{"TableForm", "[", 
  RowBox[{
   RowBox[{"SOT$data$CBZ$DR", "[", 
    RowBox[{"[", 
     RowBox[{"4", ";;", 
      RowBox[{"nrExp", "+", "3"}]}], "]"}], "]"}], ",", 
   RowBox[{"TableHeadings", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"SOT$data$CBZ$DR", "[", 
       RowBox[{"[", "3", "]"}], "]"}], ",", 
      RowBox[{"SOT$data$CBZ$DR", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.638338534805749*^9, 3.6383385504077487`*^9}, {
   3.638338585423749*^9, 3.638338638338749*^9}, {3.63833867656279*^9, 
   3.638338694504969*^9}, {3.6383387377834024`*^9, 3.6383387555455804`*^9}, {
   3.638339139083154*^9, 3.6383391682851543`*^9}, {3.6383395712521544`*^9, 
   3.638339611150154*^9}, {3.6383397756397867`*^9, 3.6383397821708517`*^9}, 
   3.6383459721523333`*^9, 3.6383583058711734`*^9, 3.638590989399055*^9, {
   3.6385910208562*^9, 3.63859102775189*^9}, {3.6385924389729977`*^9, 
   3.6385924609871993`*^9}, {3.6385932536794605`*^9, 3.638593253724465*^9}, {
   3.6386859439234743`*^9, 3.6386859800010815`*^9}, {3.6392200788554134`*^9, 
   3.6392200789744253`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Now calculate predictions of survival after 4 days for the complete exposure \
series\
\>", "Chapter",
 CellChangeTimes->{{3.638441705120392*^9, 3.638441732693143*^9}, {
  3.638443530935268*^9, 3.638443544657268*^9}, {3.648222622348973*^9, 
  3.6482226232130594`*^9}}],

Cell[BoxData["opt$Haz$BG$B"], "Input"],

Cell[BoxData[
 RowBox[{"$CalculateNew", "=", "0"}]], "Input",
 CellChangeTimes->{{3.643518375043511*^9, 3.6435183754935107`*^9}, {
  3.6482105807488813`*^9, 3.648210582084015*^9}, {3.6483768611028605`*^9, 
  3.6483768614458947`*^9}, {3.6485579887402263`*^9, 3.6485579896450377`*^9}, {
  3.6539189718325624`*^9, 3.6539189722956095`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"IXmaxFix", "=", "1000"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"NinitAcute", "=", "20"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"opt$Haz$BG$B", "=", "0.056352933607966275`"}], ";"}]}], "Input",
 CellChangeTimes->{{3.6386863065553036`*^9, 3.638686319302578*^9}, {
   3.6386875118330607`*^9, 3.6386875119960775`*^9}, {3.6392195425967927`*^9, 
   3.63921954277281*^9}, 3.639220184779004*^9, {3.6392205776592884`*^9, 
   3.639220577896312*^9}, {3.639220675344056*^9, 3.639220681693691*^9}, {
   3.6392827530521355`*^9, 3.6392827550321455`*^9}, {3.639289941469903*^9, 
   3.639289947688525*^9}, 3.648265780310521*^9}],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{"$CalculateNew", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
   RowBox[{"ITpred$Total$N10$DR", "=", "\[IndentingNewLine]", 
    RowBox[{"SOT$prediction$Uncertainty$Total", "[", "\[IndentingNewLine]", 
     RowBox[{
     "SOT$data$CBZ$DR", ",", "\[IndentingNewLine]", "ITmodel", ",", 
      "\[IndentingNewLine]", 
      RowBox[{"parSetList", "=", "paramSamplesIT"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"optParSet", "=", "optParIT$CAR$AF"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"BG$mort", "=", "opt$Haz$BG$B"}], ",", "\[IndentingNewLine]", 
      RowBox[{"repl", "=", "1"}], ",", 
      RowBox[{"tEnd", "=", "4"}], ",", 
      RowBox[{"Ninit", "=", "NinitAcute"}], ",", 
      RowBox[{"nRand", "=", "10"}], ",", 
      RowBox[{"nrTr", "=", "nrExp"}], ",", 
      RowBox[{"lcl", "=", "0.1"}], ",", 
      RowBox[{"ucl", "=", "0.9"}], ",", 
      RowBox[{"deltaT", "=", "4"}], ",", 
      RowBox[{"IXmax", "=", "IXmaxFix"}]}], "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6383389580586076`*^9, 3.6383390026940546`*^9}, {
   3.6383390464054933`*^9, 3.6383390579866095`*^9}, {3.638339537288154*^9, 
   3.638339552261154*^9}, {3.638339680938154*^9, 3.638339694499154*^9}, 
   3.6383397367643976`*^9, {3.6383406159762545`*^9, 3.6383406542126374`*^9}, {
   3.6383427543476505`*^9, 3.638342792161029*^9}, {3.63834361976929*^9, 
   3.6383436326081123`*^9}, 3.6383459754423375`*^9, {3.6383468176695223`*^9, 
   3.6383468300705395`*^9}, {3.6383509023945475`*^9, 3.6383509028545485`*^9}, 
   3.6384417514195013`*^9, {3.638586219617754*^9, 3.638586246161408*^9}, 
   3.638587094916275*^9, 3.6385871260953927`*^9, {3.6385872345032325`*^9, 
   3.6385872354363256`*^9}, {3.638591003782493*^9, 3.6385910754406586`*^9}, {
   3.638592163224426*^9, 3.6385921817292757`*^9}, 3.6385922417002726`*^9, 
   3.638686314732121*^9, {3.6386866142960744`*^9, 3.6386866167963247`*^9}, 
   3.639183910573043*^9, {3.639219765673098*^9, 3.6392197692804585`*^9}, {
   3.639219962361765*^9, 3.6392199639839272`*^9}, {3.6392200141959476`*^9, 
   3.639220015291057*^9}, {3.6392201265921865`*^9, 3.6392201266541924`*^9}, {
   3.6392205724107637`*^9, 3.639220600132536*^9}, 3.6392206870812297`*^9, {
   3.6424188954211016`*^9, 3.642418897089197*^9}, 3.6435183887865105`*^9}],

Cell[BoxData["ITpred$Total$N10$DR"], "Input"],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.648716713162289*^9, 3.6487167133003025`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"ITpred$Total$N10$DR", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "16"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "16"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "16"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "16"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "16"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "16"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "16"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "16"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "16"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "16"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "16"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "16"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "16"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "16"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "16"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "14"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "13"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "11"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "9"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "7"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "5"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "4"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "2"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "2"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "1"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "9"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "5"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "9"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "8"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "9"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "8"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "9"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "8"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "8"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "6"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "9"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "9"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "7"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "8"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "7"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "6"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "6"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "5"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "4"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "3"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "2"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "1"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "19"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "17"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "12"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "12"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "10"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "9"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "8"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "7"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "7"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "5"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "5"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "4"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "4"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "3"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "2"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "2"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "2"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "2"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "2"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "1"}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15.96375019625501`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15.962946618862068`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15.962452089978985`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15.96165326347318`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15.960362960739143`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15.958278969965454`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15.954913517376696`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15.949479763790357`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15.940709571236088`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15.926562040752081`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15.903760258009601`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15.867062520275843`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15.808135278964903`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15.713859865273152`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15.563914641277144`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15.327637891915964`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "14.96073505241047`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "14.403745222095779`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "13.586596677912798`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "12.445953641568684`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "10.959577046750566`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "9.18711882748762`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "7.2840617107603345`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "5.457727257748088`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "3.8843804866185283`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "2.6501833399238577`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "1.751278136921306`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "1.131359588838263`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0.7197670701356476`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0.4533367174217475`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0.28369335213078223`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0.17680866006015275`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0.10991171076514025`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0.06821637880971826`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0.0422960956479963`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0.02620854367001592`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0.01623374132072684`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0.010052889671111388`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0.006224423432812961`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0.003853609052607248`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0.0023856767743232923`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0.001476863427284567`"}], "}"}]}], "}"}]}], 
      "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6483754228570504`*^9, 3.648375433139078*^9}, 
   3.648716718003773*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"labels", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "2"}], ",", 
       "\"\<\!\(\*SuperscriptBox[\(10\), \(-2\)]\)\>\""}], " ", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", 
       "\"\<\!\(\*SuperscriptBox[\(10\), \(-1\)]\)\>\""}], " ", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "\"\<\!\(\*SuperscriptBox[\(10\), \(0\)]\)\>\""}], 
      " ", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "\"\<\!\(\*SuperscriptBox[\(10\), \(1\)]\)\>\""}], 
      " ", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "\"\<\!\(\*SuperscriptBox[\(10\), \(2\)]\)\>\""}], 
      " ", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "\"\<\!\(\*SuperscriptBox[\(10\), \(3\)]\)\>\""}], 
      " ", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "\"\<\!\(\*SuperscriptBox[\(10\), \(4\)]\)\>\""}], 
      " ", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "\"\<\!\(\*SuperscriptBox[\(10\), \(5\)]\)\>\""}], 
      " ", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6", ",", "\"\<\!\(\*SuperscriptBox[\(10\), \(6\)]\)\>\""}], 
      " ", "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"7", ",", "\"\<\!\(\*SuperscriptBox[\(10\), \(7\)]\)\>\""}], 
      " ", "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{3.6424189541404605`*^9}],

Cell[BoxData[
 RowBox[{"fig", "=", 
  RowBox[{"ListPlot", "[", 
   RowBox[{
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitAcute"}], "*", 
            RowBox[{
             RowBox[{"ITpred$Total$N10$DR", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"1", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitAcute"}], "*", 
            RowBox[{
             RowBox[{"ITpred$Total$N10$DR", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"2", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitAcute"}], "*", 
            RowBox[{
             RowBox[{"ITpred$Total$N10$DR", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"3", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitAcute"}], "*", 
            RowBox[{
             RowBox[{"ITpred$Total$N10$DR", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"4", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"10", ",", 
            RowBox[{"SOT$concOrig", "[", 
             RowBox[{"[", "ix", "]"}], "]"}]}], "]"}], ",", 
          RowBox[{"100", "*", 
           RowBox[{"SOT$treatmentsOrig", "[", 
            RowBox[{"[", 
             RowBox[{"ix", ",", 
              RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"ix", ",", "1", ",", "8"}], "}"}]}], "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0.3", ",", "4.8"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2.5"}], ",", "105"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"AxesOrigin", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "3"}], ",", "0"}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"Joined", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"True", ",", "True", ",", "True", ",", "True", ",", "False"}], 
      "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"GridLines", "\[Rule]", "Automatic"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
    RowBox[{"FrameTicks", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"labels", ",", "Automatic", ",", "None", ",", "Automatic"}], 
      "}"}]}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<\!\(\*SubscriptBox[\(PEC\), \(max\)]\) concentration [nmol \
\!\(\*SuperscriptBox[\(L\), \(-1\)]\)]\>\"", ",", "\"\<Survivors(%)\>\"", 
       ",", "\"\<Day 4 of acute test\>\"", ",", "\"\<\>\""}], "}"}]}], ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"Directive", "[", "Black", "]"}]}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{"Black", ",", 
       RowBox[{"Thickness", "[", "0.002", "]"}]}], "]"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"GridLinesStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Directive", "[", 
        RowBox[{"Black", ",", 
         RowBox[{"Thickness", "[", "0.001", "]"}], ",", "Dashed"}], "]"}], 
       ",", 
       RowBox[{"Directive", "[", 
        RowBox[{"Black", ",", 
         RowBox[{"Thickness", "[", "0.001", "]"}]}], "]"}]}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"FontFamily", "->", "\"\<Arial\>\""}], ",", "Bold", ",", 
       "55"}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "1800"}], ",", 
    RowBox[{"PlotMarkers", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<\>\"", ",", "\"\<\>\"", ",", "\"\<\>\"", ",", "\"\<\>\"", ",", 
       RowBox[{
        RowBox[{"MarkersScaledCol2", "[", 
         RowBox[{"Red", ",", 
          RowBox[{"lighter", "=", "0"}], ",", 
          RowBox[{"thick", "=", "0.045"}], ",", 
          RowBox[{"filled", "=", "1"}], ",", 
          RowBox[{"size", "=", "0.05"}]}], "]"}], "[", 
        RowBox[{"[", "3", "]"}], "]"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.005", "]"}], ",", "Green"}], "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Orange"}], 
        "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Orange"}], 
        "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0035", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Black"}], 
        "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Blue"}], 
        "]"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"Filling", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", "2", "}"}]}], ",", 
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", "3", "}"}]}]}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"FillingStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Directive", "[", 
        RowBox[{"Orange", ",", 
         RowBox[{"Opacity", "[", "0.2", "]"}]}], "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{"Orange", ",", 
         RowBox[{"Opacity", "[", "0.2", "]"}]}], "]"}]}], "}"}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{3.648468122780426*^9}],

Cell[BoxData[
 RowBox[{"fig", "=", 
  RowBox[{"ListPlot", "[", 
   RowBox[{
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitAcute"}], "*", 
            RowBox[{
             RowBox[{"ITpred$Total$N10$DR", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"1", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitAcute"}], "*", 
            RowBox[{
             RowBox[{"ITpred$Total$N10$DR", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"2", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitAcute"}], "*", 
            RowBox[{
             RowBox[{"ITpred$Total$N10$DR", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"3", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitAcute"}], "*", 
            RowBox[{
             RowBox[{"ITpred$Total$N10$DR", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"4", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", 
           RowBox[{"SOT$concOrig", "[", 
            RowBox[{"[", 
             RowBox[{"ix", "=", "1"}], "]"}], "]"}]}], "]"}], ",", 
         RowBox[{"100", "*", 
          RowBox[{"SOT$treatmentsOrig", "[", 
           RowBox[{"[", 
            RowBox[{"ix", ",", 
             RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", 
           RowBox[{"SOT$concOrig", "[", 
            RowBox[{"[", 
             RowBox[{"ix", "=", "2"}], "]"}], "]"}]}], "]"}], ",", 
         RowBox[{"100", "*", 
          RowBox[{"SOT$treatmentsOrig", "[", 
           RowBox[{"[", 
            RowBox[{"ix", ",", 
             RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", 
           RowBox[{"SOT$concOrig", "[", 
            RowBox[{"[", 
             RowBox[{"ix", "=", "3"}], "]"}], "]"}]}], "]"}], ",", 
         RowBox[{"100", "*", 
          RowBox[{"SOT$treatmentsOrig", "[", 
           RowBox[{"[", 
            RowBox[{"ix", ",", 
             RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", 
           RowBox[{"SOT$concOrig", "[", 
            RowBox[{"[", 
             RowBox[{"ix", "=", "4"}], "]"}], "]"}]}], "]"}], ",", 
         RowBox[{"100", "*", 
          RowBox[{"SOT$treatmentsOrig", "[", 
           RowBox[{"[", 
            RowBox[{"ix", ",", 
             RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", 
           RowBox[{"SOT$concOrig", "[", 
            RowBox[{"[", 
             RowBox[{"ix", "=", "5"}], "]"}], "]"}]}], "]"}], ",", 
         RowBox[{"100", "*", 
          RowBox[{"SOT$treatmentsOrig", "[", 
           RowBox[{"[", 
            RowBox[{"ix", ",", 
             RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", 
           RowBox[{"SOT$concOrig", "[", 
            RowBox[{"[", 
             RowBox[{"ix", "=", "6"}], "]"}], "]"}]}], "]"}], ",", 
         RowBox[{"100", "*", 
          RowBox[{"SOT$treatmentsOrig", "[", 
           RowBox[{"[", 
            RowBox[{"ix", ",", 
             RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", 
           RowBox[{"SOT$concOrig", "[", 
            RowBox[{"[", 
             RowBox[{"ix", "=", "7"}], "]"}], "]"}]}], "]"}], ",", 
         RowBox[{"100", "*", 
          RowBox[{"SOT$treatmentsOrig", "[", 
           RowBox[{"[", 
            RowBox[{"ix", ",", 
             RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", 
           RowBox[{"SOT$concOrig", "[", 
            RowBox[{"[", 
             RowBox[{"ix", "=", "8"}], "]"}], "]"}]}], "]"}], ",", 
         RowBox[{"100", "*", 
          RowBox[{"SOT$treatmentsOrig", "[", 
           RowBox[{"[", 
            RowBox[{"ix", ",", 
             RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], "}"}]}], 
     "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0.3", ",", "4.8"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2.5"}], ",", "105"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"AxesOrigin", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "3"}], ",", "0"}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"Joined", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"True", ",", "True", ",", "True", ",", "True", ",", "False"}], 
      "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"GridLines", "\[Rule]", "Automatic"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
    RowBox[{"FrameTicks", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"labels", ",", "Automatic", ",", "None", ",", "Automatic"}], 
      "}"}]}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<\!\(\*SubscriptBox[\(PEC\), \(max\)]\) concentration [nmol \
\!\(\*SuperscriptBox[\(L\), \(-1\)]\)]\>\"", ",", "\"\<Survivors(%)\>\"", 
       ",", "\"\<Day 4 of acute test\>\"", ",", "\"\<\>\""}], "}"}]}], ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"Directive", "[", "Black", "]"}]}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{"Black", ",", 
       RowBox[{"Thickness", "[", "0.002", "]"}]}], "]"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"GridLinesStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Directive", "[", 
        RowBox[{"Black", ",", 
         RowBox[{"Thickness", "[", "0.001", "]"}], ",", "Dashed"}], "]"}], 
       ",", 
       RowBox[{"Directive", "[", 
        RowBox[{"Black", ",", 
         RowBox[{"Thickness", "[", "0.001", "]"}]}], "]"}]}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"FontFamily", "->", "\"\<Arial\>\""}], ",", "Bold", ",", 
       "55"}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "1800"}], ",", 
    RowBox[{"PlotMarkers", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<\>\"", ",", "\"\<\>\"", ",", "\"\<\>\"", ",", "\"\<\>\"", ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"MarkersScaledCol2", "[", 
         RowBox[{"Red", ",", 
          RowBox[{"lighter", "=", "0"}], ",", 
          RowBox[{"thick", "=", "0.045"}], ",", 
          RowBox[{"filled", "=", "1"}], ",", 
          RowBox[{"size", "=", "0.05"}]}], "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"MarkersScaledCol2", "[", 
         RowBox[{"Red", ",", 
          RowBox[{"lighter", "=", "0"}], ",", 
          RowBox[{"thick", "=", "0.045"}], ",", 
          RowBox[{"filled", "=", "1"}], ",", 
          RowBox[{"size", "=", "0.05"}]}], "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"MarkersScaledCol2", "[", 
         RowBox[{"Red", ",", 
          RowBox[{"lighter", "=", "0"}], ",", 
          RowBox[{"thick", "=", "0.045"}], ",", 
          RowBox[{"filled", "=", "1"}], ",", 
          RowBox[{"size", "=", "0.05"}]}], "]"}], "[", 
        RowBox[{"[", "3", "]"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"MarkersScaledCol2", "[", 
         RowBox[{"Red", ",", 
          RowBox[{"lighter", "=", "0"}], ",", 
          RowBox[{"thick", "=", "0.045"}], ",", 
          RowBox[{"filled", "=", "1"}], ",", 
          RowBox[{"size", "=", "0.05"}]}], "]"}], "[", 
        RowBox[{"[", "4", "]"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"MarkersScaledCol2", "[", 
         RowBox[{"Red", ",", 
          RowBox[{"lighter", "=", "0"}], ",", 
          RowBox[{"thick", "=", "0.045"}], ",", 
          RowBox[{"filled", "=", "1"}], ",", 
          RowBox[{"size", "=", "0.05"}]}], "]"}], "[", 
        RowBox[{"[", "5", "]"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"MarkersScaledCol2", "[", 
         RowBox[{"Red", ",", 
          RowBox[{"lighter", "=", "0"}], ",", 
          RowBox[{"thick", "=", "0.045"}], ",", 
          RowBox[{"filled", "=", "1"}], ",", 
          RowBox[{"size", "=", "0.05"}]}], "]"}], "[", 
        RowBox[{"[", "6", "]"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"MarkersScaledCol2", "[", 
         RowBox[{"Red", ",", 
          RowBox[{"lighter", "=", "0"}], ",", 
          RowBox[{"thick", "=", "0.045"}], ",", 
          RowBox[{"filled", "=", "1"}], ",", 
          RowBox[{"size", "=", "0.05"}]}], "]"}], "[", 
        RowBox[{"[", "7", "]"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"MarkersScaledCol2", "[", 
         RowBox[{"Red", ",", 
          RowBox[{"lighter", "=", "0"}], ",", 
          RowBox[{"thick", "=", "0.045"}], ",", 
          RowBox[{"filled", "=", "1"}], ",", 
          RowBox[{"size", "=", "0.05"}]}], "]"}], "[", 
        RowBox[{"[", "8", "]"}], "]"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.005", "]"}], ",", "Green"}], "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Orange"}], 
        "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Orange"}], 
        "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0035", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Black"}], 
        "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Blue"}], 
        "]"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"Filling", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", "2", "}"}]}], ",", 
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", "3", "}"}]}]}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"FillingStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Directive", "[", 
        RowBox[{"Orange", ",", 
         RowBox[{"Opacity", "[", "0.2", "]"}]}], "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{"Orange", ",", 
         RowBox[{"Opacity", "[", "0.2", "]"}]}], "]"}]}], "}"}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.653920891104623*^9, 3.6539209040289145`*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\</CBZ-IT-DR-calibration.gif\>\""}], ",", "fig"}], "]"}]], "Input",
 CellChangeTimes->{{3.638686289973645*^9, 3.638686290350683*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
     "\"\</CBZ-IT-DR-calibration.xlsx\>\""}], ",", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitAcute"}], "*", 
            RowBox[{
             RowBox[{"ITpred$Total$N10$DR", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"1", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitAcute"}], "*", 
            RowBox[{
             RowBox[{"ITpred$Total$N10$DR", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"2", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitAcute"}], "*", 
            RowBox[{
             RowBox[{"ITpred$Total$N10$DR", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"3", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitAcute"}], "*", 
            RowBox[{
             RowBox[{"ITpred$Total$N10$DR", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"4", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"10", ",", 
            RowBox[{"SOT$concOrig", "[", 
             RowBox[{"[", "ix", "]"}], "]"}]}], "]"}], ",", 
          RowBox[{"100", "*", 
           RowBox[{"SOT$treatmentsOrig", "[", 
            RowBox[{"[", 
             RowBox[{"ix", ",", 
              RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"ix", ",", "1", ",", "8"}], "}"}]}], "]"}]}], "}"}]}], "]"}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
     "\"\</CBZ-IT-DR-calibration-relative.xlsx\>\""}], ",", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ITpred$Total$N10$DR", "[", 
             RowBox[{"[", 
              RowBox[{"(*", "median", "*)"}], 
              RowBox[{"1", ",", "trix"}], "]"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ITpred$Total$N10$DR", "[", 
             RowBox[{"[", 
              RowBox[{"(*", "median", "*)"}], 
              RowBox[{"2", ",", "trix"}], "]"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ITpred$Total$N10$DR", "[", 
             RowBox[{"[", 
              RowBox[{"(*", "median", "*)"}], 
              RowBox[{"3", ",", "trix"}], "]"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ITpred$Total$N10$DR", "[", 
             RowBox[{"[", 
              RowBox[{"(*", "median", "*)"}], 
              RowBox[{"4", ",", "trix"}], "]"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"10", ",", 
            RowBox[{"SOT$concOrig", "[", 
             RowBox[{"[", "ix", "]"}], "]"}]}], "]"}], ",", 
          RowBox[{"NinitAcute", "*", 
           RowBox[{"SOT$treatmentsOrig", "[", 
            RowBox[{"[", 
             RowBox[{"ix", ",", 
              RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"ix", ",", "1", ",", "8"}], "}"}]}], "]"}]}], "}"}]}], "]"}],
   ";"}]}], "Input",
 CellChangeTimes->{{3.642388030711204*^9, 3.642388035652204*^9}, {
  3.642411019000522*^9, 3.6424110242205305`*^9}, {3.6424190697200713`*^9, 
  3.6424190741943274`*^9}}],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{"$CalculateNew", "\[Equal]", "1"}], ",", 
   RowBox[{"SDpred$Total$N10$DR", "=", "\[IndentingNewLine]", 
    RowBox[{"SOT$prediction$Uncertainty$Total", "[", "\[IndentingNewLine]", 
     RowBox[{
     "SOT$data$CBZ$DR", ",", "\[IndentingNewLine]", "SDmodel", ",", 
      "\[IndentingNewLine]", 
      RowBox[{"parSetList", "=", "paramSamplesSD"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"optParSet", "=", "optParSD$CAR$AF"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"BG$mort", "=", "opt$Haz$BG$B"}], ",", "\[IndentingNewLine]", 
      RowBox[{"repl", "=", "1"}], ",", 
      RowBox[{"tEnd", "=", "4"}], ",", 
      RowBox[{"Ninit", "=", "NinitAcute"}], ",", 
      RowBox[{"nRand", "=", "10"}], ",", 
      RowBox[{"nrTr", "=", "nrExp"}], ",", 
      RowBox[{"lcl", "=", "0.1"}], ",", 
      RowBox[{"ucl", "=", "0.9"}], ",", 
      RowBox[{"deltaT", "=", "4"}], ",", 
      RowBox[{"IXmax", "=", "IXmaxFix"}]}], "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6383436614681635`*^9, 3.638343672138582*^9}, 
   3.6385857817269692`*^9, {3.6385911335004635`*^9, 3.6385911473488483`*^9}, {
   3.6385915646785774`*^9, 3.6385915648145905`*^9}, {3.6385925226323633`*^9, 
   3.6385925358966894`*^9}, 3.6386863243940873`*^9, 3.6391839174666862`*^9, {
   3.6392206619177136`*^9, 3.6392206647169933`*^9}, 3.639220698870408*^9, {
   3.6424190897432165`*^9, 3.642419093581436*^9}, {3.6478327112260756`*^9, 
   3.64783271130008*^9}}],

Cell[BoxData["SDpred$Total$N10$DR"], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SDpred$Total$N10$DR", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "16"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "16"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "16"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "16"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "16"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "16"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "16"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "16"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "16"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "14"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "14"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "13"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "12"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "11"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "10"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "9"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "7"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "6"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "5"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "3"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "2"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "1"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "8"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "6"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "8"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "7"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "9"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "8"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "7"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "7"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "8"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "7"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "8"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "6"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "5"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "6"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "5"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "4"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "3"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "2"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "1"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "1"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "19"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "18"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "17"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "16"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "14"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "12"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "13"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "9"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "8"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "6"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "5"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "4"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "2"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "1"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "1"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15.963750196255011`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.0000000000006`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15.86102873980003`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.000000000000774`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15.831976733685577`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.00000000000099`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15.79474758980819`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.000000000001275`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15.747072982478842`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.000000000001634`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15.686069174930122`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.0000000000021`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15.608086348063242`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.000000000002697`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15.508510155498954`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.00000000000346`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15.381650318465663`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.000000000004444`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15.220223095496747`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.000000000005706`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "15.015428932382978`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.000000000007326`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "14.756504499212319`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.00000000000941`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "14.430565075575949`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.00000000001208`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "14.02263960478727`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.00000000001551`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "13.515672703526906`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.000000000019917`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "12.89149856787944`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.000000000025576`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "12.132125513591683`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.00000000003284`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "11.222287802129326`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.000000000042167`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "10.153401126429637`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.000000000054143`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "8.92881671193829`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.00000000006952`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "7.570466300937158`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.000000000089265`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "6.124842236019298`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.000000000114618`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "4.6658284024901935`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.00000000014717`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "3.290043669169859`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.000000000188972`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "2.100773622871482`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.000000000242647`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "1.1809247950790085`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.000000000311566`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0.563656209438808`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.000000000400057`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0.21805837503590836`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.000000000513687`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0.0644158189123553`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.000000000659583`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0.013458493747868063`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.000000000846924`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0.0018024490618928624`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.00000000108747`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0.0001366911372681392`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.00000000139634`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "9.965205016759415`*^-6"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.00000000179294`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "3.324500790920934`*^-8"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.000000002302176`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "2.9739741951803144`*^-10"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.00000000295605`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "1.3447751695773837`*^-9"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.00000000379565`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "3.257565592437064`*^-17"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.000000004873712`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "3.1165394751432334`*^-22"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.000000006257967`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.000000008035418`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.000000010317677`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "20.000000013248076`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"4", ",", "2.290749796133196`*^-18"}], "}"}]}], "}"}]}], 
      "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6483755016979337`*^9, 3.648375506694433*^9}, 
   3.6483756025050135`*^9}],

Cell[BoxData[
 RowBox[{"fig", "=", 
  RowBox[{"ListPlot", "[", 
   RowBox[{
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitAcute"}], "*", 
            RowBox[{
             RowBox[{"SDpred$Total$N10$DR", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"1", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitAcute"}], "*", 
            RowBox[{
             RowBox[{"SDpred$Total$N10$DR", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"2", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitAcute"}], "*", 
            RowBox[{
             RowBox[{"SDpred$Total$N10$DR", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"3", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitAcute"}], "*", 
            RowBox[{
             RowBox[{"SDpred$Total$N10$DR", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"4", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"10", ",", 
            RowBox[{"SOT$concOrig", "[", 
             RowBox[{"[", "ix", "]"}], "]"}]}], "]"}], ",", 
          RowBox[{"100", "*", 
           RowBox[{"SOT$treatmentsOrig", "[", 
            RowBox[{"[", 
             RowBox[{"ix", ",", 
              RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"ix", ",", "1", ",", "8"}], "}"}]}], "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0.3", ",", "4.8"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2.5"}], ",", "105"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"AxesOrigin", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "3"}], ",", "0"}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"Joined", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"True", ",", "True", ",", "True", ",", "True", ",", "False"}], 
      "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"GridLines", "\[Rule]", "Automatic"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
    RowBox[{"FrameTicks", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"labels", ",", "Automatic", ",", "None", ",", "Automatic"}], 
      "}"}]}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<\!\(\*SubscriptBox[\(PEC\), \(max\)]\) concentration [nmol \
\!\(\*SuperscriptBox[\(L\), \(-1\)]\)]\>\"", ",", "\"\<Survivors(%)\>\"", 
       ",", "\"\<Day 4 of acute test\>\"", ",", "\"\<\>\""}], "}"}]}], ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"Directive", "[", "Black", "]"}]}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{"Black", ",", 
       RowBox[{"Thickness", "[", "0.002", "]"}]}], "]"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"GridLinesStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Directive", "[", 
        RowBox[{"Black", ",", 
         RowBox[{"Thickness", "[", "0.001", "]"}], ",", "Dashed"}], "]"}], 
       ",", 
       RowBox[{"Directive", "[", 
        RowBox[{"Black", ",", 
         RowBox[{"Thickness", "[", "0.001", "]"}]}], "]"}]}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"FontFamily", "->", "\"\<Arial\>\""}], ",", "55", ",", 
       "Bold"}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "1800"}], ",", 
    RowBox[{"PlotMarkers", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<\>\"", ",", "\"\<\>\"", ",", "\"\<\>\"", ",", "\"\<\>\"", ",", 
       RowBox[{
        RowBox[{"MarkersScaledCol2", "[", 
         RowBox[{"Red", ",", 
          RowBox[{"lighter", "=", "0"}], ",", 
          RowBox[{"thick", "=", "0.045"}], ",", 
          RowBox[{"filled", "=", "1"}], ",", 
          RowBox[{"size", "=", "0.05"}]}], "]"}], "[", 
        RowBox[{"[", "3", "]"}], "]"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.005", "]"}], ",", "Green"}], "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Orange"}], 
        "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Orange"}], 
        "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0035", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Black"}], 
        "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Blue"}], 
        "]"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"Filling", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", "2", "}"}]}], ",", 
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", "3", "}"}]}]}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"FillingStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Directive", "[", 
        RowBox[{"Orange", ",", 
         RowBox[{"Opacity", "[", "0.2", "]"}]}], "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{"Orange", ",", 
         RowBox[{"Opacity", "[", "0.2", "]"}]}], "]"}]}], "}"}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{3.6484681595961075`*^9}],

Cell[BoxData[
 RowBox[{"fig", "=", 
  RowBox[{"ListPlot", "[", 
   RowBox[{
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitAcute"}], "*", 
            RowBox[{
             RowBox[{"SDpred$Total$N10$DR", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"1", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitAcute"}], "*", 
            RowBox[{
             RowBox[{"SDpred$Total$N10$DR", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"2", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitAcute"}], "*", 
            RowBox[{
             RowBox[{"SDpred$Total$N10$DR", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"3", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitAcute"}], "*", 
            RowBox[{
             RowBox[{"SDpred$Total$N10$DR", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"4", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", 
           RowBox[{"SOT$concOrig", "[", 
            RowBox[{"[", 
             RowBox[{"ix", "=", "1"}], "]"}], "]"}]}], "]"}], ",", 
         RowBox[{"100", "*", 
          RowBox[{"SOT$treatmentsOrig", "[", 
           RowBox[{"[", 
            RowBox[{"ix", ",", 
             RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", 
           RowBox[{"SOT$concOrig", "[", 
            RowBox[{"[", 
             RowBox[{"ix", "=", "2"}], "]"}], "]"}]}], "]"}], ",", 
         RowBox[{"100", "*", 
          RowBox[{"SOT$treatmentsOrig", "[", 
           RowBox[{"[", 
            RowBox[{"ix", ",", 
             RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", 
           RowBox[{"SOT$concOrig", "[", 
            RowBox[{"[", 
             RowBox[{"ix", "=", "3"}], "]"}], "]"}]}], "]"}], ",", 
         RowBox[{"100", "*", 
          RowBox[{"SOT$treatmentsOrig", "[", 
           RowBox[{"[", 
            RowBox[{"ix", ",", 
             RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", 
           RowBox[{"SOT$concOrig", "[", 
            RowBox[{"[", 
             RowBox[{"ix", "=", "4"}], "]"}], "]"}]}], "]"}], ",", 
         RowBox[{"100", "*", 
          RowBox[{"SOT$treatmentsOrig", "[", 
           RowBox[{"[", 
            RowBox[{"ix", ",", 
             RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", 
           RowBox[{"SOT$concOrig", "[", 
            RowBox[{"[", 
             RowBox[{"ix", "=", "5"}], "]"}], "]"}]}], "]"}], ",", 
         RowBox[{"100", "*", 
          RowBox[{"SOT$treatmentsOrig", "[", 
           RowBox[{"[", 
            RowBox[{"ix", ",", 
             RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", 
           RowBox[{"SOT$concOrig", "[", 
            RowBox[{"[", 
             RowBox[{"ix", "=", "6"}], "]"}], "]"}]}], "]"}], ",", 
         RowBox[{"100", "*", 
          RowBox[{"SOT$treatmentsOrig", "[", 
           RowBox[{"[", 
            RowBox[{"ix", ",", 
             RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", 
           RowBox[{"SOT$concOrig", "[", 
            RowBox[{"[", 
             RowBox[{"ix", "=", "7"}], "]"}], "]"}]}], "]"}], ",", 
         RowBox[{"100", "*", 
          RowBox[{"SOT$treatmentsOrig", "[", 
           RowBox[{"[", 
            RowBox[{"ix", ",", 
             RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", 
           RowBox[{"SOT$concOrig", "[", 
            RowBox[{"[", 
             RowBox[{"ix", "=", "8"}], "]"}], "]"}]}], "]"}], ",", 
         RowBox[{"100", "*", 
          RowBox[{"SOT$treatmentsOrig", "[", 
           RowBox[{"[", 
            RowBox[{"ix", ",", 
             RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], "}"}]}], 
     "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0.3", ",", "4.8"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2.5"}], ",", "105"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"AxesOrigin", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "3"}], ",", "0"}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"Joined", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"True", ",", "True", ",", "True", ",", "True", ",", "False"}], 
      "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"GridLines", "\[Rule]", "Automatic"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
    RowBox[{"FrameTicks", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"labels", ",", "Automatic", ",", "None", ",", "Automatic"}], 
      "}"}]}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<\!\(\*SubscriptBox[\(PEC\), \(max\)]\) concentration [nmol \
\!\(\*SuperscriptBox[\(L\), \(-1\)]\)]\>\"", ",", "\"\<Survivors(%)\>\"", 
       ",", "\"\<Day 4 of acute test\>\"", ",", "\"\<\>\""}], "}"}]}], ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"Directive", "[", "Black", "]"}]}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{"Black", ",", 
       RowBox[{"Thickness", "[", "0.002", "]"}]}], "]"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"GridLinesStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Directive", "[", 
        RowBox[{"Black", ",", 
         RowBox[{"Thickness", "[", "0.001", "]"}], ",", "Dashed"}], "]"}], 
       ",", 
       RowBox[{"Directive", "[", 
        RowBox[{"Black", ",", 
         RowBox[{"Thickness", "[", "0.001", "]"}]}], "]"}]}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"FontFamily", "->", "\"\<Arial\>\""}], ",", "Bold", ",", 
       "55"}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "1800"}], ",", 
    RowBox[{"PlotMarkers", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<\>\"", ",", "\"\<\>\"", ",", "\"\<\>\"", ",", "\"\<\>\"", ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"MarkersScaledCol2", "[", 
         RowBox[{"Red", ",", 
          RowBox[{"lighter", "=", "0"}], ",", 
          RowBox[{"thick", "=", "0.045"}], ",", 
          RowBox[{"filled", "=", "1"}], ",", 
          RowBox[{"size", "=", "0.05"}]}], "]"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"MarkersScaledCol2", "[", 
         RowBox[{"Red", ",", 
          RowBox[{"lighter", "=", "0"}], ",", 
          RowBox[{"thick", "=", "0.045"}], ",", 
          RowBox[{"filled", "=", "1"}], ",", 
          RowBox[{"size", "=", "0.05"}]}], "]"}], "[", 
        RowBox[{"[", "2", "]"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"MarkersScaledCol2", "[", 
         RowBox[{"Red", ",", 
          RowBox[{"lighter", "=", "0"}], ",", 
          RowBox[{"thick", "=", "0.045"}], ",", 
          RowBox[{"filled", "=", "1"}], ",", 
          RowBox[{"size", "=", "0.05"}]}], "]"}], "[", 
        RowBox[{"[", "3", "]"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"MarkersScaledCol2", "[", 
         RowBox[{"Red", ",", 
          RowBox[{"lighter", "=", "0"}], ",", 
          RowBox[{"thick", "=", "0.045"}], ",", 
          RowBox[{"filled", "=", "1"}], ",", 
          RowBox[{"size", "=", "0.05"}]}], "]"}], "[", 
        RowBox[{"[", "4", "]"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"MarkersScaledCol2", "[", 
         RowBox[{"Red", ",", 
          RowBox[{"lighter", "=", "0"}], ",", 
          RowBox[{"thick", "=", "0.045"}], ",", 
          RowBox[{"filled", "=", "1"}], ",", 
          RowBox[{"size", "=", "0.05"}]}], "]"}], "[", 
        RowBox[{"[", "5", "]"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"MarkersScaledCol2", "[", 
         RowBox[{"Red", ",", 
          RowBox[{"lighter", "=", "0"}], ",", 
          RowBox[{"thick", "=", "0.045"}], ",", 
          RowBox[{"filled", "=", "1"}], ",", 
          RowBox[{"size", "=", "0.05"}]}], "]"}], "[", 
        RowBox[{"[", "6", "]"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"MarkersScaledCol2", "[", 
         RowBox[{"Red", ",", 
          RowBox[{"lighter", "=", "0"}], ",", 
          RowBox[{"thick", "=", "0.045"}], ",", 
          RowBox[{"filled", "=", "1"}], ",", 
          RowBox[{"size", "=", "0.05"}]}], "]"}], "[", 
        RowBox[{"[", "7", "]"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"MarkersScaledCol2", "[", 
         RowBox[{"Red", ",", 
          RowBox[{"lighter", "=", "0"}], ",", 
          RowBox[{"thick", "=", "0.045"}], ",", 
          RowBox[{"filled", "=", "1"}], ",", 
          RowBox[{"size", "=", "0.05"}]}], "]"}], "[", 
        RowBox[{"[", "8", "]"}], "]"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.005", "]"}], ",", "Green"}], "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Orange"}], 
        "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Orange"}], 
        "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0035", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Black"}], 
        "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Blue"}], 
        "]"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"Filling", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", "2", "}"}]}], ",", 
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", "3", "}"}]}]}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"FillingStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Directive", "[", 
        RowBox[{"Orange", ",", 
         RowBox[{"Opacity", "[", "0.2", "]"}]}], "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{"Orange", ",", 
         RowBox[{"Opacity", "[", "0.2", "]"}]}], "]"}]}], "}"}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.6539209605615673`*^9, 3.6539209689754086`*^9}}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\</CBZ-SD-DR-calibration.gif\>\""}], ",", "fig"}], "]"}]], "Input",
 CellChangeTimes->{{3.638686289973645*^9, 3.638686290350683*^9}, {
  3.63868638012866*^9, 3.6386863811547623`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
     "\"\</CBZ-SD-DR-calibration.xlsx\>\""}], ",", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitAcute"}], "*", 
            RowBox[{
             RowBox[{"SDpred$Total$N10$DR", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"1", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitAcute"}], "*", 
            RowBox[{
             RowBox[{"SDpred$Total$N10$DR", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"2", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitAcute"}], "*", 
            RowBox[{
             RowBox[{"SDpred$Total$N10$DR", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"3", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitAcute"}], "*", 
            RowBox[{
             RowBox[{"SDpred$Total$N10$DR", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"4", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"10", ",", 
            RowBox[{"SOT$concOrig", "[", 
             RowBox[{"[", "ix", "]"}], "]"}]}], "]"}], ",", 
          RowBox[{"100", "*", 
           RowBox[{"SOT$treatmentsOrig", "[", 
            RowBox[{"[", 
             RowBox[{"ix", ",", 
              RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"ix", ",", "1", ",", "8"}], "}"}]}], "]"}]}], "}"}]}], "]"}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
     "\"\</CBZ-SD-DR-calibration-relative.xlsx\>\""}], ",", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"SDpred$Total$N10$DR", "[", 
             RowBox[{"[", 
              RowBox[{"(*", "median", "*)"}], 
              RowBox[{"1", ",", "trix"}], "]"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"SDpred$Total$N10$DR", "[", 
             RowBox[{"[", 
              RowBox[{"(*", "median", "*)"}], 
              RowBox[{"2", ",", "trix"}], "]"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"SDpred$Total$N10$DR", "[", 
             RowBox[{"[", 
              RowBox[{"(*", "median", "*)"}], 
              RowBox[{"3", ",", "trix"}], "]"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"SDpred$Total$N10$DR", "[", 
             RowBox[{"[", 
              RowBox[{"(*", "median", "*)"}], 
              RowBox[{"4", ",", "trix"}], "]"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"10", ",", 
            RowBox[{"SOT$concOrig", "[", 
             RowBox[{"[", "ix", "]"}], "]"}]}], "]"}], ",", 
          RowBox[{"NinitAcute", "*", 
           RowBox[{"SOT$treatmentsOrig", "[", 
            RowBox[{"[", 
             RowBox[{"ix", ",", 
              RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"ix", ",", "1", ",", "8"}], "}"}]}], "]"}]}], "}"}]}], "]"}],
   ";"}]}], "Input",
 CellChangeTimes->{{3.642388030711204*^9, 3.642388035652204*^9}, {
  3.642411019000522*^9, 3.6424110242205305`*^9}, {3.6424118757472115`*^9, 
  3.6424118960592904`*^9}, {3.642419165278537*^9, 3.6424191688077383`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Create exposure series with pulsed profile, by multiplication of original \
pulsed data with a factor series.\
\>", "Chapter",
 CellChangeTimes->{{3.638443688402268*^9, 3.638443736934268*^9}, {
  3.6482658027027597`*^9, 3.6482658037818675`*^9}}],

Cell[BoxData[
 RowBox[{"CmaxPulse", "=", 
  RowBox[{"Max", "[", 
   RowBox[{
    RowBox[{"Transpose", "[", 
     RowBox[{"Drop", "[", 
      RowBox[{
       RowBox[{"expDataPulse", "[", 
        RowBox[{"[", "1", "]"}], "]"}], ",", "1"}], "]"}], "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.6383585272368155`*^9, 3.6383585272668133`*^9}, {
  3.6385925939944983`*^9, 3.6385925969547944`*^9}, {3.6386864533769836`*^9, 
  3.638686471567803*^9}}],

Cell[BoxData[{
 RowBox[{"nrExp", "=", 
  RowBox[{"Length", "[", "DR$exp$data", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"NinitPulse", "=", "80"}], ";"}]}], "Input",
 CellChangeTimes->{{3.63859332768286*^9, 3.638593327729865*^9}, 
   3.638593430113102*^9, {3.6386864794725933`*^9, 3.638686480609707*^9}, {
   3.6392207692174425`*^9, 3.639220775585079*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"tvefunc", "[", 
    RowBox[{"t_", ",", "dur_", ",", "conc_"}], "]"}], ":=", 
   RowBox[{"Piecewise", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"conc", ",", 
         RowBox[{"t", "<", "dur"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"t", "\[GreaterEqual]", "dur"}]}], "}"}]}], "}"}], ",", 
     "0"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"SOT$data$days", "=", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1", ",", "2", ",", "3", ",", "4"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"noTreats", "=", "nrExp"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$data$initAbundance", "=", 
   RowBox[{"Table", "[", 
    RowBox[{"NinitPulse", ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "noTreats"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$conc", "=", "DR$exp$data"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$treatments", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0.9", ",", "0.8", ",", "0.7", ",", "0.6"}], "}"}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "noTreats"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$CWs", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"tvefunc", "[", 
      RowBox[{"t", ",", "4", ",", "#"}], "]"}], "&"}], "/@", "SOT$conc"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$data$CBZ$DR", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", "SOT$data$days", "}"}], ",", 
     RowBox[{"{", "SOT$data$initAbundance", "}"}], ",", 
     RowBox[{"{", "SOT$conc", "}"}], ",", "SOT$treatments", ",", 
     RowBox[{"{", "SOT$CWs", "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{"TableForm", "[", 
  RowBox[{
   RowBox[{"SOT$data$CBZ$DR", "[", 
    RowBox[{"[", 
     RowBox[{"4", ";;", 
      RowBox[{"nrExp", "+", "3"}]}], "]"}], "]"}], ",", 
   RowBox[{"TableHeadings", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"SOT$data$CBZ$DR", "[", 
       RowBox[{"[", "3", "]"}], "]"}], ",", 
      RowBox[{"SOT$data$CBZ$DR", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}]}], "]"}]}], "Input",
 CellChangeTimes->{
  3.6385923429293947`*^9, {3.6385926033074293`*^9, 3.6385926033464336`*^9}, {
   3.6385926460707054`*^9, 3.638592660949193*^9}, 3.638592879145011*^9, 
   3.6385929517952747`*^9, {3.6385934404971404`*^9, 3.6385934414002304`*^9}, {
   3.63868650424307*^9, 3.638686534236069*^9}, 3.639220784156936*^9}],

Cell[BoxData[
 RowBox[{"scaleDRPulse", "=", 
  RowBox[{"SOT$conc", "/", "CmaxPulse"}]}]], "Input",
 CellChangeTimes->{{3.638358544698594*^9, 3.638358578141254*^9}, {
   3.6385923730324044`*^9, 3.638592374096511*^9}, {3.6385929707951746`*^9, 
   3.638592973234419*^9}, 3.638593007939889*^9, 3.6386865431399593`*^9}],

Cell[BoxData[
 RowBox[{"Length", "[", "scaleDRPulse", "]"}]], "Input",
 CellChangeTimes->{{3.638592865778674*^9, 3.63859287214231*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tEndExp", "=", "10"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$data$days", "=", 
   RowBox[{"Drop", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Transpose", "[", "survivalDataPulsed", "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}], ",", "1"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$data$initAbundance", "=", 
   RowBox[{"{", 
    RowBox[{
    "NinitPulse", ",", "NinitPulse", ",", "NinitPulse", ",", "NinitPulse"}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$concOrig", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<A\>\"", ",", "\"\<B\>\"", ",", "\"\<C\>\"", ",", "\"\<D\>\""}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$treatmentsOrig", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Drop", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Transpose", "[", "survivalDataPulsed", "]"}], "[", 
          RowBox[{"[", "#", "]"}], "]"}], ",", "1"}], "]"}], "/", 
       "NinitPulse"}], ")"}], "&"}], "/@", 
    RowBox[{"{", 
     RowBox[{"2", ",", "3", ",", "4", ",", "5"}], "}"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$CWs", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Interpolation", "[", 
      RowBox[{
       RowBox[{"Drop", "[", 
        RowBox[{
         RowBox[{"expDataPulse", "[", 
          RowBox[{"[", "#", "]"}], "]"}], ",", "1"}], "]"}], ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}], "&"}], "/@", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$dataPulsed$CYP", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", "SOT$data$days", "}"}], ",", 
     RowBox[{"{", "SOT$data$initAbundance", "}"}], ",", 
     RowBox[{"{", "SOT$conc", "}"}], ",", "SOT$treatmentsOrig", ",", 
     RowBox[{"{", "SOT$CWs", "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.6384437915292683`*^9, 3.638443796894268*^9}, {
  3.6385926810552034`*^9, 3.6385926818232803`*^9}, {3.639220802348755*^9, 
  3.639220814231943*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"expDataPulse$DR", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"Drop", "[", 
           RowBox[{
            RowBox[{"expDataPulse", "[", 
             RowBox[{"[", 
              RowBox[{"tr", "=", "1"}], "]"}], "]"}], ",", "1"}], "]"}], 
          "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], ",", 
        RowBox[{
         RowBox[{"scaleDRPulse", "[", 
          RowBox[{"[", "ix", "]"}], "]"}], "*", 
         RowBox[{
          RowBox[{"Transpose", "[", 
           RowBox[{"Drop", "[", 
            RowBox[{
             RowBox[{"expDataPulse", "[", 
              RowBox[{"[", 
               RowBox[{"tr", "=", "1"}], "]"}], "]"}], ",", "1"}], "]"}], 
           "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}]}]}], "}"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"ix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.6383590613628464`*^9, 3.6383591146798463`*^9}, 
   3.6385928077338705`*^9}],

Cell[BoxData[
 RowBox[{"ListLogPlot", "[", 
  RowBox[{"expDataPulse$DR", ",", 
   RowBox[{"Joined", "->", "True"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.638359120340846*^9, 3.638359163505846*^9}, {
  3.638592699512049*^9, 3.6385927095110493`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tEndExp", "=", "10"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$data$days", "=", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6", ",", "7",
      ",", "8", ",", "9", ",", "10"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$data$initAbundance", "=", 
   RowBox[{"Table", "[", 
    RowBox[{"NinitPulse", ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "nrExp"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$conc", "=", "scaleDRPulse"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$treatments", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "1", ",", "0.9", ",", "0.8", ",", "0.7", ",", "0.6", ",", "0.5", ",", 
       "0.4", ",", "0.3", ",", "0.2", ",", "0.1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$CWs", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Interpolation", "[", 
      RowBox[{
       RowBox[{"expDataPulse$DR", "[", 
        RowBox[{"[", "#", "]"}], "]"}], ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}], "&"}], "/@", 
    RowBox[{"Range", "[", "nrExp", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$dataPulsed$CBZ$DR", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", "SOT$data$days", "}"}], ",", 
     RowBox[{"{", "SOT$data$initAbundance", "}"}], ",", 
     RowBox[{"{", "SOT$conc", "}"}], ",", "SOT$treatments", ",", 
     RowBox[{"{", "SOT$CWs", "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.638359194625846*^9, 3.638359333234846*^9}, {
   3.638592751786276*^9, 3.6385927676928663`*^9}, {3.638593025662661*^9, 
   3.6385930263097258`*^9}, 3.639220823910911*^9}],

Cell[BoxData["opt$Haz$BG$Pulse"], "Input"],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{"$CalculateNew", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
   RowBox[{
   "ITpred$Total$N10$DR$delta$PulsedA$DT10", "=", "\[IndentingNewLine]", 
    RowBox[{"SOT$prediction$Uncertainty$Total", "[", "\[IndentingNewLine]", 
     RowBox[{
     "SOT$dataPulsed$CBZ$DR", ",", "\[IndentingNewLine]", "ITmodel", ",", 
      "\[IndentingNewLine]", 
      RowBox[{"parSetList", "=", "paramSamplesIT"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"optParSet", "=", "optParIT$CAR$AF"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"BG$mort", "=", "opt$Haz$BG$Pulse"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"repl", "=", "1"}], ",", 
      RowBox[{"tEnd", "=", "10"}], ",", 
      RowBox[{"Ninit", "=", "NinitPulse"}], ",", 
      RowBox[{"nRand", "=", "10"}], ",", 
      RowBox[{"nrTr", "=", "nrExp"}], ",", 
      RowBox[{"lcl", "=", "0.1"}], ",", 
      RowBox[{"ucl", "=", "0.9"}], ",", 
      RowBox[{"deltaT", "=", "10"}], ",", 
      RowBox[{"maxIX", "=", "IXmaxFix"}]}], "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.638359353788846*^9, 3.638359382004846*^9}, {
   3.6384453338082113`*^9, 3.6384453365462112`*^9}, 3.638459617914612*^9, {
   3.638588695060273*^9, 3.6385887111788855`*^9}, 3.6385927256226597`*^9, {
   3.6385930393000245`*^9, 3.638593052668361*^9}, {3.638686638517496*^9, 
   3.6386866429969444`*^9}, 3.6392208301425343`*^9, {3.6424192066759043`*^9, 
   3.6424192111731615`*^9}}],

Cell[BoxData["ITpred$Total$N10$DR$delta$PulsedA$DT10"], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ITpred$Total$N10$DR$delta$PulsedA$DT10", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "63"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "63"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "63"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "63"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "63"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "63"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "63"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "63"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "63"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "63"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "63"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "63"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "63"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "61"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "60"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "59"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "57"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "54"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "49"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "43"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "36"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "28"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "21"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "14"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "10"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "6"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "4"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "2"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "1"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "1"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "48"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "48"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "47"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "47"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "47"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "46"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "47"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "48"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "47"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "48"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "48"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "46"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "48"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "47"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "48"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "45"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "42"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "39"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "37"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "35"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "34"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "28"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "24"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "19"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "14"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "6"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "3"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "1"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "75"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "75"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "75"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "75"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "75"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "76"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "75"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "75"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "74"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "75"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "75"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "75"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "74"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "75"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "74"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "75"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "75"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "75"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "74"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "72"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "74"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "74"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "70"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "68"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "61"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "58"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "44"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "37"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "32"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "31"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "23"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "20"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "17"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "15"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "13"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "10"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "8"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "7"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "6"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "6"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "4"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "5"}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.736585438820654`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.73556833630232`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.73517806135078`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.73458378173391`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.73227375796382`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.730801752224714`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.72779085756953`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.72176049948712`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.71300697067852`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.69990201607267`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.67535945570365`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.63695244243384`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.577235861339766`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.478884346750164`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.3160817240028`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.06903634618962`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "61.66235240306192`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "61.017961458278016`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "60.00865421757191`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "58.44513803201334`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "56.077105385841044`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "52.62364791672112`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "47.890603767423855`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "41.810395730761144`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "34.68933309090222`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "27.195304133903537`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "20.159464078090924`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "14.219877384479476`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "9.633606411816686`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "6.33580453097715`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "4.078916463662165`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "2.5887338337130146`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "1.6281944929607148`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "1.0179361756550356`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0.6340095711840699`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0.39399002044113807`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0.24447794916251517`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0.15155959630961663`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0.09390517581645108`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0.05816268277928153`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0.036015970621382294`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0.02229926396004942`"}], "}"}]}], "}"}]}], 
      "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.648375675806343*^9, 3.648375680431805*^9}}],

Cell[BoxData[
 RowBox[{"fig", "=", 
  RowBox[{"ListPlot", "[", 
   RowBox[{
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"ITpred$Total$N10$DR$delta$PulsedA$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"1", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"ITpred$Total$N10$DR$delta$PulsedA$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"2", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"ITpred$Total$N10$DR$delta$PulsedA$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"3", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"ITpred$Total$N10$DR$delta$PulsedA$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"4", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"10", ",", "CmaxPulse"}], "]"}], ",", 
          RowBox[{"100", "*", 
           RowBox[{"SOT$treatmentsOrig", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"ix", "=", "1"}], ",", 
              RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"ix", ",", "1", ",", "8"}], "}"}]}], "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0.9", ",", "4.8"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2.5"}], ",", "105"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"AxesOrigin", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "3"}], ",", "0"}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"Joined", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"True", ",", "True", ",", "True", ",", "True", ",", "False"}], 
      "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"GridLines", "\[Rule]", "Automatic"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
    RowBox[{"FrameTicks", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"labels", ",", "Automatic", ",", "None", ",", "Automatic"}], 
      "}"}]}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<\!\(\*SubscriptBox[\(PEC\), \(max\)]\) concentration [nmol \
\!\(\*SuperscriptBox[\(L\), \(-1\)]\)]\>\"", ",", "\"\<Survivors(%)\>\"", 
       ",", "\"\<Day 10 of pulsed exposure\>\"", ",", "\"\<\>\""}], "}"}]}], 
    ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"Directive", "[", "Black", "]"}]}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{"Black", ",", 
       RowBox[{"Thickness", "[", "0.002", "]"}]}], "]"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"GridLinesStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Directive", "[", 
        RowBox[{"Black", ",", 
         RowBox[{"Thickness", "[", "0.001", "]"}], ",", "Dashed"}], "]"}], 
       ",", 
       RowBox[{"Directive", "[", 
        RowBox[{"Black", ",", 
         RowBox[{"Thickness", "[", "0.001", "]"}]}], "]"}]}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"FontFamily", "->", "\"\<Arial\>\""}], ",", "Bold", ",", 
       "55"}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "1800"}], ",", 
    RowBox[{"PlotMarkers", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<\>\"", ",", "\"\<\>\"", ",", "\"\<\>\"", ",", "\"\<\>\"", ",", 
       RowBox[{
        RowBox[{"MarkersScaledCol2", "[", 
         RowBox[{"Blue", ",", 
          RowBox[{"lighter", "=", "0"}], ",", 
          RowBox[{"thick", "=", "0.16"}], ",", 
          RowBox[{"filled", "=", "0"}], ",", 
          RowBox[{"size", "=", "0.05"}]}], "]"}], "[", 
        RowBox[{"[", "3", "]"}], "]"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.005", "]"}], ",", "Green"}], "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Orange"}], 
        "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Orange"}], 
        "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0035", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Black"}], 
        "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Blue"}], 
        "]"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"Filling", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", "2", "}"}]}], ",", 
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", "3", "}"}]}]}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"FillingStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Directive", "[", 
        RowBox[{"Orange", ",", 
         RowBox[{"Opacity", "[", "0.2", "]"}]}], "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{"Orange", ",", 
         RowBox[{"Opacity", "[", "0.2", "]"}]}], "]"}]}], "}"}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{3.648468215342681*^9, 3.653918905008881*^9}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\</CBZ-IT-DR-prediction-pulseA.gif\>\""}], ",", "fig"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.638686764078051*^9, 3.6386867705106945`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
     "\"\</CBZ-SD-DR-prediction-pulseA.xlsx\>\""}], ",", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ITpred$Total$N10$DR$delta$PulsedA$DT10", "[", 
             RowBox[{"[", 
              RowBox[{"(*", "median", "*)"}], 
              RowBox[{"1", ",", "trix"}], "]"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ITpred$Total$N10$DR$delta$PulsedA$DT10", "[", 
             RowBox[{"[", 
              RowBox[{"(*", "lcl", "*)"}], 
              RowBox[{"2", ",", "trix"}], "]"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ITpred$Total$N10$DR$delta$PulsedA$DT10", "[", 
             RowBox[{"[", 
              RowBox[{"(*", "ucl", "*)"}], 
              RowBox[{"3", ",", "trix"}], "]"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ITpred$Total$N10$DR$delta$PulsedA$DT10", "[", 
             RowBox[{"[", 
              RowBox[{"(*", "opt", "*)"}], 
              RowBox[{"4", ",", "trix"}], "]"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "CmaxPulse"}], "]"}], ",", 
         RowBox[{"NinitPulse", "*", 
          RowBox[{"SOT$treatmentsOrig", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"trix", "=", "1"}], ",", 
             RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], "}"}]}], "}"}]}], 
   "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.638588643499118*^9, 3.63858866152392*^9}, {
   3.6385935419652863`*^9, 3.6385935426293526`*^9}, {3.6385935738964787`*^9, 
   3.638593575166606*^9}, {3.638593680579146*^9, 3.638593685267615*^9}, {
   3.63868741791267*^9, 3.638687433525231*^9}, {3.638693892739031*^9, 
   3.6386938930760307`*^9}, {3.63906466175029*^9, 3.6390646668487997`*^9}, {
   3.642332472761204*^9, 3.642332484971204*^9}, 3.6423990247202044`*^9, {
   3.6423990654402037`*^9, 3.642399066080204*^9}, {3.6424122011091638`*^9, 
   3.64241222125539*^9}, {3.6424193193573494`*^9, 3.642419319807375*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
     "\"\</CBZ-SD-DR-prediction-pulseA-relative.xlsx\>\""}], ",", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"ITpred$Total$N10$DR$delta$PulsedA$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"1", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"ITpred$Total$N10$DR$delta$PulsedA$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "lcl", "*)"}], 
               RowBox[{"2", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"ITpred$Total$N10$DR$delta$PulsedA$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "ucl", "*)"}], 
               RowBox[{"3", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"ITpred$Total$N10$DR$delta$PulsedA$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "opt", "*)"}], 
               RowBox[{"4", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "CmaxPulse"}], "]"}], ",", 
         RowBox[{"100", "*", 
          RowBox[{"SOT$treatmentsOrig", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"trix", "=", "1"}], ",", 
             RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], "}"}]}], "}"}]}], 
   "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.639376095616553*^9, 3.6393761179447856`*^9}, {
   3.642310111174238*^9, 3.642310117422863*^9}, 3.642332456350204*^9, {
   3.642399040839204*^9, 3.6423990729522038`*^9}, {3.6424122133791895`*^9, 
   3.6424122241544*^9}, {3.642419323852607*^9, 3.64241932443464*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{3.638445377181711*^9}],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{"$CalculateNew", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
   RowBox[{
   "SDpred$Total$N10$DR$delta$PulsedA$DT10", "=", "\[IndentingNewLine]", 
    RowBox[{"SOT$prediction$Uncertainty$Total", "[", "\[IndentingNewLine]", 
     RowBox[{
     "SOT$dataPulsed$CBZ$DR", ",", "\[IndentingNewLine]", "SDmodel", ",", 
      "\[IndentingNewLine]", 
      RowBox[{"parSetList", "=", "paramSamplesSD"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"optParSet", "=", "optParSD$CAR$AF"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"BG$mort", "=", "opt$Haz$BG$Pulse"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"repl", "=", "1"}], ",", 
      RowBox[{"tEnd", "=", "10"}], ",", 
      RowBox[{"Ninit", "=", "NinitPulse"}], ",", 
      RowBox[{"nRand", "=", "10"}], ",", 
      RowBox[{"nrTr", "=", "nrExp"}], ",", 
      RowBox[{"lcl", "=", "0.1"}], ",", 
      RowBox[{"ucl", "=", "0.9"}], ",", 
      RowBox[{"deltaT", "=", "10"}], ",", 
      RowBox[{"maxIX", "=", "IXmaxFix"}]}], "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.638359353788846*^9, 3.638359382004846*^9}, {
   3.6384453338082113`*^9, 3.6384453365462112`*^9}, 3.638459617914612*^9, {
   3.638588695060273*^9, 3.6385887111788855`*^9}, 3.6385927256226597`*^9, {
   3.6385930393000245`*^9, 3.638593052668361*^9}, {3.638593635062595*^9, 
   3.6385936513112197`*^9}, {3.638686780288672*^9, 3.638686824035046*^9}, 
   3.639220866016121*^9, {3.6424193398655224`*^9, 3.642419347979987*^9}}],

Cell[BoxData["SDpred$Total$N10$DR$delta$PulsedA$DT10"], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SDpred$Total$N10$DR$delta$PulsedA$DT10", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "63"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "61"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "61"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "60"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "59"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "58"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "57"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "56"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "54"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "51"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "48"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "45"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "40"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "36"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "30"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "25"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "19"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "13"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "9"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "5"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "2"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "1"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "47"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "46"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "45"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "46"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "42"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "44"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "42"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "40"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "43"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "41"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "37"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "31"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "31"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "28"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "23"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "18"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "14"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "6"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "6"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "3"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "1"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "76"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "75"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "75"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "74"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "74"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "74"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "72"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "73"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "71"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "73"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "73"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "71"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "74"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "70"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "69"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "66"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "61"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "56"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "58"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "45"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "36"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "30"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "28"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "21"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "12"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "9"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "5"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "4"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "1"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "2"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "1"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.73658543882064`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "61.8907218399348`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "61.65251782636457`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "61.34655595334489`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "60.96118131444855`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "60.46446514538432`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "59.834819201526166`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "59.03495673065479`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "58.02355623683024`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "56.752079362315015`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "55.15578588963153`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "53.17558784740137`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "50.72904224362077`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "47.76707272205097`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "44.20760660864151`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "40.02282271651579`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "35.22751580079219`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "29.900136674506594`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "24.22544296014893`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "18.488982402838882`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "13.067623854754924`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "8.368986078977802`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "4.72281292282115`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "2.2654228402655914`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0.8819751343468882`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0.26268956801766374`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0.055467680318682794`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0.007526449616393881`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0.0005795911136220483`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0.0000215378740807636`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "3.1419035680704246`*^-7"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "6.707474735916314`*^-28"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "9.183549615799121`*^-40"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "1.7516230804060213`*^-45"}], "}"}]}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}]}], "}"}]}], "}"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.648375709989761*^9, 3.648375715713333*^9}}],

Cell[BoxData[
 RowBox[{"fig", "=", 
  RowBox[{"ListPlot", "[", 
   RowBox[{
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"SDpred$Total$N10$DR$delta$PulsedA$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"1", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"SDpred$Total$N10$DR$delta$PulsedA$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"2", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"SDpred$Total$N10$DR$delta$PulsedA$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"3", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"SDpred$Total$N10$DR$delta$PulsedA$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"4", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{"10", ",", "CmaxPulse"}], "]"}], ",", 
          RowBox[{"100", "*", 
           RowBox[{"SOT$treatmentsOrig", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"ix", "=", "1"}], ",", 
              RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"ix", ",", "1", ",", "8"}], "}"}]}], "]"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0.9", ",", "4.8"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2.5"}], ",", "105"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"AxesOrigin", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "3"}], ",", "0"}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"Joined", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"True", ",", "True", ",", "True", ",", "True", ",", "False"}], 
      "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"GridLines", "\[Rule]", "Automatic"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
    RowBox[{"FrameTicks", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"labels", ",", "Automatic", ",", "None", ",", "Automatic"}], 
      "}"}]}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<\!\(\*SubscriptBox[\(PEC\), \(max\)]\) concentration [nmol \
\!\(\*SuperscriptBox[\(L\), \(-1\)]\)]\>\"", ",", "\"\<Survivors(%)\>\"", 
       ",", "\"\<Day 10 of pulsed exposure\>\"", ",", "\"\<\>\""}], "}"}]}], 
    ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"Directive", "[", "Black", "]"}]}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{"Black", ",", 
       RowBox[{"Thickness", "[", "0.002", "]"}]}], "]"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"GridLinesStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Directive", "[", 
        RowBox[{"Black", ",", 
         RowBox[{"Thickness", "[", "0.001", "]"}], ",", "Dashed"}], "]"}], 
       ",", 
       RowBox[{"Directive", "[", 
        RowBox[{"Black", ",", 
         RowBox[{"Thickness", "[", "0.001", "]"}]}], "]"}]}], "}"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"FontFamily", "->", "\"\<Arial\>\""}], ",", "55", ",", 
       "Bold"}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "1800"}], ",", 
    RowBox[{"PlotMarkers", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<\>\"", ",", "\"\<\>\"", ",", "\"\<\>\"", ",", "\"\<\>\"", ",", 
       RowBox[{
        RowBox[{"MarkersScaledCol2", "[", 
         RowBox[{"Blue", ",", 
          RowBox[{"lighter", "=", "0"}], ",", 
          RowBox[{"thick", "=", "0.16"}], ",", 
          RowBox[{"filled", "=", "0"}], ",", 
          RowBox[{"size", "=", "0.05"}]}], "]"}], "[", 
        RowBox[{"[", "3", "]"}], "]"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.005", "]"}], ",", "Green"}], "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Orange"}], 
        "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Orange"}], 
        "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0035", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Black"}], 
        "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Blue"}], 
        "]"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"Filling", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", "2", "}"}]}], ",", 
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", "3", "}"}]}]}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"FillingStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Directive", "[", 
        RowBox[{"Orange", ",", 
         RowBox[{"Opacity", "[", "0.2", "]"}]}], "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{"Orange", ",", 
         RowBox[{"Opacity", "[", "0.2", "]"}]}], "]"}]}], "}"}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{3.6484682496481113`*^9, 3.6539192173331103`*^9}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\</CBZ-SD-DR-prediction-pulseA.gif\>\""}], ",", "fig"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.6386869372816763`*^9, 3.638686941394088*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
     "\"\</CBZ-SD-DR-prediction-pulseA.xlsx\>\""}], ",", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"SDpred$Total$N10$DR$delta$PulsedA$DT10", "[", 
             RowBox[{"[", 
              RowBox[{"(*", "median", "*)"}], 
              RowBox[{"1", ",", "trix"}], "]"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"SDpred$Total$N10$DR$delta$PulsedA$DT10", "[", 
             RowBox[{"[", 
              RowBox[{"(*", "lcl", "*)"}], 
              RowBox[{"2", ",", "trix"}], "]"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"SDpred$Total$N10$DR$delta$PulsedA$DT10", "[", 
             RowBox[{"[", 
              RowBox[{"(*", "ucl", "*)"}], 
              RowBox[{"3", ",", "trix"}], "]"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"SDpred$Total$N10$DR$delta$PulsedA$DT10", "[", 
             RowBox[{"[", 
              RowBox[{"(*", "opt", "*)"}], 
              RowBox[{"4", ",", "trix"}], "]"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "CmaxPulse"}], "]"}], ",", 
         RowBox[{"NinitPulse", "*", 
          RowBox[{"SOT$treatmentsOrig", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"trix", "=", "1"}], ",", 
             RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], "}"}]}], "}"}]}], 
   "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.638588643499118*^9, 3.63858866152392*^9}, {
   3.6385935419652863`*^9, 3.6385935426293526`*^9}, {3.6385935738964787`*^9, 
   3.638593575166606*^9}, {3.638593680579146*^9, 3.638593685267615*^9}, {
   3.63868741791267*^9, 3.638687433525231*^9}, {3.638693892739031*^9, 
   3.6386938930760307`*^9}, {3.63906466175029*^9, 3.6390646668487997`*^9}, {
   3.642332472761204*^9, 3.642332484971204*^9}, 3.6423990247202044`*^9, {
   3.6423990654402037`*^9, 3.642399066080204*^9}, {3.642412185351119*^9, 
   3.6424121858811197`*^9}, {3.6424123032808676`*^9, 
   3.6424123044008694`*^9}, {3.6424194090234785`*^9, 3.6424194094575033`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
     "\"\</CBZ-SD-DR-prediction-pulseA-relative.xlsx\>\""}], ",", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"SDpred$Total$N10$DR$delta$PulsedA$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"1", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"SDpred$Total$N10$DR$delta$PulsedA$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "lcl", "*)"}], 
               RowBox[{"2", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"SDpred$Total$N10$DR$delta$PulsedA$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "ucl", "*)"}], 
               RowBox[{"3", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"SDpred$Total$N10$DR$delta$PulsedA$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "opt", "*)"}], 
               RowBox[{"4", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "CmaxPulse"}], "]"}], ",", 
         RowBox[{"100", "*", 
          RowBox[{"SOT$treatmentsOrig", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"trix", "=", "1"}], ",", 
             RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], "}"}]}], "}"}]}], 
   "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.639376095616553*^9, 3.6393761179447856`*^9}, {
   3.642310111174238*^9, 3.642310117422863*^9}, 3.642332456350204*^9, {
   3.642399040839204*^9, 3.6423990729522038`*^9}, {3.6424123093138933`*^9, 
   3.6424123105039024`*^9}, 3.6424194136307416`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create pulsed exposure series B", "Chapter",
 CellChangeTimes->{{3.638444462659218*^9, 3.6384444740085683`*^9}, {
  3.6482226609108286`*^9, 3.6482226625659943`*^9}}],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.638358544698594*^9, 3.638358578141254*^9}, 
   3.638444482370781*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tEndExp", "=", "10"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$data$days", "=", 
   RowBox[{"Drop", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Transpose", "[", "survivalDataPulsed", "]"}], "[", 
      RowBox[{"[", "1", "]"}], "]"}], ",", "1"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$data$initAbundance", "=", 
   RowBox[{"{", 
    RowBox[{
    "NinitPulse", ",", "NinitPulse", ",", "NinitPulse", ",", "NinitPulse"}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$conc", "=", 
   RowBox[{"{", 
    RowBox[{
    "\"\<A\>\"", ",", "\"\<B\>\"", ",", "\"\<C\>\"", ",", "\"\<D\>\""}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$treatmentsOrig", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Drop", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Transpose", "[", "survivalDataPulsed", "]"}], "[", 
          RowBox[{"[", "#", "]"}], "]"}], ",", "1"}], "]"}], "/", 
       "NinitPulse"}], ")"}], "&"}], "/@", 
    RowBox[{"{", 
     RowBox[{"2", ",", "3", ",", "4", ",", "5"}], "}"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$CWs", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Interpolation", "[", 
      RowBox[{
       RowBox[{"Drop", "[", 
        RowBox[{
         RowBox[{"expDataPulse", "[", 
          RowBox[{"[", "#", "]"}], "]"}], ",", "1"}], "]"}], ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}], "&"}], "/@", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$dataPulsed$CBZ", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", "SOT$data$days", "}"}], ",", 
     RowBox[{"{", "SOT$data$initAbundance", "}"}], ",", 
     RowBox[{"{", "SOT$conc", "}"}], ",", "SOT$treatmentsOrig", ",", 
     RowBox[{"{", "SOT$CWs", "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.6384437915292683`*^9, 3.638443796894268*^9}, {
  3.638686963133261*^9, 3.6386869637863264`*^9}, {3.6392209027617955`*^9, 
  3.639220907801299*^9}}],

Cell[BoxData[
 RowBox[{"CmaxPulse", "=", 
  RowBox[{"Max", "[", 
   RowBox[{
    RowBox[{"Transpose", "[", 
     RowBox[{"Drop", "[", 
      RowBox[{
       RowBox[{"expDataPulse", "[", 
        RowBox[{"[", "2", "]"}], "]"}], ",", "1"}], "]"}], "]"}], "[", 
    RowBox[{"[", "2", "]"}], "]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.638687477358614*^9, 3.6386874773766155`*^9}}],

Cell[BoxData[
 RowBox[{"scaleDRPulse", "=", 
  RowBox[{"DR$exp$data", "/", "CmaxPulse"}]}]], "Input",
 CellChangeTimes->{{3.6386869725892067`*^9, 3.6386869763385816`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"expDataPulse$DR", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"Drop", "[", 
           RowBox[{
            RowBox[{"expDataPulse", "[", 
             RowBox[{"[", 
              RowBox[{"tr", "=", "2"}], "]"}], "]"}], ",", "1"}], "]"}], 
          "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], ",", 
        RowBox[{
         RowBox[{"scaleDRPulse", "[", 
          RowBox[{"[", "ix", "]"}], "]"}], "*", 
         RowBox[{
          RowBox[{"Transpose", "[", 
           RowBox[{"Drop", "[", 
            RowBox[{
             RowBox[{"expDataPulse", "[", 
              RowBox[{"[", 
               RowBox[{"tr", "=", "2"}], "]"}], "]"}], ",", "1"}], "]"}], 
           "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}]}]}], "}"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"ix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.6383590613628464`*^9, 3.6383591146798463`*^9}, {
  3.638444629272238*^9, 3.6384446333593674`*^9}, {3.638687016407588*^9, 
  3.6386870173806853`*^9}}],

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{"expDataPulse$DR", ",", 
   RowBox[{"Joined", "->", "True"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.638359120340846*^9, 3.638359163505846*^9}, {
  3.638686990244972*^9, 3.6386869934982977`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tEndExp", "=", "10"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$data$days", "=", 
   RowBox[{"{", 
    RowBox[{
    "0", ",", "1", ",", "2", ",", "3", ",", "4", ",", "5", ",", "6", ",", "7",
      ",", "8", ",", "9", ",", "10"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$data$initAbundance", "=", 
   RowBox[{"Table", "[", 
    RowBox[{"NinitPulse", ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "nrExp"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$conc", "=", "scaleDRPulse"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$treatments", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "1", ",", "0.9", ",", "0.8", ",", "0.7", ",", "0.6", ",", "0.5", ",", 
       "0.4", ",", "0.3", ",", "0.2", ",", "0.1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$CWs", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Interpolation", "[", 
      RowBox[{
       RowBox[{"expDataPulse$DR", "[", 
        RowBox[{"[", "#", "]"}], "]"}], ",", 
       RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}], "&"}], "/@", 
    RowBox[{"Range", "[", "nrExp", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SOT$dataPulsed$CBZ$DR", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"{", "SOT$data$days", "}"}], ",", 
     RowBox[{"{", "SOT$data$initAbundance", "}"}], ",", 
     RowBox[{"{", "SOT$conc", "}"}], ",", "SOT$treatments", ",", 
     RowBox[{"{", "SOT$CWs", "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.638359194625846*^9, 3.638359333234846*^9}, {
   3.6386870277967267`*^9, 3.638687036276575*^9}, 3.6392209115216713`*^9}],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{"$CalculateNew", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
   RowBox[{
   "ITpred$Total$N10$DR$delta$PulsedB$DT10", "=", "\[IndentingNewLine]", 
    RowBox[{"SOT$prediction$Uncertainty$Total", "[", "\[IndentingNewLine]", 
     RowBox[{
     "SOT$dataPulsed$CBZ$DR", ",", "\[IndentingNewLine]", "ITmodel", ",", 
      "\[IndentingNewLine]", 
      RowBox[{"parSetList", "=", "paramSamplesIT"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"optParSet", "=", "optParIT$CAR$AF"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"BG$mort", "=", "opt$Haz$BG$Pulse"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"repl", "=", "1"}], ",", 
      RowBox[{"tEnd", "=", "10"}], ",", 
      RowBox[{"Ninit", "=", "NinitPulse"}], ",", 
      RowBox[{"nRand", "=", "10"}], ",", 
      RowBox[{"nrTr", "=", "nrExp"}], ",", 
      RowBox[{"lcl", "=", "0.1"}], ",", 
      RowBox[{"ucl", "=", "0.9"}], ",", 
      RowBox[{"deltaT", "=", "10"}], ",", 
      RowBox[{"IXmax", "=", "IXmaxFix"}]}], "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.638359353788846*^9, 3.638359382004846*^9}, {
   3.638445292800211*^9, 3.638445306899211*^9}, {3.638588750323799*^9, 
   3.6385888059293594`*^9}, {3.638687041170064*^9, 3.6386870716391*^9}, {
   3.6386871078067164`*^9, 3.6386871087678127`*^9}, {3.638692575097971*^9, 
   3.638692576053631*^9}, 3.639220913448864*^9, {3.6424194355329943`*^9, 
   3.6424194418613567`*^9}}],

Cell[BoxData["ITpred$Total$N10$DR$delta$PulsedB$DT10"], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ITpred$Total$N10$DR$delta$PulsedB$DT10", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "63"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "63"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "63"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "63"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "63"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "63"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "63"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "63"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "63"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "63"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "63"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "63"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "63"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "61"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "60"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "59"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "57"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "54"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "49"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "43"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "36"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "28"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "21"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "15"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "10"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "6"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "4"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "2"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "1"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "1"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "48"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "48"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "48"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "49"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "48"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "47"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "48"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "47"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "48"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "46"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "48"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "49"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "47"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "48"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "46"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "42"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "46"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "40"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "40"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "35"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "34"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "25"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "24"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "15"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "10"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "8"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "3"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "75"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "76"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "75"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "74"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "74"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "75"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "74"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "75"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "76"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "75"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "76"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "75"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "77"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "75"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "76"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "75"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "74"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "74"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "74"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "73"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "73"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "71"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "70"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "66"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "61"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "56"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "46"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "39"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "34"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "28"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "25"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "19"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "14"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "14"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "11"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "10"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "8"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "8"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "6"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "6"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "4"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "4"}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.736585438820654`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.73570969021661`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.73502784618106`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.734314454369965`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.733034965012564`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.73155222128648`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.727823318929474`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.72231647824547`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.71390684044731`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.69807010952891`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.67678220948258`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.63857955481935`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.57826009158366`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.48299115243846`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.3261697949347`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.080659381785345`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "61.67590271208326`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "61.043240191320734`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "60.0458317360355`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "58.501566639005105`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "56.165696989669115`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "52.754748806342135`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "48.049938803177255`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "41.999856712516575`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "34.901134729166586`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "27.418742727972973`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "20.36222081348589`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "14.386347794629025`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "9.756719614117292`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "6.419433104608142`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "4.135441207430882`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "2.625620369598463`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "1.6519080321489599`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "1.0327252311567778`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0.6433584635167175`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0.3998115462948649`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0.24809773337776636`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0.15380479917961418`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0.09529721246050049`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0.059024991299419585`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0.03655072975171283`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0.02263056030488651`"}], "}"}]}], "}"}]}], 
      "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.648376991382887*^9, 3.6483769950852575`*^9}}],

Cell[BoxData[
 RowBox[{"fig", "=", 
  RowBox[{"ListPlot", "[", 
   RowBox[{
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"ITpred$Total$N10$DR$delta$PulsedB$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"1", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"ITpred$Total$N10$DR$delta$PulsedB$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"2", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"ITpred$Total$N10$DR$delta$PulsedB$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"3", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"ITpred$Total$N10$DR$delta$PulsedB$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"4", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "CmaxPulse"}], "]"}], ",", 
         RowBox[{"100", "*", 
          RowBox[{"SOT$treatmentsOrig", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"ix", "=", "2"}], ",", 
             RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], "}"}]}], "}"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0.9", ",", "4.8"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2.5"}], ",", "105"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"AxesOrigin", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "3"}], ",", "0"}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"Joined", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"True", ",", "True", ",", "True", ",", "True", ",", "False"}], 
      "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"GridLines", "\[Rule]", "Automatic"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"FrameTicks", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"labels", ",", "Automatic", ",", "None", ",", "Automatic"}], 
      "}"}]}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<\!\(\*SubscriptBox[\(PEC\), \(max\)]\) concentration [nmol \
\!\(\*SuperscriptBox[\(L\), \(-1\)]\)]\>\"", ",", "\"\<Survivors(%)\>\"", 
       ",", "\"\<Day 10 of pulsed exposure\>\"", ",", "\"\<\>\""}], "}"}]}], 
    ",", 
    RowBox[{"GridLinesStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Directive", "[", 
        RowBox[{"Black", ",", 
         RowBox[{"Thickness", "[", "0.001", "]"}], ",", "Dashed"}], "]"}], 
       ",", 
       RowBox[{"Directive", "[", 
        RowBox[{"Black", ",", 
         RowBox[{"Thickness", "[", "0.001", "]"}]}], "]"}]}], "}"}]}], ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"Directive", "[", "Black", "]"}]}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{"Black", ",", 
       RowBox[{"Thickness", "[", "0.002", "]"}]}], "]"}]}], ",", 
    RowBox[{"PlotMarkers", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<\>\"", ",", "\"\<\>\"", ",", "\"\<\>\"", ",", "\"\<\>\"", ",", 
       RowBox[{
        RowBox[{"MarkersScaledCol2", "[", 
         RowBox[{"Blue", ",", 
          RowBox[{"lighter", "=", "0"}], ",", 
          RowBox[{"thick", "=", "0.16"}], ",", 
          RowBox[{"filled", "=", "0"}], ",", 
          RowBox[{"size", "=", "0.05"}]}], "]"}], "[", 
        RowBox[{"[", "3", "]"}], "]"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"FontFamily", "->", "\"\<Arial\>\""}], ",", "55", ",", 
       "Bold"}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "1800"}], ",", "\[IndentingNewLine]", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.005", "]"}], ",", "Green"}], "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Orange"}], 
        "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Orange"}], 
        "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0035", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Black"}], 
        "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Blue"}], 
        "]"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"Filling", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", "2", "}"}]}], ",", 
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", "3", "}"}]}]}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"FillingStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Directive", "[", 
        RowBox[{"Orange", ",", 
         RowBox[{"Opacity", "[", "0.2", "]"}]}], "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{"Orange", ",", 
         RowBox[{"Opacity", "[", "0.2", "]"}]}], "]"}]}], "}"}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{3.6484682877609224`*^9, 3.648468331382284*^9, 
  3.648477661304246*^9, 3.6539192430226793`*^9}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\</CBZ-IT-DR-prediction-pulseB.gif\>\""}], ",", "fig"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.6386872792558055`*^9, 3.638687285271407*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
     "\"\</CBZ-SD-DR-prediction-pulseA.xlsx\>\""}], ",", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ITpred$Total$N10$DR$delta$PulsedB$DT10", "[", 
             RowBox[{"[", 
              RowBox[{"(*", "median", "*)"}], 
              RowBox[{"1", ",", "trix"}], "]"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ITpred$Total$N10$DR$delta$PulsedB$DT10", "[", 
             RowBox[{"[", 
              RowBox[{"(*", "lcl", "*)"}], 
              RowBox[{"2", ",", "trix"}], "]"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ITpred$Total$N10$DR$delta$PulsedB$DT10", "[", 
             RowBox[{"[", 
              RowBox[{"(*", "ucl", "*)"}], 
              RowBox[{"3", ",", "trix"}], "]"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"ITpred$Total$N10$DR$delta$PulsedB$DT10", "[", 
             RowBox[{"[", 
              RowBox[{"(*", "opt", "*)"}], 
              RowBox[{"4", ",", "trix"}], "]"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "CmaxPulse"}], "]"}], ",", 
         RowBox[{"NinitPulse", "*", 
          RowBox[{"SOT$treatmentsOrig", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"trix", "=", "1"}], ",", 
             RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], "}"}]}], "}"}]}], 
   "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.638588643499118*^9, 3.63858866152392*^9}, {
   3.6385935419652863`*^9, 3.6385935426293526`*^9}, {3.6385935738964787`*^9, 
   3.638593575166606*^9}, {3.638593680579146*^9, 3.638593685267615*^9}, {
   3.63868741791267*^9, 3.638687433525231*^9}, {3.638693892739031*^9, 
   3.6386938930760307`*^9}, {3.63906466175029*^9, 3.6390646668487997`*^9}, {
   3.642332472761204*^9, 3.642332484971204*^9}, 3.6423990247202044`*^9, {
   3.6423990654402037`*^9, 3.642399066080204*^9}, {3.642412185351119*^9, 
   3.6424121858811197`*^9}, {3.6424123032808676`*^9, 
   3.6424123044008694`*^9}, {3.6424194090234785`*^9, 
   3.6424194094575033`*^9}, {3.642419550943596*^9, 3.6424195626232634`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
     "\"\</CBZ-SD-DR-prediction-pulseA-relative.xlsx\>\""}], ",", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"ITpred$Total$N10$DR$delta$PulsedB$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"1", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"ITpred$Total$N10$DR$delta$PulsedB$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "lcl", "*)"}], 
               RowBox[{"2", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"ITpred$Total$N10$DR$delta$PulsedB$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "ucl", "*)"}], 
               RowBox[{"3", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"ITpred$Total$N10$DR$delta$PulsedB$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "opt", "*)"}], 
               RowBox[{"4", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "CmaxPulse"}], "]"}], ",", 
         RowBox[{"100", "*", 
          RowBox[{"SOT$treatmentsOrig", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"trix", "=", "1"}], ",", 
             RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], "}"}]}], "}"}]}], 
   "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.639376095616553*^9, 3.6393761179447856`*^9}, {
   3.642310111174238*^9, 3.642310117422863*^9}, 3.642332456350204*^9, {
   3.642399040839204*^9, 3.6423990729522038`*^9}, {3.6424123093138933`*^9, 
   3.6424123105039024`*^9}, 3.6424194136307416`*^9, {3.6424195641123486`*^9, 
   3.642419566323475*^9}}],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{"$CalculateNew", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
   RowBox[{
   "SDpred$Total$N10$DR$delta$PulsedB$DT10", "=", "\[IndentingNewLine]", 
    RowBox[{"SOT$prediction$Uncertainty$Total", "[", "\[IndentingNewLine]", 
     RowBox[{
     "SOT$dataPulsed$CBZ$DR", ",", "\[IndentingNewLine]", "SDmodel", ",", 
      "\[IndentingNewLine]", 
      RowBox[{"parSetList", "=", "paramSamplesSD"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"optParSet", "=", "optParSD$CAR$AF"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"BG$mort", "=", "opt$Haz$BG$Pulse"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"repl", "=", "1"}], ",", 
      RowBox[{"tEnd", "=", "10"}], ",", 
      RowBox[{"Ninit", "=", "NinitPulse"}], ",", 
      RowBox[{"nRand", "=", "10"}], ",", 
      RowBox[{"nrTr", "=", "nrExp"}], ",", 
      RowBox[{"lcl", "=", "0.1"}], ",", 
      RowBox[{"ucl", "=", "0.9"}], ",", 
      RowBox[{"deltaT", "=", "10"}], ",", 
      RowBox[{"IXmax", "=", "IXmaxFix"}]}], "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.638359353788846*^9, 3.638359382004846*^9}, {
   3.638445292800211*^9, 3.638445306899211*^9}, {3.638588750323799*^9, 
   3.6385888059293594`*^9}, {3.638687041170064*^9, 3.6386870716391*^9}, {
   3.6386871078067164`*^9, 3.6386871087678127`*^9}, {3.638687306923572*^9, 
   3.6386873348833675`*^9}, {3.6386925599192505`*^9, 3.638692562769255*^9}, 
   3.6392209194574647`*^9, {3.642419578237157*^9, 3.642419582715413*^9}}],

Cell[BoxData["SDpred$Total$N10$DR$delta$PulsedB$DT10"], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SDpred$Total$N10$DR$delta$PulsedB$DT10", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "63"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "61"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "61"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "60"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "59"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "58"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "57"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "56"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "54"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "51"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "49"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "45"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "41"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "36"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "31"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "25"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "19"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "14"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "9"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "5"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "2"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "1"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "48"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "46"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "47"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "46"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "46"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "47"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "46"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "45"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "43"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "42"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "41"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "37"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "36"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "32"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "28"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "24"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "19"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "13"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "9"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "7"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "2"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "75"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "75"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "75"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "75"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "74"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "75"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "74"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "74"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "74"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "72"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "75"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "71"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "73"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "70"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "70"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "72"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "65"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "61"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "55"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "44"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "39"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "35"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "28"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "21"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "13"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "9"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "4"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "3"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "2"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "1"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "1"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0"}], "}"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.73658543882064`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "62.09391241557901`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "61.911549086164406`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "61.681289070472175`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "61.38261617183807`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "61.00411617587244`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "60.524697820121894`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "59.905303844443985`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "59.12503607963867`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "58.13878125879179`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "56.893682240879045`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "55.33627287799138`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "53.39715396381869`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "51.00780011724943`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "48.09545524088278`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "44.59885955800698`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "40.47970317985979`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "35.742716398922724`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "30.46384460282964`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "24.81233873052222`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "19.065631787436374`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "13.593157317532613`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "8.803834295538941`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "5.04005715874897`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "2.4629915961239055`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0.9818875960601624`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0.3014903603978985`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0.0661966147096041`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0.009447902048415039`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0.0007726404621518046`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "0.00003132173304914172`"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "6.526484437772793`*^-6"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "2.5573054249113717`*^-9"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "4.561302256527322`*^-10"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "4.653717713259383`*^-16"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "6.346024818215527`*^-21"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "3.59207421736312`*^-27"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "3.418593944789935`*^-35"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "1.730845936753121`*^-45"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "1.0317599220075511`*^-45"}], "}"}]}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "3.7977650352075864`*^-53"}], "}"}]}], "}"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "80.`"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"10", ",", "2.5295397722546583`*^-68"}], "}"}]}], "}"}]}], 
      "}"}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.6483770188976383`*^9, 3.6483770231300616`*^9}}],

Cell[BoxData[
 RowBox[{"fig", "=", 
  RowBox[{"ListPlot", "[", 
   RowBox[{
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"SDpred$Total$N10$DR$delta$PulsedB$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"1", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"SDpred$Total$N10$DR$delta$PulsedB$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"2", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"SDpred$Total$N10$DR$delta$PulsedB$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"3", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"SDpred$Total$N10$DR$delta$PulsedB$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"4", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "CmaxPulse"}], "]"}], ",", 
         RowBox[{"100", "*", 
          RowBox[{"SOT$treatmentsOrig", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"ix", "=", "2"}], ",", 
             RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], "}"}]}], "}"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{"PlotRange", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0.9", ",", "4.8"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "2.5"}], ",", "105"}], "}"}]}], "}"}]}], ",", 
    RowBox[{"AxesOrigin", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "3"}], ",", "0"}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"Joined", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"True", ",", "True", ",", "True", ",", "True", ",", "False"}], 
      "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"PlotMarkers", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<\>\"", ",", "\"\<\>\"", ",", "\"\<\>\"", ",", "\"\<\>\"", ",", 
       RowBox[{
        RowBox[{"MarkersScaledCol2", "[", 
         RowBox[{"Blue", ",", 
          RowBox[{"lighter", "=", "0"}], ",", 
          RowBox[{"thick", "=", "0.16"}], ",", 
          RowBox[{"filled", "=", "0"}], ",", 
          RowBox[{"size", "=", "0.05"}]}], "]"}], "[", 
        RowBox[{"[", "3", "]"}], "]"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"GridLines", "\[Rule]", "Automatic"}], ",", 
    RowBox[{"Frame", "\[Rule]", "True"}], ",", 
    RowBox[{"FrameTicks", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"labels", ",", "Automatic", ",", "None", ",", "Automatic"}], 
      "}"}]}], ",", 
    RowBox[{"FrameLabel", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
      "\"\<\!\(\*SubscriptBox[\(PEC\), \(max\)]\) concentration [nmol \
\!\(\*SuperscriptBox[\(L\), \(-1\)]\)]\>\"", ",", "\"\<Survivors(%)\>\"", 
       ",", "\"\<Day 10 of pulsed exposure\>\"", ",", "\"\<\>\""}], "}"}]}], 
    ",", 
    RowBox[{"GridLinesStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Directive", "[", 
        RowBox[{"Black", ",", 
         RowBox[{"Thickness", "[", "0.001", "]"}], ",", "Dashed"}], "]"}], 
       ",", 
       RowBox[{"Directive", "[", 
        RowBox[{"Black", ",", 
         RowBox[{"Thickness", "[", "0.001", "]"}]}], "]"}]}], "}"}]}], ",", 
    RowBox[{"LabelStyle", "\[Rule]", 
     RowBox[{"Directive", "[", "Black", "]"}]}], ",", 
    RowBox[{"FrameStyle", "\[Rule]", 
     RowBox[{"Directive", "[", 
      RowBox[{"Black", ",", 
       RowBox[{"Thickness", "[", "0.002", "]"}]}], "]"}]}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"BaseStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"FontFamily", "->", "\"\<Arial\>\""}], ",", "Bold", ",", 
       "55"}], "}"}]}], ",", 
    RowBox[{"ImageSize", "\[Rule]", "1800"}], ",", "\[IndentingNewLine]", 
    RowBox[{"PlotStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.005", "]"}], ",", "Green"}], "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Orange"}], 
        "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Orange"}], 
        "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0035", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Black"}], 
        "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Thickness", "[", "0.0015", "]"}], ",", 
         RowBox[{"Dashing", "[", 
          RowBox[{"{", 
           RowBox[{"0.01", ",", "0.005"}], "}"}], "]"}], ",", "Blue"}], 
        "]"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"Filling", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", "2", "}"}]}], ",", 
       RowBox[{"1", "\[Rule]", 
        RowBox[{"{", "3", "}"}]}]}], "}"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"FillingStyle", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Directive", "[", 
        RowBox[{"Orange", ",", 
         RowBox[{"Opacity", "[", "0.2", "]"}]}], "]"}], ",", 
       RowBox[{"Directive", "[", 
        RowBox[{"Orange", ",", 
         RowBox[{"Opacity", "[", "0.2", "]"}]}], "]"}]}], "}"}]}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.648468367292875*^9, 3.648468375205666*^9}, 
   3.6484776670283823`*^9, 3.653919262985675*^9}],

Cell[BoxData[
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
    "\"\</CBZ-SD-DR-prediction-pulseB.gif\>\""}], ",", "fig"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.6386872792558055`*^9, 3.638687285271407*^9}, {
  3.63868735780766*^9, 3.638687358217701*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
     "\"\</CBZ-SD-DR-prediction-pulseA.xlsx\>\""}], ",", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"SDpred$Total$N10$DR$delta$PulsedB$DT10", "[", 
             RowBox[{"[", 
              RowBox[{"(*", "median", "*)"}], 
              RowBox[{"1", ",", "trix"}], "]"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"SDpred$Total$N10$DR$delta$PulsedB$DT10", "[", 
             RowBox[{"[", 
              RowBox[{"(*", "lcl", "*)"}], 
              RowBox[{"2", ",", "trix"}], "]"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"SDpred$Total$N10$DR$delta$PulsedB$DT10", "[", 
             RowBox[{"[", 
              RowBox[{"(*", "ucl", "*)"}], 
              RowBox[{"3", ",", "trix"}], "]"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"SDpred$Total$N10$DR$delta$PulsedB$DT10", "[", 
             RowBox[{"[", 
              RowBox[{"(*", "opt", "*)"}], 
              RowBox[{"4", ",", "trix"}], "]"}], "]"}], "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "CmaxPulse"}], "]"}], ",", 
         RowBox[{"NinitPulse", "*", 
          RowBox[{"SOT$treatmentsOrig", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"trix", "=", "1"}], ",", 
             RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], "}"}]}], "}"}]}], 
   "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.638588643499118*^9, 3.63858866152392*^9}, {
   3.6385935419652863`*^9, 3.6385935426293526`*^9}, {3.6385935738964787`*^9, 
   3.638593575166606*^9}, {3.638593680579146*^9, 3.638593685267615*^9}, {
   3.63868741791267*^9, 3.638687433525231*^9}, {3.638693892739031*^9, 
   3.6386938930760307`*^9}, {3.63906466175029*^9, 3.6390646668487997`*^9}, {
   3.642332472761204*^9, 3.642332484971204*^9}, 3.6423990247202044`*^9, {
   3.6423990654402037`*^9, 3.642399066080204*^9}, {3.642412185351119*^9, 
   3.6424121858811197`*^9}, {3.6424123032808676`*^9, 
   3.6424123044008694`*^9}, {3.6424194090234785`*^9, 
   3.6424194094575033`*^9}, {3.642419550943596*^9, 3.6424195626232634`*^9}, {
   3.642419649157213*^9, 3.642419654591524*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Export", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"NotebookDirectory", "[", "]"}], "<>", 
     "\"\</CBZ-SD-DR-prediction-pulseA-relative.xlsx\>\""}], ",", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"SDpred$Total$N10$DR$delta$PulsedB$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "median", "*)"}], 
               RowBox[{"1", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"SDpred$Total$N10$DR$delta$PulsedB$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "lcl", "*)"}], 
               RowBox[{"2", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"SDpred$Total$N10$DR$delta$PulsedB$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "ucl", "*)"}], 
               RowBox[{"3", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Transpose", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "DR$exp$data"}], "]"}], ",", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"100", "/", "NinitPulse"}], "*", 
            RowBox[{
             RowBox[{"SDpred$Total$N10$DR$delta$PulsedB$DT10", "[", 
              RowBox[{"[", 
               RowBox[{"(*", "opt", "*)"}], 
               RowBox[{"4", ",", "trix"}], "]"}], "]"}], "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"-", "1"}], ",", "2"}], "]"}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"trix", ",", "1", ",", "nrExp"}], "}"}]}], "]"}]}], "}"}],
        "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{"10", ",", "CmaxPulse"}], "]"}], ",", 
         RowBox[{"100", "*", 
          RowBox[{"SOT$treatmentsOrig", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"trix", "=", "1"}], ",", 
             RowBox[{"-", "1"}]}], "]"}], "]"}]}]}], "}"}], "}"}]}], "}"}]}], 
   "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.639376095616553*^9, 3.6393761179447856`*^9}, {
   3.642310111174238*^9, 3.642310117422863*^9}, 3.642332456350204*^9, {
   3.642399040839204*^9, 3.6423990729522038`*^9}, {3.6424123093138933`*^9, 
   3.6424123105039024`*^9}, 3.6424194136307416`*^9, {3.6424195641123486`*^9, 
   3.642419566323475*^9}, {3.6424196565126333`*^9, 3.642419658821766*^9}}],

Cell[BoxData[
 RowBox[{"NotebookSave", "[", "]"}]], "Input",
 CellChangeTimes->{{3.6485580782385736`*^9, 3.6485580841510496`*^9}}]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1664, 948},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
Magnification:>0.95 Inherited,
FrontEndVersion->"10.0 for Microsoft Windows (64-bit) (December 4, 2014)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[StyleDefinitions -> "Default.nb"]], 
   Cell[
    StyleData["Subsubsection"]]}, Visible -> False, FrontEndVersion -> 
  "10.0 for Microsoft Windows (64-bit) (December 4, 2014)", StyleDefinitions -> 
  "PrivateStylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 40, 0, 30, "Input"],
Cell[601, 22, 172, 4, 30, "Input",
 InitializationCell->True],
Cell[776, 28, 430, 8, 30, "Input",
 InitializationCell->True],
Cell[1209, 38, 160, 3, 30, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[1394, 45, 134, 1, 68, "Chapter"],
Cell[1531, 48, 692, 15, 30, "Input",
 InitializationCell->True],
Cell[2226, 65, 1067, 24, 51, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[3330, 94, 220, 3, 68, "Chapter"],
Cell[CellGroupData[{
Cell[3575, 101, 89, 1, 64, "Subchapter"],
Cell[3667, 104, 982, 18, 200, "Subsubtitle"],
Cell[4652, 124, 3482, 102, 191, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[8171, 231, 283, 5, 64, "Subchapter"],
Cell[8457, 238, 1378, 30, 111, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9884, 274, 95, 1, 93, "Title"],
Cell[CellGroupData[{
Cell[10004, 279, 180, 2, 60, "Subchapter"],
Cell[10187, 283, 68, 1, 26, "Input"],
Cell[10258, 286, 12171, 286, 641, "Input"],
Cell[22432, 574, 248, 6, 26, "Input"],
Cell[22683, 582, 458, 12, 26, "Input"],
Cell[23144, 596, 145, 3, 26, "Input"],
Cell[23292, 601, 235, 6, 26, "Input"],
Cell[23530, 609, 959, 28, 45, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[24526, 642, 116, 1, 46, "Subchapter"],
Cell[24645, 645, 2227, 52, 63, "Input"],
Cell[26875, 699, 1085, 26, 26, "Input"],
Cell[27963, 727, 467, 10, 26, "Input"],
Cell[28433, 739, 611, 12, 26, "Input"],
Cell[29047, 753, 399, 9, 26, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[29483, 767, 169, 2, 46, "Subchapter"],
Cell[29655, 771, 1918, 44, 99, "Input"],
Cell[31576, 817, 1965, 44, 99, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[33578, 866, 112, 1, 46, "Subchapter"],
Cell[33693, 869, 658, 11, 28, "Input"],
Cell[34354, 882, 8077, 227, 447, "Input"],
Cell[42434, 1111, 1323, 27, 216, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[43806, 1144, 277, 4, 93, "Title"],
Cell[CellGroupData[{
Cell[44108, 1152, 238, 3, 60, "Subchapter"],
Cell[44349, 1157, 12210, 285, 677, "Input"],
Cell[56562, 1444, 358, 10, 26, "Input"],
Cell[56923, 1456, 985, 29, 45, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[57945, 1490, 114, 1, 46, "Subchapter"],
Cell[58062, 1493, 2027, 50, 63, "Input"],
Cell[60092, 1545, 1390, 29, 63, "Input"],
Cell[61485, 1576, 518, 11, 26, "Input"],
Cell[62006, 1589, 664, 13, 26, "Input"],
Cell[62673, 1604, 420, 9, 26, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[63130, 1618, 169, 2, 46, "Subchapter"],
Cell[63302, 1622, 1994, 45, 99, "Input"],
Cell[65299, 1669, 2023, 45, 99, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[67359, 1719, 112, 1, 46, "Subchapter"],
Cell[67474, 1722, 240, 5, 28, "Input"],
Cell[67717, 1729, 712, 12, 28, "Input"],
Cell[68432, 1743, 8296, 231, 466, "Input"],
Cell[76731, 1976, 1096, 24, 162, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[77876, 2006, 131, 1, 93, "Title"],
Cell[CellGroupData[{
Cell[78032, 2011, 170, 2, 57, "Chapter"],
Cell[78205, 2015, 3009, 75, 130, "Input"],
Cell[81217, 2092, 875, 24, 67, "Input"],
Cell[82095, 2118, 622, 13, 28, "Input"],
Cell[82720, 2133, 227, 5, 48, "Input"],
Cell[82950, 2140, 4972, 103, 143, "Input"],
Cell[87925, 2245, 1280, 28, 86, "Input"],
Cell[89208, 2275, 42, 0, 28, "Input"],
Cell[89253, 2277, 2023, 60, 143, "Input"],
Cell[91279, 2339, 273, 6, 67, "Input"],
Cell[91555, 2347, 1212, 23, 86, "Input"],
Cell[92770, 2372, 1128, 23, 143, "Input"],
Cell[93901, 2397, 470, 9, 28, "Input"],
Cell[94374, 2408, 507, 11, 28, "Input"],
Cell[94884, 2421, 503, 10, 67, "Input"],
Cell[95390, 2433, 181, 4, 28, "Input"],
Cell[95574, 2439, 200, 4, 28, "Input"],
Cell[95777, 2445, 372, 7, 48, "Input"],
Cell[96152, 2454, 145, 3, 28, "Input"],
Cell[96300, 2459, 17955, 395, 599, "Input"],
Cell[114258, 2856, 634, 16, 48, "Input"],
Cell[114895, 2874, 13797, 313, 390, "Input"],
Cell[128695, 3189, 318, 8, 28, "Input"],
Cell[129016, 3199, 3016, 85, 124, "Input"],
Cell[132035, 3286, 1306, 32, 86, "Input"],
Cell[133344, 3320, 470, 9, 28, "Input"],
Cell[133817, 3331, 507, 11, 28, "Input"],
Cell[134327, 3344, 24502, 533, 637, "Input"],
Cell[158832, 3879, 1413, 39, 105, "Input"],
Cell[160248, 3920, 1040, 26, 86, "Input"],
Cell[161291, 3948, 469, 8, 28, "Input"],
Cell[161763, 3958, 317, 6, 28, "Input"],
Cell[162083, 3966, 292, 6, 28, "Input"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[162424, 3978, 240, 3, 93, "Title"],
Cell[162667, 3983, 689, 14, 28, "Input"],
Cell[163359, 3999, 1040, 23, 48, "Input"],
Cell[164402, 4024, 279, 6, 48, "Input"],
Cell[164684, 4032, 3242, 97, 181, "Input"],
Cell[CellGroupData[{
Cell[167951, 4133, 250, 3, 64, "Chapter"],
Cell[168204, 4138, 132, 3, 28, "Input"],
Cell[168339, 4143, 349, 7, 28, "Input"],
Cell[168691, 4152, 215, 5, 28, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[168943, 4162, 192, 2, 64, "Chapter"],
Cell[169138, 4166, 766, 16, 48, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[169941, 4187, 218, 4, 64, "Chapter"],
Cell[170162, 4193, 2976, 79, 181, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[173175, 4277, 278, 6, 64, "Chapter"],
Cell[173456, 4285, 38, 0, 28, "Input"],
Cell[173497, 4287, 336, 5, 28, "Input"],
Cell[173836, 4294, 675, 12, 67, "Input"],
Cell[174514, 4308, 2328, 39, 181, "Input"],
Cell[176845, 4349, 45, 0, 28, "Input"],
Cell[176893, 4351, 94, 1, 28, "Input"],
Cell[176990, 4354, 33204, 1023, 409, "Input"],
Cell[210197, 5379, 1385, 37, 30, "Input"],
Cell[211585, 5418, 8272, 217, 340, "Input"],
Cell[219860, 5637, 14184, 370, 644, "Input"],
Cell[234047, 6009, 254, 6, 28, "Input"],
Cell[234304, 6017, 7567, 203, 238, "Input"],
Cell[241874, 6222, 1499, 29, 162, "Input"],
Cell[243376, 6253, 45, 0, 28, "Input"],
Cell[243424, 6255, 33763, 1023, 466, "Input"],
Cell[277190, 7280, 8274, 217, 340, "Input"],
Cell[285467, 7499, 14186, 370, 644, "Input"],
Cell[299656, 7871, 304, 7, 28, "Input"],
Cell[299963, 7880, 7615, 203, 238, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[307615, 8088, 255, 5, 64, "Chapter"],
Cell[307873, 8095, 487, 12, 28, "Input"],
Cell[308363, 8109, 367, 7, 48, "Input"],
Cell[308733, 8118, 2602, 74, 181, "Input"],
Cell[311338, 8194, 314, 5, 28, "Input"],
Cell[311655, 8201, 135, 2, 28, "Input"],
Cell[311793, 8205, 2156, 62, 143, "Input"],
Cell[313952, 8269, 1134, 33, 28, "Input"],
Cell[315089, 8304, 301, 6, 28, "Input"],
Cell[315393, 8312, 1868, 49, 143, "Input"],
Cell[317264, 8363, 42, 0, 28, "Input"],
Cell[317309, 8365, 1483, 30, 181, "Input"],
Cell[318795, 8397, 64, 0, 28, "Input"],
Cell[318862, 8399, 33382, 1022, 447, "Input"],
Cell[352247, 9423, 8340, 217, 340, "Input"],
Cell[360590, 9642, 265, 7, 28, "Input"],
Cell[360858, 9651, 4036, 100, 124, "Input"],
Cell[364897, 9753, 4071, 104, 124, "Input"],
Cell[368971, 9859, 68, 1, 28, "Input"],
Cell[369042, 9862, 1525, 30, 181, "Input"],
Cell[370570, 9894, 64, 0, 28, "Input"],
Cell[370637, 9896, 33237, 1023, 428, "Input"],
Cell[403877, 10921, 8344, 217, 340, "Input"],
Cell[412224, 11140, 265, 7, 28, "Input"],
Cell[412492, 11149, 4093, 101, 124, "Input"],
Cell[416588, 11252, 4054, 104, 124, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[420679, 11361, 171, 2, 64, "Chapter"],
Cell[420853, 11365, 118, 2, 28, "Input"],
Cell[420974, 11369, 2152, 62, 143, "Input"],
Cell[423129, 11433, 381, 10, 28, "Input"],
Cell[423513, 11445, 171, 3, 28, "Input"],
Cell[423687, 11450, 1208, 34, 28, "Input"],
Cell[424898, 11486, 298, 6, 28, "Input"],
Cell[425199, 11494, 1818, 48, 143, "Input"],
Cell[427020, 11544, 1475, 30, 181, "Input"],
Cell[428498, 11576, 64, 0, 28, "Input"],
Cell[428565, 11578, 33385, 1022, 447, "Input"],
Cell[461953, 12602, 8218, 213, 321, "Input"],
Cell[470174, 12817, 265, 7, 28, "Input"],
Cell[470442, 12826, 4145, 102, 124, "Input"],
Cell[474590, 12930, 4106, 105, 124, "Input"],
Cell[478699, 13037, 1523, 30, 181, "Input"],
Cell[480225, 13069, 64, 0, 28, "Input"],
Cell[480292, 13071, 33429, 1024, 447, "Input"],
Cell[513724, 14097, 8247, 214, 321, "Input"],
Cell[521974, 14313, 313, 8, 28, "Input"],
Cell[522290, 14323, 4195, 103, 124, "Input"],
Cell[526488, 14428, 4154, 105, 124, "Input"],
Cell[530645, 14535, 130, 2, 28, "Input"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
